﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cosmos.KPS
{
    /// <summary>
    /// Kitchen Device Status
    /// </summary>
    public class KTCH_SYS_STATUS
    {
        public string sSubShopCd;
        public string sKtchSysCd;
        public int nErrorCd;
    }

    public class KPSItem
    {
        /// <summary>
        /// 연습모드구분  0:일반, 1:연습모드 
        /// </summary>
        public string sTrainMode; 

        public string sOrderType;
        public string sFloorCd;
        public string sTableNo;
        public string sSubShopCd;                                                                                       // Add, 2017.02.06 
        public string sKtchSysCd;
        public int nSeq;
        public string sOrderNo;
        public string sPosType;
        public string sItemCd;
        public string sItemNm;
        /// <summary>
        /// 상품구분(0:일반, 1:세트, 2:세트자식, 3:부가상품, 4:세트할인, 5:상품권(추가))
        /// </summary>
        public string sItemDiv;
        public int nQty;
        public string sPackDiv;
        public string sSetMenuCd;
        public string sOrdTime;
        public string sCancelDiv;
        /// <summary>
        /// 0:정상 1:재전송
        /// </summary>
        public string sResendYn;
        public string sKtchSysUseDiv;
        public int nKpsComPort;
        public int nKpsComBaudrate;
        public string sKpsOposName;
        public string sKpsIp;
        public string sKpsPort;

        /// <summary>
        /// 0:미전송 1:전송 
        /// 7:영수증프린터출력(주방프린터와 영수증프린터가 동일장치)
        /// 8:영수증프린터출력(주방출력오류)
        /// </summary>
        public string sSendYn;
        /// <summary>
        /// 0000 : 정상
        /// 
        /// </summary>
        public string sErrorCd;

        //public string sKpsCdBackup1;
        //public string sKpsCdBackup2;
        //public string sKpsCdBackup3;
        //public string sKpsCdBackup4;
        //public string sKpsCdBackup5;
        //public string sKpsCdBackup6;

        /// <summary>
        /// 반복출력 횟수 
        /// </summary>
        public string sFiller1;
        /// <summary>
        /// 기타주문구분 
        /// 1:후불일반판매, 2:해피오더
        /// </summary>
        public string sFiller2;
        /// <summary>
        /// 추가주문구분 (NEW,ADD,DEL)
        /// </summary>
        public string sFiller3;
        /// <summary>
        /// 부가메뉴구분 (SUBPRC_MENU_KEY_DIV)
        /// 
        /// </summary>
        public string sFiller4;
        public string sFiller5;

        /// <summary>
        /// 수동출력일때 주방메모 
        /// </summary>
        public string sKtchMemo = string.Empty;
        /// <summary>
        /// 상품메모 
        /// </summary>
        public string sItemMemo = string.Empty;
        /// <summary>
        /// 주문담당자
        /// </summary>
        public string sOrdPicNm = string.Empty;
        /// <summary>
        /// 장치명
        /// </summary>
        public string sKtchSysNm = string.Empty;                                                                        // Add, 2017.04.07
        /// <summary>
        /// 최종주문POS
        /// </summary>
        public string sOrdPosNo = string.Empty;                                                                         // Add, 2017.04.10
        // 2017.09.06 레시피 추가
        /// <summary>
        /// 레시피
        /// </summary>
        public string sRecipe= string.Empty;

        //#20180515 KPS 출력시 라벨프린터 출력 start
        /// <summary>
        /// 라벨프린터 출력여부(0:미전송, 1:전송)
        /// </summary>
        public string sLblSendYn = string.Empty;

        /// <summary>
        /// 라벨프린터 총출력 해야 할 건수
        /// </summary>
        public int iTOTCNT = 0;

        /// <summary>
        /// 라벨프린터 QRCODE URL
        /// </summary>
        public string sQrcodeUrl = "";

        /// <summary>
        /// 라벨프린터 QRCODE MSG
        /// </summary>
        public string sQrcodeMsg = "";

        /// <summary>
        /// 라벨프린터 TOP MSG
        /// </summary>
        public string sTopMsg = "";

        /// <summary>
        /// 라벨프린터 BTM MSG
        /// </summary>
        public string sBtmMsg = "";
        //#20180515 KPS 출력시 라벨프린터 출력 end

    }

    /// <summary>
    /// Table Master
    /// </summary>
    public class TableMaster
    {
        public string sFloorCd;
        public string sTableNo;
        public string sTableNm;
        public string sTableDispDiv;
    }

    //public class TABLE_DISP_FLAG
    //{
    //    public const string TABLE_NO = "0";         // 테이블 번호
    //    public const string TABLE_NAME = "1";       // 테이블 이름
    //    public const string TABLE_NO_NAME = "2";    // 테이블 번호 + 이름
    //}

    public class KPSOrderMessage
    {
        /// <summary>
        /// 연습모드구분  0:일반, 1:연습모드 
        /// </summary>
        public string sTrainMode;                                                                                       // Add, 2017.03.03

        public string sOrderType;
        public string sFloorCd;
        public string sTableNo;
        public int    nSeq;
        public string sSubShopCd;                                                                                       // Add, 2017.02.06 
        public string sKtchSysCd;
        public string sItemCd;
        public string sItemNm;
        public string sMsgId;
        public string sMsg1;
        public string sMsg2;
        public string sMsg3;
        public string sMsgRegTime;
        public string sKtchSysUseDiv;
        public int    nKpsComPort;
        public int    nKpsComBaudrate;
        public string sKpsOposName;
        public string sKpsIp;
        public string sKpsPort;
        public string sSendYn;
        public string sResendYn;
        public string sErrorCd;
        public int printCount = 1; 

        //public string sKpsCdBackup1;
        //public string sKpsCdBackup2;
        //public string sKpsCdBackup3;
        //public string sKpsCdBackup4;
        //public string sKpsCdBackup5;
        //public string sKpsCdBackup6;

        public string sRegDate;
        /// <summary>
        /// 장치명 
        /// </summary>
        public string sKtchSysNm = string.Empty;                                                                        // Add, 2017.04.07
        /// <summary>
        /// 마지막주문POS
        /// </summary>
        public string sOrdPosNo = string.Empty;                                                                         // Add, 2017.04.10 
    }

    public class OPOS
    {
        public const int CASH_SUE_DRAWERCLOSED = 0;
        public const int CASH_SUE_DRAWEROPEN = 1;
        public const int CHAN_STATUS_ASYNC = 91;
        public const int CHAN_STATUS_EMPTY = 11;
        public const int CHAN_STATUS_EMPTYOK = 13;
        public const int CHAN_STATUS_FULL = 21;
        public const int CHAN_STATUS_FULLOK = 23;
        public const int CHAN_STATUS_JAM = 31;
        public const int CHAN_STATUS_JAMOK = 32;
        public const int CHAN_STATUS_NEAREMPTY = 12;
        public const int CHAN_STATUS_NEARFULL = 22;
        public const int CHAN_STATUS_OK = 0;
        public const int COIN_STATUS_EMPTY = 2;
        public const int COIN_STATUS_JAM = 4;
        public const int COIN_STATUS_NEAREMPTY = 3;
        public const int COIN_STATUS_OK = 1;
        public const int DISP_CB_BLINKALL = 1;
        public const int DISP_CB_BLINKEACH = 2;
        public const int DISP_CB_NOBLINK = 0;
        public const int DISP_CCS_ALPHA = 1;
        public const int DISP_CCS_ASCII = 998;
        public const int DISP_CCS_KANA = 10;
        public const int DISP_CCS_KANJI = 11;
        public const int DISP_CCS_NUMERIC = 0;
        public const int DISP_CS_ASCII = 998;
        public const int DISP_CS_WINDOWS = 999;
        public const int DISP_DT_BLINK = 1;
        public const int DISP_DT_NORMAL = 0;
        public const int DISP_MF_PLACE = 1;
        public const int DISP_MF_WALK = 0;
        public const int DISP_MT_DOWN = 2;
        public const int DISP_MT_INIT = 5;
        public const int DISP_MT_LEFT = 3;
        public const int DISP_MT_NONE = 0;
        public const int DISP_MT_RIGHT = 4;
        public const int DISP_MT_UP = 1;
        public const int DISP_SD_BLINK = 2;
        public const int DISP_SD_OFF = 0;
        public const int DISP_SD_ON = 1;
        public const int DISP_ST_DOWN = 2;
        public const int DISP_ST_LEFT = 3;
        public const int DISP_ST_RIGHT = 4;
        public const int DISP_ST_UP = 1;
        public const int FPTR_AT_AMOUNT_DISCOUNT = 1;
        public const int FPTR_AT_AMOUNT_SURCHARGE = 2;
        public const int FPTR_AT_PERCENTAGE_DISCOUNT = 3;
        public const int FPTR_AT_PERCENTAGE_SURCHARGE = 4;
        public const int FPTR_CC_BRAZIL = 1;
        public const int FPTR_CC_GREECE = 2;
        public const int FPTR_CC_HUNGARY = 3;
        public const int FPTR_CC_ITALY = 4;
        public const int FPTR_CC_POLAND = 5;
        public const int FPTR_CC_TURKEY = 6;
        public const int FPTR_EL_BLOCKED = 4;
        public const int FPTR_EL_FATAL = 3;
        public const int FPTR_EL_NONE = 1;
        public const int FPTR_EL_RECOVERABLE = 2;
        public const int FPTR_GD_CURRENT_TOTAL = 1;
        public const int FPTR_GD_DAILY_TOTAL = 2;
        public const int FPTR_GD_FIRMWARE = 10;
        public const int FPTR_GD_GRAND_TOTAL = 8;
        public const int FPTR_GD_MID_VOID = 6;
        public const int FPTR_GD_NOT_PAID = 5;
        public const int FPTR_GD_PRINTER_ID = 9;
        public const int FPTR_GD_RECEIPT_NUMBER = 3;
        public const int FPTR_GD_REFUND = 4;
        public const int FPTR_GD_RESTART = 11;
        public const int FPTR_GD_Z_REPORT = 7;
        public const int FPTR_PS_FISCAL_DOCUMENT = 5;
        public const int FPTR_PS_FISCAL_RECEIPT = 2;
        public const int FPTR_PS_FISCAL_RECEIPT_ENDING = 4;
        public const int FPTR_PS_FISCAL_RECEIPT_TOTAL = 3;
        public const int FPTR_PS_FIXED_OUTPUT = 6;
        public const int FPTR_PS_ITEM_LIST = 7;
        public const int FPTR_PS_LOCKED = 8;
        public const int FPTR_PS_MONITOR = 1;
        public const int FPTR_PS_NONFISCAL = 9;
        public const int FPTR_PS_REPORT = 10;
        public const int FPTR_RT_DATE = 2;
        public const int FPTR_RT_ORDINAL = 1;
        public const int FPTR_S_JOURNAL = 1;
        public const int FPTR_S_RECEIPT = 2;
        public const int FPTR_S_SLIP = 4;
        public const int FPTR_SS_FULL_LENGTH = 1;
        public const int FPTR_SS_VALIDATION = 2;
        public const int FPTR_SUE_COVER_OK = 12;
        public const int FPTR_SUE_COVER_OPEN = 11;
        public const int FPTR_SUE_IDLE = 1001;
        public const int FPTR_SUE_JRN_EMPTY = 21;
        public const int FPTR_SUE_JRN_NEAREMPTY = 22;
        public const int FPTR_SUE_JRN_PAPEROK = 23;
        public const int FPTR_SUE_REC_EMPTY = 24;
        public const int FPTR_SUE_REC_NEAREMPTY = 25;
        public const int FPTR_SUE_REC_PAPEROK = 26;
        public const int FPTR_SUE_SLP_EMPTY = 27;
        public const int FPTR_SUE_SLP_NEAREMPTY = 28;
        public const int FPTR_SUE_SLP_PAPEROK = 29;
        public const int KBD_ET_DOWN = 1;
        public const int KBD_ET_DOWN_UP = 2;
        public const int KBD_KET_KEYDOWN = 1;
        public const int KBD_KET_KEYUP = 2;
        public const int LOCK_KP_ANY = 0;
        public const int LOCK_KP_LOCK = 1;
        public const int LOCK_KP_NORM = 2;
        public const int LOCK_KP_SUPR = 3;
        public const int MICR_CC_CANADA = 2;
        public const int MICR_CC_MEXICO = 3;
        public const int MICR_CC_UNKNOWN = 99;
        public const int MICR_CC_USA = 1;
        public const int MICR_CT_BUSINESS = 2;
        public const int MICR_CT_PERSONAL = 1;
        public const int MICR_CT_UNKNOWN = 99;
        public const int MSR_ERT_CARD = 0;
        public const int MSR_ERT_TRACK = 1;
        public const int MSR_TR_1 = 1;
        public const int MSR_TR_2 = 2;
        public const int MSR_TR_3 = 4;
        public const int OPOS_BC_DECIMAL = 2;
        public const int OPOS_BC_NIBBLE = 1;
        public const int OPOS_BC_NONE = 0;
        public const int OPOS_CH_EXTERNAL = 2;
        public const int OPOS_CH_INTERACTIVE = 3;
        public const int OPOS_CH_INTERNAL = 1;
        public const int OPOS_E_BUSY = 113;
        public const int OPOS_E_CLAIMED = 102;
        public const int OPOS_E_CLOSED = 101;
        public const int OPOS_E_DISABLED = 105;
        public const int OPOS_E_EXISTS = 110;
        public const int OPOS_E_EXTENDED = 114;
        public const int OPOS_E_FAILURE = 111;
        public const int OPOS_E_ILLEGAL = 106;
        public const int OPOS_E_NOEXIST = 109;
        public const int OPOS_E_NOHARDWARE = 107;
        public const int OPOS_E_NOSERVICE = 104;
        public const int OPOS_E_NOTCLAIMED = 103;
        public const int OPOS_E_OFFLINE = 108;
        public const int OPOS_E_TIMEOUT = 112;
        public const int OPOS_ECHAN_OVERDISPENSE = 201;
        public const int OPOS_EFPTR_BAD_DATE = 219;
        public const int OPOS_EFPTR_BAD_ITEM_AMOUNT = 214;
        public const int OPOS_EFPTR_BAD_ITEM_DESCRIPTION = 215;
        public const int OPOS_EFPTR_BAD_ITEM_QUANTITY = 213;
        public const int OPOS_EFPTR_BAD_PRICE = 218;
        public const int OPOS_EFPTR_BAD_VAT = 217;
        public const int OPOS_EFPTR_CLOCK_ERROR = 209;
        public const int OPOS_EFPTR_COVER_OPEN = 201;
        public const int OPOS_EFPTR_FISCAL_MEMORY_DISCONNECTED = 211;
        public const int OPOS_EFPTR_FISCAL_MEMORY_FULL = 210;
        public const int OPOS_EFPTR_FISCAL_TOTALS_ERROR = 212;
        public const int OPOS_EFPTR_JRN_EMPTY = 202;
        public const int OPOS_EFPTR_MISSING_DEVICES = 206;
        public const int OPOS_EFPTR_NEGATIVE_TOTAL = 220;
        public const int OPOS_EFPTR_REC_EMPTY = 203;
        public const int OPOS_EFPTR_RECEIPT_TOTAL_OVERFLOW = 216;
        public const int OPOS_EFPTR_SLP_EMPTY = 204;
        public const int OPOS_EFPTR_SLP_FORM = 205;
        public const int OPOS_EFPTR_TECHNICAL_ASSISTANCE = 208;
        public const int OPOS_EFPTR_WORD_NOT_ALLOWED = 221;
        public const int OPOS_EFPTR_WRONG_STATE = 207;
        public const int OPOS_EL_INPUT = 2;
        public const int OPOS_EL_INPUT_DATA = 3;
        public const int OPOS_EL_OUTPUT = 1;
        public const int OPOS_EMICR_CHECK = 202;
        public const int OPOS_EMICR_NOCHECK = 201;
        public const int OPOS_EMSR_END = 202;
        public const int OPOS_EMSR_LRC = 204;
        public const int OPOS_EMSR_PARITY = 203;
        public const int OPOS_EMSR_START = 201;
        public const int OPOS_EPTR_BADFORMAT = 207;
        public const int OPOS_EPTR_COVER_OPEN = 201;
        public const int OPOS_EPTR_JRN_EMPTY = 202;
        public const int OPOS_EPTR_REC_EMPTY = 203;
        public const int OPOS_EPTR_SLP_EMPTY = 204;
        public const int OPOS_EPTR_SLP_FORM = 205;
        public const int OPOS_EPTR_TOOBIG = 206;
        public const int OPOS_ER_CLEAR = 12;
        public const int OPOS_ER_CONTINUEINPUT = 13;
        public const int OPOS_ER_RETRY = 11;
        public const int OPOS_EROD_BADCLK = 201;
        public const int OPOS_EROD_NOBUFFERS = 204;
        public const int OPOS_EROD_NOCLOCKS = 202;
        public const int OPOS_EROD_NOREGION = 203;
        public const int OPOS_EROD_NOROOM = 205;
        public const int OPOS_ESCAL_OVERWEIGHT = 201;
        public const int OPOS_ETOT_NOROOM = 201;
        public const int OPOS_ETOT_VALIDATION = 202;
        public const int OPOS_FOREVER = -1;
        public const int OPOS_PN_DISABLED = 0;
        public const int OPOS_PN_ENABLED = 1;
        public const int OPOS_PR_ADVANCED = 2;
        public const int OPOS_PR_NONE = 0;
        public const int OPOS_PR_STANDARD = 1;
        public const int OPOS_PS_OFF = 2002;
        public const int OPOS_PS_OFF_OFFLINE = 2004;
        public const int OPOS_PS_OFFLINE = 2003;
        public const int OPOS_PS_ONLINE = 2001;
        public const int OPOS_PS_UNKNOWN = 2000;
        public const int OPOS_S_BUSY = 3;
        public const int OPOS_S_CLOSED = 1;
        public const int OPOS_S_ERROR = 4;
        public const int OPOS_S_IDLE = 2;
        public const int OPOS_SUCCESS = 0;
        public const int OPOS_SUE_POWER_OFF = 2002;
        public const int OPOS_SUE_POWER_OFF_OFFLINE = 2004;
        public const int OPOS_SUE_POWER_OFFLINE = 2003;
        public const int OPOS_SUE_POWER_ONLINE = 2001;
        public const int OPOSERR = 100;
        public const int OPOSERREXT = 200;
        public const int PPAD_CANCEL = 2;
        public const int PPAD_DISP_PINRESTRICTED = 2;
        public const int PPAD_DISP_RESTRICTEDLIST = 3;
        public const int PPAD_DISP_RESTRICTEDORDER = 4;
        public const int PPAD_DISP_UNRESTRICTED = 1;
        public const int PPAD_EFT_ABNORMAL = 2;
        public const int PPAD_EFT_NORMAL = 1;
        public const int PPAD_LANG_NONE = 1;
        public const int PPAD_LANG_ONE = 2;
        public const int PPAD_LANG_PINRESTRICTED = 3;
        public const int PPAD_LANG_UNRESTRICTED = 4;
        public const int PPAD_MSG_AMOUNTOK = 8;
        public const int PPAD_MSG_APPROVED = 5;
        public const int PPAD_MSG_CANCELED = 7;
        public const int PPAD_MSG_DECLINED = 6;
        public const int PPAD_MSG_ENTERPIN = 1;
        public const int PPAD_MSG_ENTERVALIDPIN = 3;
        public const int PPAD_MSG_IDLE = 10;
        public const int PPAD_MSG_INSERTCARD = 12;
        public const int PPAD_MSG_NOTREADY = 9;
        public const int PPAD_MSG_PLEASEWAIT = 2;
        public const int PPAD_MSG_RETRIESEXCEEDED = 4;
        public const int PPAD_MSG_SELECTCARDTYPE = 13;
        public const int PPAD_MSG_SLIDE_CARD = 11;
        public const int PPAD_SUCCESS = 1;
        public const int PPAD_TRANS_ADMIN = 5;
        public const int PPAD_TRANS_CREDIT = 2;
        public const int PPAD_TRANS_DEBIT = 1;
        public const int PPAD_TRANS_INQ = 3;
        public const int PPAD_TRANS_RECONCILE = 4;
        public const int PTR_BC_CENTER = -2;
        public const int PTR_BC_LEFT = -1;
        public const int PTR_BC_RIGHT = -3;
        public const int PTR_BC_TEXT_ABOVE = -12;
        public const int PTR_BC_TEXT_BELOW = -13;
        public const int PTR_BC_TEXT_NONE = -11;
        public const int PTR_BCS_Codabar = 107;
        public const int PTR_BCS_Code128 = 110;
        public const int PTR_BCS_Code39 = 108;
        public const int PTR_BCS_Code93 = 109;
        public const int PTR_BCS_EAN128 = 120;
        public const int PTR_BCS_EAN13 = 104;
        public const int PTR_BCS_EAN13_S = 119;
        public const int PTR_BCS_EAN8 = 103;
        public const int PTR_BCS_EAN8_S = 118;
        public const int PTR_BCS_ITF = 106;
        public const int PTR_BCS_JAN13 = 104;
        public const int PTR_BCS_JAN8 = 103;
        public const int PTR_BCS_MAXICODE = 202;
        public const int PTR_BCS_OCRA = 121;
        public const int PTR_BCS_OCRB = 122;
        public const int PTR_BCS_OTHER = 501;
        public const int PTR_BCS_PDF417 = 201;
        public const int PTR_BCS_TF = 105;
        public const int PTR_BCS_UPCA = 101;
        public const int PTR_BCS_UPCA_S = 111;
        public const int PTR_BCS_UPCD1 = 113;
        public const int PTR_BCS_UPCD2 = 114;
        public const int PTR_BCS_UPCD3 = 115;
        public const int PTR_BCS_UPCD4 = 116;
        public const int PTR_BCS_UPCD5 = 117;
        public const int PTR_BCS_UPCE = 102;
        public const int PTR_BCS_UPCE_S = 112;
        public const int PTR_BM_ASIS = -11;
        public const int PTR_BM_CENTER = -2;
        public const int PTR_BM_LEFT = -1;
        public const int PTR_BM_RIGHT = -3;
        public const int PTR_CCS_ALPHA = 1;
        public const int PTR_CCS_ASCII = 998;
        public const int PTR_CCS_KANA = 10;
        public const int PTR_CCS_KANJI = 11;
        public const int PTR_CP_FULLCUT = 100;
        public const int PTR_CS_ASCII = 998;
        public const int PTR_CS_WINDOWS = 999;
        public const int PTR_EL_FATAL = 3;
        public const int PTR_EL_NONE = 1;
        public const int PTR_EL_RECOVERABLE = 2;
        public const int PTR_L_BOTTOM = 2;
        public const int PTR_L_TOP = 1;
        public const int PTR_MM_DOTS = 1;
        public const int PTR_MM_ENGLISH = 3;
        public const int PTR_MM_METRIC = 4;
        public const int PTR_MM_TWIPS = 2;
        public const char PTR_RP_LEFT90 = 'f';
        public const char PTR_RP_NORMAL = '';
        public const char PTR_RP_RIGHT90 = 'e';
        public const char PTR_RP_ROTATE180 = 'g';
        public const int PTR_S_JOURNAL = 1;
        public const int PTR_S_RECEIPT = 2;
        public const int PTR_S_SLIP = 4;
        public const int PTR_SUE_COVER_OK = 12;
        public const int PTR_SUE_COVER_OPEN = 11;
        public const int PTR_SUE_IDLE = 1001;
        public const int PTR_SUE_JRN_EMPTY = 21;
        public const int PTR_SUE_JRN_NEAREMPTY = 22;
        public const int PTR_SUE_JRN_PAPEROK = 23;
        public const int PTR_SUE_REC_EMPTY = 24;
        public const int PTR_SUE_REC_NEAREMPTY = 25;
        public const int PTR_SUE_REC_PAPEROK = 26;
        public const int PTR_SUE_SLP_EMPTY = 27;
        public const int PTR_SUE_SLP_NEAREMPTY = 28;
        public const int PTR_SUE_SLP_PAPEROK = 29;
        public const int PTR_TP_NORMAL = 12;
        public const int PTR_TP_TRANSACTION = 11;
        public const int ROD_BDR_DOUBLE = 2;
        public const int ROD_BDR_SINGLE = 1;
        public const int ROD_BDR_SOLID = 3;
        public const int ROD_CLK_MOVE = 4;
        public const int ROD_CLK_PAUSE = 2;
        public const int ROD_CLK_RESUME = 3;
        public const int ROD_CLK_START = 1;
        public const int ROD_CLK_STOP = 5;
        public const int ROD_CRS_BLOCK = 3;
        public const int ROD_CRS_BLOCK_BLINK = 4;
        public const int ROD_CRS_LINE = 1;
        public const int ROD_CRS_LINE_BLINK = 2;
        public const int ROD_CRS_OFF = 5;
        public const int ROD_CS_ASCII = 998;
        public const int ROD_CS_WINDOWS = 999;
        public const char ROD_DE_TOUCH_DOWN = '';
        public const char ROD_DE_TOUCH_MOVE = '';
        public const char ROD_DE_TOUCH_UP = '';
        public const int ROD_TD_NORMAL = 12;
        public const int ROD_TD_TRANSACTION = 11;
        public const int ROD_UA_BLINK_OFF = 7;
        public const int ROD_UA_BLINK_ON = 6;
        public const int ROD_UA_INTENSITY_OFF = 3;
        public const int ROD_UA_INTENSITY_ON = 2;
        public const int ROD_UA_REVERSE_OFF = 5;
        public const int ROD_UA_REVERSE_ON = 4;
        public const int ROD_UA_SET = 1;
        public const int SCAL_WU_GRAM = 1;
        public const int SCAL_WU_KILOGRAM = 2;
        public const int SCAL_WU_OUNCE = 3;
        public const int SCAL_WU_POUND = 4;
        public const int SCAN_SDT_Codabar = 107;
        public const int SCAN_SDT_Code128 = 110;
        public const int SCAN_SDT_Code39 = 108;
        public const int SCAN_SDT_Code93 = 109;
        public const int SCAN_SDT_EAN128 = 120;
        public const int SCAN_SDT_EAN13 = 104;
        public const int SCAN_SDT_EAN13_S = 119;
        public const int SCAN_SDT_EAN8 = 103;
        public const int SCAN_SDT_EAN8_S = 118;
        public const int SCAN_SDT_ITF = 106;
        public const int SCAN_SDT_JAN13 = 104;
        public const int SCAN_SDT_JAN8 = 103;
        public const int SCAN_SDT_MAXICODE = 202;
        public const int SCAN_SDT_OCRA = 121;
        public const int SCAN_SDT_OCRB = 122;
        public const int SCAN_SDT_OTHER = 501;
        public const int SCAN_SDT_PDF417 = 201;
        public const int SCAN_SDT_TF = 105;
        public const int SCAN_SDT_UNKNOWN = 0;
        public const int SCAN_SDT_UPCA = 101;
        public const int SCAN_SDT_UPCA_S = 111;
        public const int SCAN_SDT_UPCD1 = 113;
        public const int SCAN_SDT_UPCD2 = 114;
        public const int SCAN_SDT_UPCD3 = 115;
        public const int SCAN_SDT_UPCD4 = 116;
        public const int SCAN_SDT_UPCD5 = 117;
        public const int SCAN_SDT_UPCE = 102;
        public const int SCAN_SDT_UPCE_S = 112;
    }
}
