﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Cosmos.Common; 
using Cosmos.UserFrame;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 아워홈
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.OLEDevice
{
    public class DeviceOurHome : IOurHome
    {
        #region 변수 선언
        /// <summary>
        /// StateServer Object (StateServer 객체)
        /// </summary>
        public StateServer StateObject = (StateServer)StateServer.GetInstance();

        /// <summary>
        /// 아워홈 OCX form 객체
        /// </summary>
        frmDeviceOurHome frmOurHome = null;
        #endregion 

        #region 생성자
        /// <summary>
        /// 생성자
        /// </summary>
        public DeviceOurHome()
        {
            try
            {
                frmOurHome = new frmDeviceOurHome();
            }
            catch(Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }
        #endregion 

        #region 고객정보 조회
        /// <summary>
        /// 고객정보 조회
        /// </summary>
        /// <param name="sStoreCD"></param>
        /// <param name="sRFNo"></param>
        /// <param name="sRFType"></param>
        /// <returns></returns>
        public string Rf_EmpInfo(string sStoreCD, string sRFNo, string sRFType)
        {
            string sResult = "9^Not Connect DataBase!!!"; 
            try
            {
                sResult = frmOurHome.Rf_EmpInfo(sStoreCD, sRFNo, sRFType);
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
            return sResult;
        }
        #endregion

        #region 결제
        /// <summary>
        /// 결제
        /// </summary>
        /// <param name="sStoreCD"></param>
        /// <param name="sTranData"></param>
        /// <param name="sRfType"></param>
        /// <returns></returns>
        public string Rf_TransData(string sStoreCD, string sTranData, string sRfType)
        {
            string sResult = "9^Not Connect DataBase!!!";
            try
            {
                sResult = frmOurHome.Rf_TransData(sStoreCD, sTranData, sRfType);
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
            return sResult;
        }
        #endregion
    }
}
