﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace SPC.Kiosk.PB.Model
{
    /// <summary>
    /// PB Sensing Sub Page
    /// </summary>
    public enum PBSensingSubPageType
    {
        /// <summary>
        /// Sensing Page
        /// </summary>
        SensingPage,
        /// <summary>
        /// Sensing Sub Page
        /// </summary>
        BarcordPage,
    }
    /// <summary>
    /// PB Page Types
    /// </summary>
    public enum PBPageType
    {
        /// <summary>
        /// Intro
        /// </summary>
        Intro,
        /// <summary>
        /// 객체인식,일반주문 선택화면
        /// </summary>
        FirstSelect,
        /// <summary>
        /// 객체인식
        /// </summary>
        Sensing,
        /// <summary>
        /// 일반주문
        /// </summary>
        Items
    }
    public enum SensingPageType
    {
        /// <summary>
        /// 카메라 스캔 안내 페이지
        /// </summary>
        Infomation,
        /// <summary>
        /// 카메라 스캔중 및 종료후 표시 페이지
        /// </summary>
        SensingMain,
        /// <summary>
        /// 바코드 리딩으로 제품 추가 하는 페이지
        /// </summary>
        BarcodeRead
    }
    /// <summary>
    /// PB Payments Page Type
    /// </summary>
    public enum PBPaymentPageType
    {
        /// <summary>
        /// Parking Page
        /// </summary>
        None,
        /// <summary>
        /// 주문 내역 상세
        /// </summary>
        DetailBasket,
        //PaymentsSelect,
        /// <summary>
        /// 포인트 적립/통신사 할인
        /// </summary>
        PointsDisCounts,
        /// <summary>
        /// 포인트 사용/ 쿠폰 사용
        /// </summary>
        CouponUsePoints,
        /// <summary>
        /// 포인트 사용 더보기
        /// </summary>
        MoreVIewPoints,
        /// <summary>
        /// 포인트 사용 더보기 뒤로가기
        /// </summary>
        MoreVIewReturnPoints,
        /// <summary>
        /// 최종 결제
        /// </summary>
        PaymentExcute,
    }
    /// <summary>
    /// Payment Discount And And Add Type
    /// </summary>
    public enum PaymentsDiscountAndAddType
    {
        /// <summary>
        /// None
        /// </summary>
        None,
        /// <summary>
        /// 사은품
        /// </summary>
        BonusGift,
        /// <summary>
        /// SK 할인
        /// </summary>
        SkTelecomDiscount,
        /// <summary>
        /// KT 할인
        /// </summary>
        AllehKTDiscount,
        /// <summary>
        /// LGU+ 할인
        /// </summary>
        LGUPlusDisCount,
        /// <summary>
        /// Happy Point
        /// </summary>
        HappyPoint,
        /// <summary>
        /// Ok Cash Bag Point
        /// </summary>
        OkCashBagPoint,
        /// <summary>
        /// Happy Coupon
        /// </summary>
        HappyCoupon,
        /// <summary>
        /// Mobile Coupon
        /// </summary>
        MobileCoupon,
        /// <summary>
        /// Lasy Payment
        /// </summary>
        LastPayment
    }
}