﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using SPC.Kiosk.Common;

namespace SPC.Kiosk.Popup.Model
{
    /// <summary>
    /// Mini Popup Model
    /// </summary>
    public class M_MiniPopup
    {
        /// <summary>
        /// Icon Type
        /// </summary>
        public MiniPopupIcon Icon { get; set; } = MiniPopupIcon.None;
        /// <summary>
        /// Display Language
        /// </summary>
        public SupportLanguageType DisplayLanguage { get; set; } = SupportLanguageType.ko;
        /// <summary>
        /// Main Message
        /// </summary>
        public List<M_Language> Message { get; set; }
        /// <summary>
        /// Sub Message
        /// </summary>
        public List<M_Language> SubMessage { get; set; }
        /// <summary>
        /// Cencal Button Text
        /// </summary>
        public List<M_Language> CencalButtonText { get; set; }
        /// <summary>
        /// Ok Button Text
        /// </summary>
        public List<M_Language> OkButtonText { get; set; }
        /// <summary>
        /// Is Show Cencal Button
        /// </summary>
        public bool IsCencalButton { get; set; } = true;
        /// <summary>
        /// Is Show Timeout Popup 
        /// </summary>
        public bool IsTimeoutPopup { get; set; } = false;
        /// <summary>
        /// Timeout Seconds
        /// </summary>
        public double TimeoutSeconds { get; set; } = 10d;


    }
}