﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using SPC.Kiosk.Common;
using SPC.Kiosk.Base;
namespace SPC.Kiosk.Popup.Model
{
    /// <summary>
    /// ※CommonTypes에 NhsFuncInfoType과 일치해야함※
    /// Kiosk 에서 사용가능한 결재수단 필드 : 2019-06-10 - 1997fx11
    /// </summary>
    public class NhsFuncInfoItem : ViewModelBase
    {
        private string defaultValue = "0";
        /// <summary>
        /// 아직 없는 필드에대한 값(Default 숨김)
        /// </summary>
        public string DefaultValue 
        {
            get { return defaultValue; }
            set { defaultValue = value; PropertyChange("DefaultValue"); }
        }

        private string saveHappyPoint;
        /// <summary>
        /// STEP01 포인트 적립 - 해피포인트 적립
        /// </summary>
        public string SaveHappyPoint
        {
            get { return saveHappyPoint; }
            set { saveHappyPoint = value; PropertyChange("SaveHappyPoint"); }
        }

        private string saveOkCashBag;
        /// <summary>
        /// STEP01 포인트 적립 - OK CASHBAG 적립
        /// </summary>        
        public string SaveOkCashBag
        {
            get { return saveOkCashBag; }
            set { saveOkCashBag = value; PropertyChange("SaveOkCashBag"); }
        }

        private string discountSKT;
        /// <summary>
        /// STEP01 통신사 할인 - SKT
        /// </summary>        
        public string DiscountSKT
        {
            get { return discountSKT; }
            set { discountSKT = value; PropertyChange("DiscountSKT"); }
        }

        private string discountKT;
        /// <summary>
        /// STEP01 통신사 할인 - KT
        /// </summary>        
        public string DiscountKT
        {
            get { return discountKT; }
            set { discountKT = value; PropertyChange("DiscountKT"); }
        }

        private string discountLG;
        /// <summary>
        /// STEP01 통신사 할인 - LGT
        /// </summary>        
        public string DiscountLG
        {
            get { return discountLG; }
            set { discountLG = value; PropertyChange("discountLG"); }
        }

        private string usePointHappyPoint;
        /// <summary>
        /// STEP02 포인트 사용 - 해피포인트 사용
        /// </summary>        
        public string UsePointHappyPoint
        {
            get { return usePointHappyPoint; }
            set { usePointHappyPoint = value; PropertyChange("UsePointHappyPoint"); }
        }

        private string usePointOkCashBag;
        /// <summary>
        /// STEP02 포인트 사용 - OK CASHBAG 사용
        /// </summary>        
        public string UsePointOkCashBag
        {
            get { return usePointOkCashBag; }
            set { usePointOkCashBag = value; PropertyChange("UsePointOkCashBag"); }
        }

        private string useCouponHappy;
        /// <summary>
        /// STEP02 쿠폰 사용 - 해피쿠폰할인
        /// </summary>        
        public string UseCouponHappy
        {
            get { return useCouponHappy; }
            set { useCouponHappy = value; PropertyChange("UseCouponHappy"); }
        }

        private string useCouponMobile;
        /// <summary>
        /// STEP02 쿠폰 사용 - 모바일쿠폰
        /// </summary>        
        public string UseCouponMobile
        {
            get { return useCouponMobile; }
            set { useCouponMobile = value; PropertyChange("UseCouponMobile"); }
        }

        private string useCardPaymentCreditCard;
        /// <summary>
        /// STEP03 카드 결제 - 신용카드
        /// </summary>        
        public string UseCardPaymentCreditCard
        {
            get { return useCardPaymentCreditCard; }
            set { useCardPaymentCreditCard = value; PropertyChange("UseCardPaymentCreditCard"); }
        }

        private string useCardPaymentSPCEmployeeCertificate;
        /// <summary>
        /// STEP03 카드 결제 - SPC 사원증
        /// </summary>        
        public string UseCardPaymentSPCEmployeeCertificate
        {
            get { return useCardPaymentSPCEmployeeCertificate; }
            set { useCardPaymentSPCEmployeeCertificate = value; PropertyChange("UseCardPaymentSPCEmployeeCertificate"); }
        }

        private string useCardPaymentTMoney;
        /// <summary>
        /// STEP03 카드 결제 - T-MONEY
        /// </summary>        
        public string UseCardPaymentTMoney
        {
            get { return useCardPaymentTMoney; }
            set { useCardPaymentTMoney = value; PropertyChange("UseCardPaymentTMoney"); }
        }

        private string useCardPaymentCashBee;
        /// <summary>
        /// STEP03 카드 결제 - 캐시비
        /// </summary>        
        public string UseCardPaymentCashBee
        {
            get { return useCardPaymentCashBee; }
            set { useCardPaymentCashBee = value; PropertyChange("UseCardPaymentCashBee"); }
        }

        private string useCardPaymentHappyGift;
        /// <summary>
        /// STEP03 카드 결제 - HAPPY GIFT
        /// </summary>        
        public string UseCardPaymentHappyGift
        {
            get { return useCardPaymentHappyGift; }
            set { useCardPaymentHappyGift = value; PropertyChange("UseCardPaymentHappyGift"); }
        }

        private string useCardPaymentSamsungLGPay;
        /// <summary>
        /// STEP03 카드 결제 - 삼성/LG 페이
        /// </summary>        
        public string UseCardPaymentSamsungLGPay
        {
            get { return useCardPaymentSamsungLGPay; }
            set { useCardPaymentSamsungLGPay = value; PropertyChange("UseCardPaymentSamsungLGPay"); }
        }

        private string useCardPaymentAlipay;
        /// <summary>
        /// STEP03 카드 결제 - 알리페이
        /// </summary>        
        public string UseCardPaymentAlipay
        {
            get { return useCardPaymentAlipay; }
            set { useCardPaymentAlipay = value; PropertyChange("UseCardPaymentAlipay"); }
        }

        private string useCardPaymentSmilePay;
        /// <summary>
        /// STEP03 카드 결제 - 스마일페이
        /// </summary>        
        public string UseCardPaymentSmilePay
        {
            get { return useCardPaymentSmilePay; }
            set { useCardPaymentSmilePay = value; PropertyChange("UseCardPaymentSmilePay"); }
        }

        private string useCardPaymentZeroPay;
        /// <summary>
        /// STEP03 카드 결제 - 제로페이
        /// </summary>        
        public string UseCardPaymentZeroPay
        {
            get { return useCardPaymentZeroPay; }
            set { useCardPaymentZeroPay = value; PropertyChange("UseCardPaymentZeroPay"); }
        }
    }
}