﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : POS 기본 상수 선언
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Common
{
    /// <summary>
    /// POS에서만 사용하는 값들 Define
    /// </summary>
    public class PosConst
    {
        //#20170918 기념일 배송 출력 start
        public const int WM_COPYDATA = 0x4A;
        //#20170918 기념일 배송 출력 end

        /// <summary>
        /// CRLF
        /// </summary>
        public const string CRLF = "\r\n";

        /// <summary>
        /// 해피포인트 프리픽스(HP_CARD_PRIFIX)
        /// </summary>
        public const string HP_CARD_PRIFIX = "8231";

        /// <summary>
        /// 백신 프로그램 실행파일 정보
        /// </summary>
        public const string VACCINE_EXE_INFO = "KISA_HAURI_S213_20140408.EXE";

        public const string BEGINNING_MST_DOWN_DATE = "20000101000000";

        // 복합매장 전체 수신은 별도 관리(20170619)
        public const string BEGINNING_COMPLEX_SHOP_MST_DOWN_DATE = "20000102000000";

        #region COMMON_CODE_GROUP => 공통코드 그룹
        /// <summary>
        /// 공통코드 그룹
        /// </summary>
        public class COMMON_CODE_GROUP
        {
            /// <summary>
            /// 현금결제 화면 금액올림 단위
            /// </summary>
            public const string Z0001 = "Z0001";
            /// <summary>
            /// 현금결제 화면 금액표시 단위
            /// </summary>
            public const string Z0002 = "Z0002";
            /// <summary>
            /// 수표조회시 권종버튼
            /// </summary>
            public const string Z0003 = "Z0003";
            /// <summary>
            /// 준비금입력시 권종 표시
            /// </summary>
            public const string Z0004 = "Z0004";
            /// <summary>
            /// 예약 시간
            /// </summary>
            public const string Z0005 = "Z0005";
            /// <summary>
            /// 예약 분
            /// </summary>
            public const string Z0006 = "Z0006";
            /// <summary>
            /// 해피기프트 충전 금액
            /// </summary>
            public const string Z0007 = "Z0007";
            /// <summary>
            /// 반품사유 코드
            /// </summary>
            public const string Z0008 = "Z0008";
            /// <summary>
            /// 자료조회 대상 목록
            /// </summary>
            public const string Z0009 = "Z0009";
            /// <summary>
            /// 주문내역조회 - 차수
            /// </summary>
            public const string Z0010 = "Z0010";
            /// <summary>
            /// 주문내역조회 - 차수
            /// </summary>
            public const string Z0011 = "Z0011";
            /// <summary>
            /// 채반반납조회-차수
            /// </summary>
            public const string Z0012 = "Z0012";
            /// <summary>
            /// 정산코드표
            /// </summary>
            public const string Z0013 = "Z0013";
            /// <summary>
            /// 마감입금 - 결제내역
            /// </summary>
            public const string Z0014 = "Z0014";
            /// <summary>
            /// BR) 입고처리 알림
            /// </summary>
            public const string Z0015 = "Z0015";
            /// <summary>
            /// BR) 품질관리 집중시간
            /// </summary>
            public const string Z0016 = "Z0016";
            /// <summary>
            /// 외국인 응대코드
            /// </summary>
            public const string Z0017 = "Z0017";
            /// <summary>
            /// DD) 재고율정보 알림
            /// </summary>
            public const string Z0018 = "Z0018";
            /// <summary>
            /// DD) 주말 행사정보 팝업
            /// </summary>
            public const string Z0019 = "Z0019";
            /// <summary>
            /// 메모코드 (MST_POS_LOCAL)
            /// </summary>
            public const string Z0020 = "Z0020";
            /// <summary>
            /// 온라인쿠폰(중국) 응답메시지
            /// </summary>
            public const string Z0021 = "Z0021"; 
            /// <summary>
            /// 해피포인트 결제수단별 추가 적립
            /// </summary>
            public const string Z0022 = "Z0022";
            /// <summary>
            /// 위챗페이 승인 오류 메시지
            /// </summary>
            public const string Z0023 = "Z0023";

            /// <summary>
            /// 케익교환권 금액 관리
            /// </summary>
            public const string Z0025 = "Z0025";
            /// <summary>
            /// POS백신실행파일명
            /// </summary>
            public const string Z0026 = "Z0026";
            /// <summary>
            /// 서명패드모델
            /// </summary>
            public const string Z0027 = "Z0027";


            /// <summary>
            /// 점포결제유형
            /// </summary>
            public const string B0001 = "B0001";
            /// <summary>
            /// 판매 LOSS 코드
            /// </summary>
            public const string S0001 = "S0001";
            /// <summary>
            /// 부가세 세율 코드
            /// </summary>
            public const string M0101 = "M0101";


            //#20180611 해피오더 주문취소 사유 start
            /// <summary>
            /// 해피오더 취소 사유 공통코드 
            /// </summary>
            public const string S0093 = "S0093";
            //#20180611 해피오더 주문취소 사유 end

            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
            /// <summary>
            /// 해피오더 랜덤박스 상품코드 모음
            /// </summary>
            public const string T0039 = "T0039";
            //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end


            //#17651 해피오더)자동주문 시 표시문구 변경 start
            /// <summary>
            /// HPO 해피오더 자동주문 안내문구
            /// </summary>
            public const string T0043 = "T0043";
            //#17651 해피오더)자동주문 시 표시문구 변경 end

        }
        #endregion

        #region POS 유형
        /// <summary>
        /// POS 유형
        /// </summary>
        public class POS_TYPE
        {
            /// <summary>
            /// 선불
            /// </summary>
            public const string PRE_PAYMENT = "1";
            /// <summary>
            /// 후불
            /// </summary>
            public const string DEFERRED_PAYMENT = "2";
        }
        #endregion

        #region TABLE 유형 => 미사용
        //public class TABLE_TYPE
        //{
        //    /// <summary>
        //    /// 고정
        //    /// </summary>
        //    public const string TABLE_TYPE_FIXED = "0";
        //    /// <summary>
        //    /// 이미지
        //    /// </summary>
        //    public const string TABLE_TYPE_IMAGE = "1";
        //}
        #endregion

        #region Table Type Flag => 미사용
        //public class TABLE_TYPE_FLAG
        //{
        //    /// <summary>
        //    /// Table
        //    /// </summary>
        //    public const string TABLE_TYPE_FLAG_TABLE = "1";
        //    /// <summary>
        //    /// Label
        //    /// </summary>
        //    public const string TABLE_TYPE_FLAG_LABEL = "2";
        //}
        #endregion

        #region TABLE 표시 유형(1:사각, 2:라운드, 3:타원, 4:이미지) => 미사용
        /// <summary>
        /// TABLE 표시 유형(1:사각, 2:라운드, 3:타원, 4:이미지) => 미사용
        /// </summary>
        //public class TABLE_DISP_TYPE
        //{
        //    public const string RECTANGLE = "1";
        //    public const string ROUND = "2";
        //    public const string ELLIPSE = "3";
        //    public const string IMAGE = "4";
        //}
        #endregion

        #region TABLE 표시 구분
        /// <summary>
        /// TABLE 표시 구분 => 1번 테이블이름으로 고정 
        /// </summary>
        public class TABLE_DISP_FLAG
        {
            /// <summary>
            /// Table No (테이블 번호)
            /// </summary>
            public const string TABLE_NO = "0";
            /// <summary>
            /// Table Name (테이블 이름)
            /// </summary>
            public const string TABLE_NAME = "1";
            /// <summary>
            /// TABLE NO and NAME (테이블 번호 + 이름)
            /// </summary>
            public const string TABLE_NO_NAME = "2";
        }
        #endregion

        #region SEAT 표시 구분 => 미사용
        /// <summary>
        /// SEAT 표시 구분
        /// </summary>
        //public class SEAT_DISP_FLAG
        //{
        //    /// <summary>
        //    /// No Display (미표시)
        //    /// </summary>
        //    public const string NO_DISPLAY = "0";
        //    /// <summary>
        //    /// Display (표시)
        //    /// </summary>
        //    public const string YES_DISPLAY = "1";
        //}
        #endregion

        #region 주문 유형
        /// <summary>
        /// 주문 유형
        /// </summary>
        public class ORDER_TYPE
        {
            /// <summary>
            /// 일반
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 배달
            /// </summary>
            public const string DELIVERY = "1";
            /// <summary>
            /// 포장
            /// </summary>
            public const string PACKING = "2";
        }
        #endregion

        #region Table Operation Flag Enum
        public enum TABLE_OPERATION_FLAG
        {
            TABLE_NONE,             // None
            //TABLE_JOIN,             // Table Join
            //TABLE_JOIN_CLEAR,       // Table Join Clear
            TABLE_ADD,              // Table Add
            TABLE_MOVE,             // Table Move
            TABLE_ITEM_MOVE,        // Table Item Move
            TABLE_MEMO,             // Table Memo
            TABLE_COMPLETE_PAYMENT, // Table Compete Payment
            TABLE_NOT_USE,          // Table Not Use
            TABLE_GROUP,            // Table Group
            TABLE_GROUP_CLEAR,      // Table Group Clear
            TABLE_PAYMENT,          // Table Payment 
            TABLE_NO_ORDER_SALE,    // Table No order sale (판매모드)
        }
        #endregion

        #region TABLE Operation Flag
        public class TABLE_OP_FLAG
        {
            /// <summary>
            /// NONE (없음)
            /// </summary>
            public const string OP_NONE = "0";
            ///// <summary>
            ///// TABLE JOIN (테이블 붙임 => 업무 없어짐)
            ///// </summary>
            //public const string OP_JOIN = "1";
            /// <summary>
            /// TABLE GROUP 
            /// </summary>
            public const string OP_GROUP = "2";
        }
        #endregion

        #region TABLE Use Flag
        public class TABLE_USE_FLAG
        {
            /// <summary>
            /// 미사용
            /// </summary>
            public const string NO_USE = "0";
            /// <summary>
            /// 사용
            /// </summary>
            public const string YES_USE = "1";
        }
        #endregion

        #region 테이블 기타 실행모드 (ETC_OPERATION_MODE)
        /// <summary>
        /// 테이블 기타 실행모드 
        /// </summary>
        public class ETC_OPERATION_MODE
        {
            /// <summary>
            /// 일반모드 (테이블주문)
            /// </summary>
            public const string NORMAL = "";
            /// <summary>
            /// 판매모드 (테이블)
            /// </summary>
            public const string NO_ORDER_SALE = "NO_ORDER_SALE";
            /// <summary>
            /// 테이블그룹 결제 모드 
            /// </summary>
            public const string TABLE_GROUP_PAY = "TABLE_GROUP_PAY";
            /// <summary>
            /// 메뉴실행모드 
            /// </summary>
            public const string MENU_EXECUTE = "MENU_EXECUTE|";
        } 
        #endregion

        #region Database Row Status 
        /// <summary>
        /// Database Row Status 
        /// </summary>
        public enum DB_ROW_STATUS
        {
            NONE,                   // 0
            INSERT,                 // 1
            UPDATE,                 // 2
            DELETE,                 // 3
            RESTORE = 9,
        } 
        #endregion

        #region Query Definition
        public class QueryTagDef
        {
            /// <summary>
            /// 층 마스터 조회 조건
            /// </summary>
            public class QueryFloorDef
            {
                public const string FLOOR_ALL_SEARCH = "0";
                public const string FLOOR_CD_SEARCH = "1";
                public const string FLOOR_NM_SEARCH = "2";
            }
            /// <summary>
            /// 테이블 마스터 조회 조건
            /// </summary>
            public class QueryTableDef
            {
                public const string FLOOR_CD_SEARCH = "1";
                public const string TABLE_ALL_SEARCH = "0";
                public const string TABLE_NM_SEARCH = "3";
                public const string TABLE_NO_SEARCH = "2";
                public const string TABLE_WHERE = "4";
                public const string TABLE_NO_FLOOR_CD_SEARCH = "5";
                public const string TABLE_GROUP_SEARCH = "6";

                //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 start
                public const string DT_TABLE_ORD_SEARCH = "7";
                //#16569 파스쿠찌 드라이브 스루 기능 개발 요청 end

            }
            /// <summary>
            /// 점포공지사항 조회 조건
            /// </summary>
            public class QueryStoreNoticeDef
            {
                public const string ALL_SEARCH = "0";
                public const string SEQ_SEATCH = "1";
                public const string SEQ_DELETE = "2";
                public const string DATE_DELETE = "3";
                public const string ALL_DELETE = "4";
            }
        }
        #endregion

        #region POS 주변장치 관련
        /// <summary>
        /// POS 주변장치 형태
        /// </summary>
        public class OPOS_DEVICE
        {
            /// <summary>
            /// Scanner"Scanner"
            /// </summary>
            public const string SCANNER = "Scanner";
            /// <summary>
            /// Msr"Msr"
            /// </summary>
            public const string MSR = "Msr";
            /// <summary>
            /// CashDrawer"CashDrawer"
            /// </summary>
            public const string CASHDRAWER = "CashDrawer";
            /// <summary>
            /// PosPrinter"PosPrinter"
            /// </summary>
            public const string POSPRINTER = "PosPrinter";
            /// <summary>
            /// UNIDONGLE"UniDongle"
            /// </summary>
            public const string UNIDONGLE = "UniDongle";
            /// <summary>
            /// CATTERMINAL"CatTerminal"
            /// </summary>
            public const string CATTERMINAL = "CatTerminal";
            /// <summary>
            /// ICReader"ICReader"
            /// </summary>
            public const string ICREADER = "ICReader";
            /// <summary>
            /// Scale"Scale"(PB 한매장에서 사용)
            /// </summary>
            public const string SCALE = "Scale";
            /// <summary>
            /// WirelessScale"WirelessScale"(BR에서 사용)
            /// </summary>
            public const string WIRELESSSCALE = "WirelessScale";
            /// <summary>
            /// LabelPrinter"LabelPrinter"
            /// </summary>
            public const string LABELPRINTER = "LabelPrinter";
        }

        #region Device Use Flag
        public class DEVICE_USE_FLAG
        {
            /// <summary>
            /// 미사용
            /// </summary>
            public const string NO_USE = "0";
            /// <summary>
            /// 사용
            /// </summary>
            public const string YES_USE = "1";
        }
        #endregion

        /// <summary>
        /// POS 설정용 주변장치 항목
        /// </summary>
        public class POS_DEVICE_LIST
        {
            /// <summary>
            /// Hand SCANNER 장비 종류("Scanner" 항목)
            /// </summary>
            //public class ALTERNATE_SCANNER
            //{
            //    ///// <summary>
            //    ///// Scanner 범용
            //    ///// </summary>
            //    //public const string _1_ALL = "NCRScanner.2";
            //    ///// <summary>
            //    ///// Scanner 후지쯔
            //    ///// </summary>
            //    //public const string _2_FUJITSU = "HScanner";
            //    ///// <summary>
            //    ///// 3000XC 연결 마젤란스캐너 
            //    ///// </summary>
            //    //public const string _3_3000XC = "NCRScanner.1";
            //    ///// <summary>
            //    ///// 핸드스캐너 장비 리스트 Hashtable
            //    ///// </summary>
            //    //public static Hashtable htDevice = new Hashtable {  { 1, _1_ALL }, 
            //    //                                                    { 2, _2_FUJITSU },
            //    //                                                    { 3, _3_3000XC}
            //    //                                                 };

            //}
            /// <summary>
            /// POS_PRINTER 장비 종류("DefaultPosPrinter" 항목)
            /// </summary>
            public class POS_PRINTER
            {
                /// <summary>
                /// EPSON 계열 호환
                /// ex) EPSON TM-T88 Series, SAM4S GIANT-100S, 
                /// </summary>
                public const string _1_EPSON = "1";
                /// <summary>
                /// TOSHIBA 계열 호환
                /// ex) TOSHIBA TRST-A00
                /// </summary>
                public const string _2_TOSHIBA = "2";
                /// <summary>
                /// IBM
                /// ex) TYPE 4610-TF7, TYPE 4610-1NR
                /// </summary>
                public const string _3_IBM = "3";
                /// <summary>
                /// P2C
                /// ex) P2C All in One
                /// </summary>
                public const string _6_P2C = "6";

                public const string _7_1NR = "7";//2018.01.22;"7:4610_1NR" 모델 추가;girak.kim

                public static Hashtable htSvcOPOS = new Hashtable {  { "1", "" }, 
                                                                     { "2", "" },
                                                                     { "3", "POS_PRT" },
                                                                     { "6", "" },
                                                                     { "7", "" }
                                                                  };


                ///// <summary>
                ///// EPSON TM-T88II
                ///// </summary>
                ////public const string _1_TM_T88II = "TM-T88II";
                //public const string _1_TM_T88II = "1";
                ///// <summary>
                ///// EPSON TM-T88III
                ///// </summary
                ////public const string _2_TM_T88III = "TM-T88III";
                //public const string _2_TM_T88III = "2";
                ///// <summary>
                ///// EPSON TM-T88V
                ///// </summary>
                ////public const string _3_TM_T88IV = "TM-T88IV";
                //public const string _3_TM_T88IV = "3";
                ///// <summary>
                ///// EPSON TM-T88IV
                ///// </summary>
                ////public const string _4_TM_T88V = "TM-T88V";
                //public const string _4_TM_T88V = "4";

                ///// <summary>
                ///// IBM 4610-TF7
                ///// </summary>
                //public const string _5_4610_TF7 = "5";

                ///// <summary>
                ///// IBM 4610-1NR
                ///// </summary>
                //public const string _6_4610_1NR = "6";

                ///// <summary>
                ///// TOSHIBA TRST-A00
                ///// </summary>
                //public const string _7_TRST_A00 = "7";

                ///// <summary>
                ///// Bixolon SRP-352plusIII
                ///// </summary>
                //public const string _8_SRP_352PLUSIII = "8";                

                ///// <summary>
                ///// UP Solution TP-600
                ///// </summary>
                //public const string _9_TP_600 = "9";

                ///// <summary>
                ///// SAM4S GIANT-100S
                ///// </summary>
                //public const string _10_GIANT_100S = "10";

                ///// <summary>
                ///// P2C All in One
                ///// </summary>
                //public const string _11_P2C_All_In_One = "11";

                /// <summary>
                /// POSBANK ???
                /// </summary>
                /// 

                /// <summary>
                /// Sewoo ???
                /// </summary>
                /// 

                //public static Hashtable htDevice = new Hashtable {  { 1, _1_THERMAL }, 
                //                                                    { 5, _5_SRP_352plusIII },
                //                                                    { 6, _6_TOSHIBA },
                //                                                    { 7, _7_3000XC },
                //                                                    { 8, _8_TM88_IV }
                //                                                 };
            }
            /// <summary>
            /// 돈통 장비 종류("DefaultCashdrawer" 항목)
            /// </summary>
            public class CASHDRAWER
            {
                /// <summary>
                /// 프린터 연결
                /// </summary>
                public const string _1_PRINTER = "1";

                public const string _2_OPOS_IBM = "2";

                public const string _3_DLL_TPS8700 = "3";

                public const string _4_DLL_VPS9700 = "4";

                public const string _5_IBM_MAIN = "5";

                public const string SvcOPOS = "POS_CASH";

                ///// <summary>
                ///// 엡손 Printer TM-T88II 에 연결 "Standard"
                ///// </summary>
                //public const string _1_1_PRINTER = "Standard";
                ///// <summary>
                ///// 엡손 Printer TM-T88IV 에 연결 "Multi_A"
                ///// </summary>
                //public const string _1_8_PRINTER = "Multi_A";
                ///// <summary>
                ///// 빅솔론 Printer SRP-352plusIII 에 연결 "SRPCDW"
                ///// </summary>
                //public const string _1_5_PRINTER = "SRPCDW";
                ///// <summary>
                ///// Fujitsu TP2000M 본체연결 Cashdrawer. "Fujitsu7514DR"
                ///// </summary>
                //public const string _2_1_FUJITSU = "Fujitsu7514DR";
                ///// <summary>
                ///// Fujitsu TP7000 본체연결 Cashdrawer. "FujitsuFP7PDR"
                ///// </summary>
                //public const string _2_2_FUJITSU = "FujitsuFP7PDR";
                ///// <summary>
                ///// Fujitsu TP3000XL, TP3000XL2 본체연결 Cashdrawer. "FujitsuFPS3DDR"
                ///// </summary>
                //public const string _2_5_FUJITSU = "FujitsuFPS3DDR";
                ///// <summary>
                ///// Toshiba "DRWA1S"
                ///// </summary>
                //public const string _5_TOSHIBA = "DRWA1S";
                ///// <summary>
                ///// Fujitsu TP3000XC  "PTD00"
                ///// </summary>
                //public const string _6_3000XC = "PTD00";
                ///// <summary>
                ///// Cashdrawer 장비 리스트 Hashtable
                ///// </summary>
                //public static Hashtable htDevice = new Hashtable {  { 1.1, _1_1_PRINTER }, 
                //                                                    { 1.8, _1_8_PRINTER }, 
                //                                                    { 1.5, _1_5_PRINTER },
                //                                                    { 2.1, _2_1_FUJITSU },
                //                                                    { 2.2, _2_2_FUJITSU },
                //                                                    { 2.5, _2_5_FUJITSU },
                //                                                    { 5,   _5_TOSHIBA },
                //                                                    { 6,   _6_3000XC }
                //                                                 };
            }
            /// <summary>
            /// MSR 장비 종류("DefaultMsr" 항목)
            /// </summary>
            public class MSR
            {
                ///// <summary>
                ///// Msr Fujitsu TP2000 104KBD "Fujitsu7518MC"
                ///// </summary>
                //public const string _1_TP2000 = "Fujitsu7518MC";
                ///// <summary>
                ///// Fujitsu Msr TP3000 32KBD "FujitsuFPS3DKB2_MSR"
                ///// </summary>
                //public const string _2_TP3000_32 = "FujitsuFPS3DKB2_MSR";
                ///// <summary>
                ///// Toshiba Msr "MCRST"
                ///// </summary>
                //public const string _3_80M = "MCRST";
                ///// <summary>
                ///// Fujitsu Msr TP7000 40KBD "FujitsuFP7PKA_MSR"
                ///// </summary>
                //public const string _4_TP7000_40 = "FujitsuFP7PKA_MSR";
                ///// <summary>
                ///// Toshiba Msr "MCRST"
                ///// </summary>
                //public const string _5_40 = "MCRST";
                ///// <summary>
                ///// Fujitsu Msr TP3000XC Msr "IDTECH_MMII_RS232"
                ///// </summary>
                //public const string _6_3000XC = "IDTECH_MMII_RS232";
                ///// <summary>
                ///// MSR 장비 리스트 Hashtable
                ///// </summary>
                //public static Hashtable htDevice = new Hashtable {  { 1, _1_TP2000 }, 
                //                                                    { 2, _2_TP3000_32 },
                //                                                    { 3, _3_80M },
                //                                                    { 4, _4_TP7000_40 },
                //                                                    { 5, _5_40 },
                //                                                    { 6, _6_3000XC }
                //                                                 };
            }

            public class LABEL_PRINTER
            {
                /// <summary>
                /// 라벨 프린터 구형(라벨지 크기 작은 것)
                /// </summary>
                public const string OLD_TYPE = "0";
                /// <summary>
                /// 라벨 프린터 신형(라벨지 크기 큰 것)
                /// </summary>
                public const string NEW_TYPE = "1";
            }

            public class Signpad
            {
                public const string _1_OLTMS = "1";

                public const string _2_OLCSP = "2";

                public const string _3_SSP_100 = "3";

                public const string _4_SN_350P = "4";

                public const string _5_SN_150P = "5";
            }

            public class CDP
            {
                public const string _0_TOSHIBA = "0";

                public const string _1_XN = "1";
            }
        }
        /// <summary>
        /// POS Device Controller Type
        /// </summary>
        public class POS_DEVICE_CONTROLLER
        {
            public const string RS232 = "1";

            public const string OPOS = "2";
        }

        public class PRINT_ALIGN
        {
            public const int LEFT_ALIGN = 0;

            public const int CENTER_ALIGN = 1;

            public const int RIGHT_ALIGN = 2;
        }

        public class CDP_COMMAND
        {
            /// <summary>
            /// All clear ( 0x1B 0x5B 0x32 0x4A )
            /// </summary>
            public static byte[] LINE_CLEAR = { 27, 91, 50, 74 };
            /// <summary>
            /// All clear for XN ( 0x0C )
            /// </summary>
            public static byte[] LINE_CLEAR_XN = { 12 };
            /// <summary>
            /// Set virtual cursor ( 0x1B 0x5B 0x31 0x3B 0x31 0x48 )
            /// </summary>
            public static byte[] LINE_START_1 = { 27, 91, 49, 59, 49, 72 };
            /// <summary>
            /// Set virtual cursor ( 0x1B 0x5B 0x32 0x3B 0x31 0x48 )
            /// </summary>
            public static byte[] LINE_START_2 = { 27, 91, 50, 59, 49, 72 };
            /// <summary>
            /// Delete to end of line
            /// </summary>
            public static byte[] LINE_DELETE = { 27, 91, 48, 107 };
        }

        public class ESCP_COMMAND
        {
            /// <summary>
            /// Initialize printer (ESC @)
            /// </summary>
            public static byte[] INITIALIZE_PRINTER = { 27, 64 };
            /// <summary>
            /// Initialize printer
            /// </summary>
            public static byte[] INITIALIZE_IBM = { 27, 32, 0 };
            /// <summary>
            /// Print and line feed (LF)
            /// </summary>
            public static byte[] LINE_FEED = { 10 };
            /// <summary>
            /// Select bit image mode
            /// </summary>
            public static byte[] SELECT_BIT_IMAGE_MODE = { 27, 42 };
            /// <summary>
            /// Set line spacing
            /// </summary>
            public static byte[] SET_LINE_SPACING = { 27, 51 };
            /// <summary>
            /// Set default line spacing
            /// </summary>
            public static byte[] SET_DEFAULT_LINE_SPACING = { 27, 50 };
            /// <summary>
            /// BOLD ON
            /// </summary>
            public static byte[] BOLD_ON = { 27, 71, 1 };
            /// <summary>
            /// BOLD OFF
            /// </summary>
            public static byte[] BOLD_OFF = { 27, 71, 0 };
            /// <summary>
            /// ZOOM ON
            /// </summary>
            public static byte[] ZOOM_ON = { 29, 33, 17 };
            /// <summary>
            /// ZOOM OFF
            /// </summary>
            public static byte[] ZOOM_OFF = { 29, 33, 0 };
            /// <summary>
            /// HEIGHT x 2 ON
            /// </summary>
            public static byte[] HEIGHT_X2_ON = { 27, 33, 16 };
            /// <summary>
            /// HEIGHT x 2 OFF
            /// </summary>
            public static byte[] HEIGHT_X2_OFF = { 27, 33, 0 };
            /// <summary>
            /// WIDTH x 2 ON
            /// </summary>
            public static byte[] WIDTH_X2_ON = { 27, 33, 32 };
            /// <summary>
            /// WIDTH x 2 OFF
            /// </summary>
            public static byte[] WIDTH_X2_OFF = { 27, 33, 0 };
            ///// <summary>
            ///// LINE SPACE ON
            ///// </summary>
            //public static byte[] LINE_SPACE_ON = { 27, 51, 12 };
            ///// <summary>
            ///// LINE SPACE OFF
            ///// </summary>
            //public static byte[] LINE_SPACE_OFF = { 27, 50 };
            /// <summary>
            /// LEFT ALIGN
            /// </summary>
            public static byte[] LEFT_ALIGN = { 27, 97, 0 };
            /// <summary>
            /// CENTER ALIGN
            /// </summary>
            public static byte[] CENTER_ALIGN = { 27, 97, 1 };
            /// <summary>
            /// RIGHT ALIGN
            /// </summary>
            public static byte[] RIGHT_ALIGN = { 27, 97, 2 };
            /// <summary>
            /// Underline On
            /// </summary>
            public static byte[] UNDERLINE_ON = { 27, 45, 1 };
            /// <summary>
            /// Underline Off
            /// </summary>
            public static byte[] UNDERLINE_OFF = { 27, 45, 0 };
            /// <summary>
            /// PAPER CUT(1NR)
            /// </summary>
            public static byte[] PAPER_CUT_1NR = { 27, 109 };
            /// <summary>
            /// PAPER CUT(EPSON)
            /// </summary>
            public static byte[] PAPER_CUT = { 29, 86, 1 };
            /// <summary>
            /// CASHDRAWER OPEN for EPSON
            /// </summary>
            public static byte[] CASHDRAWER_OPEN_EPSON = { 27, 112, 0, 32, 128 };
            /// <summary>
            /// CASHDRAWER OPEN for ETC
            /// </summary>
            public static byte[] CASHDRAWER_OPEN_ETC = { 27, 112, 48, 16, 16 };
            /// <summary>
            /// CASHDRAWER OPEN for IBM 본체
            /// </summary>
            //#20170928 IBM 본체 돈통 오픈시 명령어 수정 start
            //기존
            public static byte[] CASHDRAWER_OPEN_IBMHOST = { 27, 7 };
            //변경
            //public static byte[] CASHDRAWER_OPEN_IBMHOST = { 7 };
            //#20170928 IBM 본체 돈통 오픈시 명령어 수정 end
            /// <summary>
            /// Select page mode.
            /// </summary>
            public static byte[] SET_PAGE_MODE = { 27, 76 };
            /// <summary>
            /// Print and recover to standart mode.
            /// </summary>
            public static byte[] SET_STD_MODE_AFTER_PRINT_IN_PAGE_MODE = { 12 };

            /// <summary>
            /// Select HRI Character print position.
            /// </summary>
            public static byte[] HRI_PRINT_POSITION = { 29, 72 };                   // GS H
            /// <summary>
            /// Set Barcode horizontal size.
            /// </summary>
            public static byte[] BARCODE_HORIZONTAL_SIZE = { 29, 119 };             // GS w
            /// <summary>
            /// Set Barcode height.
            /// </summary>
            public static byte[] BARCODE_HEIGHT = { 29, 104 };                      // GS h
            /// <summary>
            /// Print Barcode(CODE128)
            /// </summary>
            public static byte[] PRINT_BARCODE_CODE128 = { 29, 107, 73 };           // GS k m

            /// <summary>
            /// Defines the specified NV bit image for EPSON.
            /// </summary>
            public static byte[] UPLOAD_NV_BIT_IMAGE_1_EPSON = { 28, 113, 1 };      // FS q 1
            /// <summary>
            /// Defines the specified NV bit images for EPSON.
            /// </summary>
            public static byte[] UPLOAD_NV_BIT_IMAGE_2_EPSON = { 28, 113, 2 };      // FS q 2
            /// <summary>
            /// Prints NV bit image n using mode m.
            /// </summary>
            //public static byte[] PRINT_NV_BIT_IMAGE_1 = { 28, 112, 1, 0, 10 };          // FS p 1 0
            public static byte[] PRINT_NV_BIT_IMAGE_1 = { 28, 112, 1, 0 };          // FS p 1 0
            /// <summary>
            /// Prints NV bit image n using mode m.
            /// </summary>
            //public static byte[] PRINT_NV_BIT_IMAGE_2 = { 28, 112, 2, 0, 10 };          // FS p 2 0
            public static byte[] PRINT_NV_BIT_IMAGE_2 = { 28, 112, 2, 0 };          // FS p 2 0
            /// <summary>
            /// Prints NV bit image n using mode m.
            /// </summary>
            //public static byte[] PRINT_NV_BIT_IMAGE_3 = { 28, 112, 3, 0, 10 };          // FS p 3 0
            public static byte[] PRINT_NV_BIT_IMAGE_3 = { 28, 112, 3, 0 };          // FS p 3 0
            /// <summary>
            /// Prints NV bit image n using mode m.
            /// </summary>
            //public static byte[] PRINT_NV_BIT_IMAGE_4 = { 28, 112, 4, 0, 10 };          // FS p 4 0
            public static byte[] PRINT_NV_BIT_IMAGE_4 = { 28, 112, 4, 0 };          // FS p 4 0
            /// <summary>
            /// Print NV bit image for IBM 1NR
            /// </summary>
            public static byte[] PRINT_NV_BIT_IMAGE_1_1NR = { 29, 47, 0, 1 };          // FS p 1 0
            /// <summary>
            /// Print NV bit image for IBM 1NR
            /// </summary>
            public static byte[] PRINT_NV_BIT_IMAGE_2_1NR = { 29, 47, 0, 2 };          // FS p 2 0
            /// <summary>
            /// Transmit printer status
            /// </summary>
            public static byte[] TRANSMIT_PRINTER_STATUS = { 0x10, 0x04, 0x01 };                // DLE EOT 1
            /// <summary>
            /// Transmit offline cause status
            /// </summary>
            public static byte[] TRANSMIT_OFFLINE_STATUS = { 0x10, 0x04, 0x02 };                // DLE EOT 2
            /// <summary>
            /// Transmit error cause status
            /// </summary>
            public static byte[] TRANSMIT_ERROR_STATUS = { 0x10, 0x04, 0x03 };                  // DLE EOT 3
            /// <summary>
            /// Transmit continuous paper detector status
            /// </summary>
            public static byte[] TRANSMIT_CONTINUOUS_PAPER_DETECTOR_STATUS = { 0x10, 0x04, 0x04 };  // DLE EOT 4
            /// <summary>
            /// Transmit presenter paper detector status
            /// </summary>
            public static byte[] TRANSMIT_PRESENTER_PAPER_DETECTOR_STATUS = { 16, 4, 5 };   // DLE EOT 5

            public static byte[] STATUS_OK = { 0x12, 0x14 };

            /// <summary>
            /// On Reverse Mode 
            /// </summary>
            public static byte[] REVERSE_MODE_ON = { 0x1D, 0x42, 0x01 };    //ESC + "|rvC"
            /// <summary>
            /// Off Revers Mode
            /// </summary>
            public static byte[] REVERSE_MODE_OFF = { 0x1D, 0x42, 0x00 };   //ESC + "|!rvC"


            /// <summary>
            /// 돈통 Open
            /// </summary>
            public static byte[] OPEN_CASHDRAWER = { 27, 112, 0, 32, 128 };
            public static byte[] OPEN_CASHDRAWER_FOR_TOSHIBA = { 27, 112, 48, 16, 16 };
            public static byte[] OPEN_CASHDRAWER_FOR_IBM = { 27, 7 };
        }

        public class POS_ICREADER_CONFIG
        {
            /// <summary>
            /// INI파일 App Name
            /// </summary>
            public const string APPNAME = "CONFIG";

            /// <summary>
            /// INI파일 Key Name
            /// </summary>
            public const string KEY_READER_PORT = "READER_PORT";
            public const string KEY_READER_BAUDRATE = "READER_BAUDRATE";


        }

        public class POS_SIGNPAD_CONFIG
        {
            /// <summary>
            /// INI파일 App Name
            /// </summary>
            public const string APPNAME = "CONFIG";

            /// <summary>
            /// INI파일 Key Name
            /// </summary>
            public const string KEY_SIGN_PORT = "SIGN_PORT";
            public const string KEY_SIGN_BAUDRATE = "SIGN_BAUDRATE";
            public const string KEY_SIGN_AUTOFLAG = "SIGN_AUTO_FLAG";
            public const string KEY_SIGN_MIN_CNT = "SIGN_MIN_CNT";
            public const string KEY_SIGN_TIMEOUT = "SIGN_TIMEOUT";

            //#20170904 IC_MSG_CARD, RF_MSG_CARD 문구 추가 start
            public const string KEY_IC_MSG_CARD = "IC_MSG_CARD";
            public const string KEY_RF_MSG_CARD = "RF_MSG_CARD";
            //#20170904 IC_MSG_CARD, RF_MSG_CARD 문구 추가 end

        }

        public class O2MSR_CONFIG
        {
            /// <summary>
            /// INI파일 App Name
            /// </summary>
            public const string APPNAME = "MSRINFO";

            /// <summary>
            /// INI파일 Key Name
            /// </summary>
            public const string COMPORT = "COMPORT";
            public const string BAUDRATE = "BAUDRATE";
            public const string VENDOR = "VENDOR";
            public const string MODEL = "MODEL";
        }

        /// <summary>
        /// OPOS 레지스트리 항목의 Logical Device Name
        /// </summary>
        public class OPOS_LDN
        {
            /// <summary>
            /// CashDrawer"DefaultCashDrawer"
            /// </summary>
            public const string CASHDRAWER = "DefaultCashDrawer";
            /// <summary>
            /// PosPrinter"DefaultPosPrinter"
            /// </summary>
            public const string POSPRINTER = "DefaultPosPrinter";

            public const string SCANNER = "DefaultScanner";
        }
        #endregion

        #region MSG_BOX_TYPE => 메세지 박스 형태
        /// <summary>
        /// MSG_BOX_TYPE => 메세지 박스 형태
        /// </summary>
        public class MSG_BOX_TYPE
        {
            /// <summary>
            /// 확인성메세지 = "1"
            /// </summary>
            public const string CONFIRM = "1";
            /// <summary>
            /// 경고성메세지 = "2"
            /// </summary>
            public const string ERROR = "2";
            /// <summary>
            /// 질문성메세지(아니오,예) = "3"
            /// </summary>
            public const string QUESTION = "3";
            /// <summary>
            /// 질문성메세지(아니오,확정) = "4"
            /// </summary>
            public const string COMPLETE = "4";
            /// <summary>
            /// 카운트 다운
            /// </summary>
            public const string COUNTDOWN = "5";
            /// <summary>
            /// BR 아이스크림 전용
            /// </summary>
            public const string BRK_POPUP = "6";

            //#15945 해피오더 자동주문 상세기능 start
            /// <summary>
            /// 자동출하 질문성메세지
            /// </summary>
            public const string AutomaticShipment = "7";
            //#15945 해피오더 자동주문 상세기능 end

            //#14941 스마트영수증 대상고객 안내기능 도입 start
            /// <summary>
            /// 카운트 다운 확인
            /// </summary>
            public const string COUNTDOWNCONFIRM = "8";
            //#14941 스마트영수증 대상고객 안내기능 도입 end
        }
        #endregion

        #region FOREIGNCURRENCY_TYPE => 외화결제타입형태
        /// <summary>
        /// FOREIGNCURRENCY_TYPE(외화결제타입형태)
        /// </summary>
        public class FOREIGNCURRENCY_TYPE
        {
            /// <summary>
            /// 달러
            /// </summary>
            public const string USD = "USD";

            /// <summary>
            /// 유로
            /// </summary>
            public const string EUR = "EUR";

            /// <summary>
            /// 엔화
            /// </summary>
            public const string JPY = "JPY";
            /// <summary>
            /// 위안
            /// </summary>
            public const string CNY = "CNY";
        }
        #endregion

        #region PRT_HDR, PRT_FMT POS 영수증 출력 관련
        /// <summary>
        /// 영수증 유형
        /// </summary>
        public class PRT_ITEM
        {
            /// <summary>
            /// 본영수증
            /// </summary>
            public const string REC = "0";
            /// <summary>
            /// 본영수증 임시출력용 (재출력 되지 않음)
            /// </summary>
            public const string REC_TEMP = "1";

            /// <summary>
            /// 기타영수증 임시출력용 (재출력 되지 않음)
            /// </summary>
            public const string ETC_TEMP = "8";
            /// <summary>
            /// 기타영수증
            /// </summary>
            public const string ETC = "9";
        }

        /// <summary>
        /// PRT_HDR(영수증출력형태)
        /// </summary>
        public class PRT_HDR
        {
            /// <summary>
            /// BMP파일
            /// </summary>
            public const string PRT_BMP = "[BMP]";          // BMP
            /// <summary>
            /// 서명 BMP파일
            /// </summary>
            public const string PRT_SGN = "[SGN]";          // SIGN BMP
            /// <summary>
            /// 상단 로고 이미지
            /// </summary>
            public const string PRT_TBM = "[TBM]";          // TOP BMP
            /// <summary>
            /// 하단 로고 이미지
            /// </summary>
            public const string PRT_BBM = "[BBM]";          // BOTTOM BMP
            /// <summary>
            /// 바코드(CODE128) with HRI(below BARCODE)
            /// </summary>
            public const string PRT_BAR = "[BAR]";          // 바코드(CODE128) with HRI(below BARCODE)
            /// <summary>
            /// 바코드(CODE128) without HRI
            /// </summary>
            public const string PRT_BA1 = "[BA1]";          // 바코드(CODE128) without HRI
            ///// <summary>
            ///// 바코드(KAN)
            ///// </summary>
            //public const string PRT_KAN = "[KAN]";        // 바코드(KAN8,KAN13)
            /// <summary>
            /// 용지절단
            /// <para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_CUT = "[CUT]";          // CUT
            /// <summary>
            /// 일반문자
            /// <para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_NOR = "[NOR]";          // 일반 문자
            /// <summary>
            /// 진하게
            /// <para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_BLD = "[BLD]";          // 진하게
            /// <summary>
            /// 라인문자
            /// </summary>
            public const string PRT_LIN = "[LIN]";          // 라인문자
            /// <summary>
            /// 세로확대
            /// <para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_VER = "[VER]";          // 세로확대
            /// <summary>
            /// 가로확대
            ///<para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_HOR = "[HOR]";          // 가로확대
            /// <summary>
            /// 가로/세로확대
            /// <para>FoodPrinter사용가능</para>
            /// </summary>
            public const string PRT_BIG = "[BIG]";          // 가로/세로확대
            /// <summary>
            /// 저널데이터
            /// </summary>
            public const string PRT_JNL = "[JNL]";          // 저널데이터
            /// <summary>
            /// 이미지파일
            /// </summary>
            public const string PRT_IMG = "[IMG]";          // 이미지 출력   
            /// <summary>
            /// 전자서명 이미지 파일
            /// </summary>
            public const string PRT_SIG = "[SIG]";          // 전자서명 이미지파일출력
            /////// <summary>
            /////// 바코드(CODE93)
            /////// </summary>
            //public const string PRT_B93 = "[B93]";        // 바코드(CODE93)
            /// <summary>
            /// 영수증 재출력 용
            /// </summary>
            public const string PRT_REP = "[REP]";          // 재출력 용
            /// <summary>
            /// 스캐너 초기화 용
            /// </summary>
            public const string PRT_SIS = "[SIS]";          // 스캐너 초기화 용 (SCANNER INITIALIZE SETUP)
            /// <summary>
            /// 세로확대 + 진하게
            /// </summary>
            public const string PRT_VRB = "[VRB]";          // 세로확대 + 진하게
            /// <summary>
            /// 가로확대 + 진하게
            /// </summary>
            public const string PRT_HRB = "[HRB]";          // 가로확대 + 진하게
            /// <summary>
            /// 가로/세로확대 + 진하게
            /// </summary>
            public const string PRT_BGB = "[BGB]";          // 가로/세로확대 + 진하게

            /// <summary>
            /// 세로확대 + 반전 + 가운데정렬
            /// </summary>
            public const string PRT_VRE = "[VRE]";          // 세로확대 + 반전 + 가운데정렬
        }

        /// <summary>
        /// PRT_FMT(영수증출력 포멧)
        /// </summary>
        public class PRT_FMT
        {
            /// <summary>
            /// 전체-선귿기(================)
            /// </summary>
            public const string F100 = "100";
            /// <summary>
            /// 전체-왼쪽정렬
            /// </summary>
            public const string F101 = "101";
            /// <summary>
            /// 전체-오른쪽정렬
            /// </summary>
            public const string F102 = "102";
            /// <summary>
            /// 전체-가운데정렬
            /// </summary>
            public const string F103 = "103"; 

            /// <summary>
            /// 2개=>명RPAD(31)+금액(11)
            /// </summary>
            public const string F200 = "200";
            /// <summary>
            /// 2개=>명LPAD(31)+금액(11)
            /// </summary>
            public const string F201 = "201";
            /// <summary>
            /// 2개=>명RPAD(20)+데이터LPAD(22)
            /// </summary>
            public const string F202 = "202";
            /// <summary>
            /// 2개=>명(16)+데이터(26)
            /// </summary>
            public const string F203 = "203";
            /// <summary>
            /// 2개=>명(20)+데이터(22)
            /// </summary>
            public const string F204 = "204";
            /// <summary>
            /// 2개=>명(31-우정렬)+금액(11)
            /// </summary>
            public const string F205 = "205";
            /// <summary>
            /// 2개=>명(20)+금액(12)
            /// </summary>
            public const string F206 = "206";
            //#20171227, 예약증 양식 출력 Start
            /// <summary>
            /// 2개=>명RPAD(16)+데이터(26)
            /// </summary>
            public const string F207 = "207";
            //#20171227, 예약증 양식 출력 End

            /// <summary>
            /// 3개=>명LPAD(26)+수량(5)+금액(11)
            /// </summary>
            public const string F300 = "300";
            /// <summary>
            /// 3개=>명RPAD(26)+수량(5)+금액(11)
            /// </summary>
            public const string F301 = "301";
            /// <summary>
            /// 3개(카드/승인번호용)=>명RPAD(17)+데이터LPAD(9)+데이터LPAD(16)
            /// </summary>
            public const string F302 = "302";
            /// <summary>
            /// 3개(카드/승인번호용)=>명RPAD(17)+데이터RPAD(9)+데이터LPAD(16)              // 현금반품 내역 추가 20170830 goblin6
            /// </summary>
            public const string F303 = "303";
            //#20171227, 예약증 양식 출력 Start
            /// <summary>
            /// 3개=>명RPAD(16)+데이터RPAD(9)+데이터RPAD(17) 
            /// </summary>
            public const string F304 = "304";
            //#20171227, 예약증 양식 출력 End

            /// <summary>
            /// 4개=>명(좌)(16)+수량(5)+할인(10)+금액(11)
            /// </summary>
            public const string F401 = "401";
            /// <summary>
            /// 4개=>명(우)(16)+수량(5)+할인(10)+금액(11)
            /// </summary>
            public const string F402 = "402";
            /// <summary>
            /// 4개=>명(우)(2)+수량(19)+할인(10)+금액(11)
            /// </summary>
            public const string F403 = "403";
            /// <summary>
            /// 4개=>명(우)(12)+수량(7)+명(우)(12)+금액(11)
            /// </summary>
            public const string F404 = "404";
            /// <summary>
            /// 4개=>명(좌)(10)+명(좌)(15)+명(좌)(10)+명(좌)(7)
            /// </summary>
            public const string F405 = "405";

            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 start
            /// <summary>
            /// 4개=>명(좌)(14)+명(좌)(10)+명(좌)(14)+명(우)(4)
            /// </summary>
            public const string F406 = "406";
            //#17142 [해피오더]POS로그인 시 영수증프린터로 장부재고 자동 출력 end

            /// <summary>
            /// 5개=> 수량(3)+명(좌)(16)+단가(10)+금액(11)+부가세코드(2) 
            /// </summary>
            public const string F501 = "501";
            /// <summary>
            /// 5개=> 과세코드(4)+과세율(11)+순매출액(9)+과세금액(9)+합계(9)
            /// </summary>
            public const string F502 = "502";
        }
        #endregion

        #region INI_FILE_NAME 파일명 정의
        /// <summary>
        /// INI_FILE_NAME
        /// </summary>
        public class INI_FILE_NAME
        {
            /// <summary>
            /// 기본정보 설정 파일
            /// </summary>
            public const string PosConfig = "PosConfig.ini";
            /// <summary>
            /// POS 거래정보 설정파일
            /// </summary>
            public const string PosSaleInfo = "PosSaleInfo.ini";
            /// <summary>
            /// POS 디바이스 설정파일
            /// </summary>
            public const string PosDevice = "PosDevice.ini";
            /// <summary>
            /// POS 통신포트 설정파일
            /// </summary>
            public const string CommPort = "CommPort.ini";
            /// <summary>
            /// IC Reader, Signpad 설정 파일
            /// </summary>
            public const string ICReaderConfig = "SpcnPosCfg.ini";
            /// <summary>
            /// POS 프로그램 업데이트 관리 파일
            /// </summary>
            public const string PosUpdateInfo = "PosUpdateInfo.INI";
            /// <summary>
            /// MSR에뮬 설정 파일 
            /// </summary>
            public const string O2MSRConfig = "O2MSR.Conf";
            /// <summary>
            /// 메모 파일
            /// </summary>
            public const string Memo = "Memo.txt";

            //#20171227 인천공항 포스연동 start, phj
            /// <summary>
            /// 인천공항 통합POS 연동정보 
            /// </summary>
            public const string IncheonAirPort = "IncheonAirPort.ini";
            //#20171227 인천공항 포스연동 end, phj

            //#20180322 휴게소pos매출연동 start,phj
            /// <summary>
            /// 도로공사 HI-쉼마루 연동정보 
            /// </summary>
            public const string RestAreaPos = "RestAreaPos.ini";
            //#20180322 휴게소pos매출연동 end,phj
        }
        #endregion

        #region SALE_FLOW => POS 상품판매 단계별 STEP
        /// <summary>
        /// SALE_FLOW => POS 상품판매 단계별 STEP
        /// </summary>
        public class SALE_FLOW
        {
            /// <summary>
            /// 상품등록 대기
            /// </summary>
            public const string SALE_WAIT = "00";
            /// <summary>
            /// 상품등록 중
            /// </summary>
            public const string SALE_DOING = "10";
            /// <summary>
            /// 세트메뉴 등록 중
            /// </summary>
            public const string SALE_DOING_SET = "11";
            /// <summary>
            /// 강제부가메뉴 등록 중
            /// </summary>
            public const string SALE_DOING_OPT = "12";
            /// <summary>
            /// 세트메뉴 하위 강제부가메뉴 등록 중
            /// </summary>
            public const string SALE_DOING_SET_OPT = "13";
            ///// <summary>
            ///// 선택부가메뉴 등록 중
            ///// </summary>
            //public const string SALE_DOING_BTN_OPT = "14";
            ///// <summary>
            ///// 플레이버 등록 중
            ///// </summary>
            //public const string SALE_DOING_FLAVOUR = "15";
            /// <summary>
            /// 상품권 판매 중
            /// </summary>
            public const string SALE_GIFT = "16";
            /// <summary>
            /// 선불카드 판매 중
            /// </summary>
            public const string SALE_PREPAID = "17";
            /// <summary>
            /// 결제 대기
            /// </summary>
            public const string PAY_WAIT = "50";
            /// <summary>
            /// 결제 중
            /// </summary>
            public const string PAY_DOING = "51";

            /// <summary>
            /// 판매완료
            /// </summary>
            public const string SALE_END = "99";
            /// <summary>
            /// 반품호출 후 대기
            /// </summary>
            public const string REFUND_WAIT = "60";
        }

        /// <summary>
        /// 기타트란선언(2:영수증재발행,3:호출트란)
        /// </summary>
        public class TRAN_ETC_TYPE
        {
            /// <summary>
            /// 정상거래
            /// </summary>
            public const string NORMAL = "";
            /// <summary>
            /// 일괄취소
            /// </summary>
            public const string SALE_STOP = "1";
            /// <summary>
            /// 영수증 재발행
            /// </summary>
            public const string RE_PRINT = "2";
            /// <summary>
            /// 트란호출 거래
            /// </summary>
            public const string TRAN_CALL = "3";
        }
        #endregion

        #region PLU_ORDER_OK_FLAG => 상품 주문 상태
        /// <summary>
        /// 주문상태
        /// </summary>
        public class PLU_ORDER_OK_FLAG
        {
            /// <summary>
            /// 주문 중
            /// </summary>
            public const string ORDER_ING = "0";
            /// <summary>
            /// 주문 완료
            /// </summary>
            public const string ORDER_OK = "1";
            /// <summary>
            /// 주문 수정(지정취소)
            /// </summary>
            public const string ORDER_MOD = "2";

        }
        #endregion

        #region OWN_PART_DIV 점주 알바 구분
        /// <summary>
        /// 점주 알바 구분
        /// </summary>
        public class OWN_PART_DIV
        {
            /// <summary>
            /// 점주
            /// </summary>
            public const string OWN_DIV = "0";
            /// <summary>
            /// 알바
            /// </summary>
            public const string PART_DIV = "1";
        }
        #endregion

        #region MOT_MSG_TYPE MOT메시지유령
        /// <summary>
        /// 메시지 유형<1:STEP=1, 2:STEP=2, 3:STEP=3, 5:스크린>
        /// </summary>
        public class MOT_MSG_TYPE
        {
            /// <summary>
            /// 1:결제 MOT STEP1 
            /// </summary>
            public const string PAY_STEP_1 = "1";
            /// <summary>
            /// 2:결제 MOT STEP2 
            /// </summary>
            public const string PAY_STEP_2 = "2";
            /// <summary>
            /// 3:결제 MOT STEP3 
            /// </summary>
            public const string PAY_STEP_3 = "3";
            /// <summary>
            /// 5:스크린 MOT
            /// </summary>
            public const string DSP_SCN_MSG = "5";

        }
        #endregion

        #region MST_SUB_SET_MNG_TYPE 상품마스터 부가세트관리유형
        /// <summary>
        /// 상품 종류
        /// </summary>
        public class MST_SUB_SET_MNG_TYPE
        {
            /// <summary>
            /// 0:일반상품
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 2:세트상품
            /// </summary>
            public const string SET_MENU = "2";
            /// <summary>
            /// 1:부가상품
            /// </summary>
            public const string SUB_MENU = "1";
        }
        #endregion

        #region MATH_ROUND => 올림,반올림,내림 구분
        /// <summary>
        /// MATH_ROUND => 올림,반올림,내림 구분
        /// </summary>
        public class MATH_ROUND
        {
            /// <summary>
            /// 0:올림
            /// </summary>
            public const string CEILING = "1";
            /// <summary>
            /// 1:반올림
            /// </summary>
            public const string ROUND = "2";
            /// <summary>
            /// 2:내림
            /// </summary>
            public const string TRANCATE = "3";
        }
        #endregion

        #region MST_USE_YN 마스터 사용구분
        /// <summary>
        /// 마스터 사용 구분
        /// </summary>
        public class MST_USE_YN
        {
            /// <summary>
            /// 1:사용
            /// </summary>
            public const string YES = "1";
            /// <summary>
            /// 0:미사용
            /// </summary>
            public const string NO = "0";

        }
        #endregion

        #region MST_PIC_AUTH 담당자 관리권한 구분
        public class MNG_AUTH_DIV
        {
            /// <summary>
            /// 0:불가
            /// </summary>
            public const string NON_PERMISSION = "0";
            /// <summary>
            /// 1:가능
            /// </summary>
            public const string PERMISSION = "1";
            /// <summary>
            /// 2:Supervisor 권한 체크
            /// </summary>
            public const string SUPERVISOR = "2";
        }
        #endregion MST_PIC_AUTH 담당자 관리권한 구분

        #region MST_USER 계산원 구분
        public class CASHIER_DIV
        {
            /// <summary>
            /// 점주
            /// </summary>
            public const string OWNER = "1";
            /// <summary>
            /// 점장
            /// </summary>
            public const string MANAGER = "2";
            /// <summary>
            /// 직원
            /// </summary>
            public const string EMPLOYEE = "3";
            /// <summary>
            /// 아르바이트
            /// </summary>
            public const string PARTTIME = "4";
        }
        #endregion MST_USER 계산원 구분

        #region CANCEL_DIV 취소 구분
        /// <summary>
        /// 취소 구분
        /// </summary>
        public class CANCEL_DIV
        {
            /// <summary>
            /// 0:정상
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:취소
            /// </summary>
            public const string CANCEL = "1";
            /// <summary>
            /// 2:결제 전환 후 취소
            /// </summary>
            public const string CANCEL_SUBTOT = "2";

        }
        #endregion

        #region PAY_DISPLAY_DIV (결제수단 화면표시 여부)
        /// <summary>
        /// 결제수단 화면표시 여부
        /// </summary>
        public class DISPLAY_DIV
        {
            /// <summary>
            /// 표시 : 0
            /// </summary>
            public const string DISPLAY_YES = "0";
            /// <summary>
            /// 미표시 : 1
            /// </summary>
            public const string DISPLAY_NO = "1";
        }
        #endregion

        #region POS VAN
        /// <summary>
        /// POS VAN 
        /// </summary>
        public class POS_VAN_MASTER
        {
            /// <summary>
            /// 전문 버전 01
            /// </summary>
            public const string IRT_VERSION_01 = "SP01";
            /// <summary>
            /// 전문 버전 02
            /// </summary>
            public const string IRT_VERSION_02 = "SP02";
            /// <summary>
            /// HEADER DOC 업체정보
            /// </summary>
            public const string VAN_SHOP_INFO = "SPCN";

            /// <summary>
            /// 거래구분
            /// </summary>
            public class TRADE_ID
            {
                /// <summary>
                /// 카드사인 오굿 승인 요청
                /// </summary>
                public const string VAN_CARD_AGREE_J = "JA";
                /// <summary>
                /// 카드사인 오굿 취소 요청
                /// </summary>
                public const string VAN_CARD_CANCEL_J = "JC";
                /// <summary>
                /// 카드사인 승인 요청
                /// </summary>
                public const string VAN_CARD_AGREE = "NA";
                /// <summary>
                /// 카드사인 취소 요청
                /// </summary>
                public const string VAN_CARD_CANCEL = "NC";
                /// <summary>
                /// IC카드사인 승인 요청
                /// </summary>
                public const string VAN_ICCARD_AGREE = "IA";
                /// <summary>
                /// IC카드사인 취소 요청
                /// </summary>
                public const string VAN_ICCARD_CANCEL = "IC";
                /// <summary>
                /// IC카드사인 망취소 요청
                /// </summary>
                public const string VAN_ICCARD_LINE_CANCEL = "IY";
                /// <summary>
                /// 현금영수증 승인 요청
                /// </summary>
                public const string VAN_CASH_AGREE = "bq";
                /// <summary>
                /// 현금영수증 취소 요청
                /// </summary>
                public const string VAN_CASH_CANCEL = "bs";
                /// <summary>
                /// 수표조회 요청
                /// </summary>
                public const string VAN_BILL_CHECK = "DK";
                /// <summary>
                /// 포인트적립
                /// </summary>
                public const string VAN_POT_ACC_A = "yk";
                /// <summary>
                /// 포인트적립취소
                /// </summary>
                public const string VAN_POT_ACC_C = "ym";
                /// <summary>
                /// 포인트사용
                /// </summary>
                public const string VAN_POT_USE_A = "yo";
                /// <summary>
                /// 포인트사용취소
                /// </summary>
                public const string VAN_POT_USE_C = "yq";
                /// <summary>
                /// 포인트할인
                /// </summary>
                public const string VAN_POT_DIS_A = "ys";
                /// <summary>
                /// 포인트할인취소
                /// </summary>
                public const string VAN_POT_DIS_C = "yu";
                /// <summary>
                /// 포인트조회
                /// </summary>
                public const string VAN_POT_QRY_A = "yw";
                /// <summary>
                /// 해피전자쿠폰 조회
                /// </summary>
                public const string VAN_HPY_ELC_A = "yy";
            }
            /// <summary>
            /// 입력방식
            /// </summary>
            public class INPUT_TYPE
            {
                public const string VAN_SWIP = "S";
                public const string VAN_KEYIN = "K";

                public const string VAN_MOBILE_SWIP = "M";
                public const string VAN_BARCODE = "B";

                public const string VAN_BARCODE_SH = "A";       // 세브란스병원

                public const string VAN_BARCODE_CP = "0";       // 모바일쿠폰-해피콘
                public const string VAN_KEYIN_CP = "1";         // 모바일쿠폰 - 해피콘

                public const string VAN_BARCODE_GIFT = "1";     // 상품권
                public const string VAN_KEYIN_GIFT = "0";       // 상품권

                public const string VAN_RF = "R";               // {T-Money}
                /// <summary>
                /// IC 보안 리더기
                /// </summary>            
                public const string VAN_IC = "C";

                public const string VAN_SPC_MSR = "A";          // spc 임직원 할인 - 중국 
                public const string VAN_SPC_KEYIN = "@";        // spc 임직원 할인 - 중국
            }

			/// <summary>
			/// T페이 입력구분
			/// </summary>
			public class TPAY_ENTRY_MODE
			{
				public const string KEYIN = "010";
				public const string SWIP = "020";
				public const string BARCODE = "031";
				public const string BLE = "032";
				public const string NFC = "033";
			}

            /// <summary>
            /// 신CMS추가_20120725 롤파일 다운로드 요청
            /// </summary>
            public const string VAN_OGOOD_RULE_DOWN = "JU";   //롤파일 다운로드 요청

            /// <summary>
            /// 현금영수증 단독
            /// </summary>
            public const string CASHBILL_DIV_ONLY = "0";
            /// <summary>
            /// 현금영수증+OCB
            /// </summary>
            public const string CASHBILL_DIV_WITH_OCV = "1";

            /// <summary>
            /// 다운로드 요청
            /// </summary>
            public const string REQ_DOWNLOAD = "DN";
            /// <summary>
            /// 다운로드 응답
            /// </summary>
            public const string RES_DOWNLOAD = "DO";

            /// <summary>
            /// 룰파일 다운로드 요청
            /// </summary>
            public const string RULE_DOWNLOAD_REQ = "JU";
            /// <summary>
            /// 룰파일 로딩결과 응답
            /// </summary>
            public const string RULE_RESULT_REQ = "JQ";
        }
        #endregion

        #region POS CAT
        /// <summary>
        /// POS CAT
        /// </summary>
        public class POS_CAT_MASTER
        {

            public const string TRAN_TYPE = "Z0";

            /// <summary>
            /// 거래구분
            /// </summary>
            public class TRADE_ID
            {
                /// <summary>
                /// 신용카드 승인
                /// </summary>
                public const string CAT_CARD_AGREE = "S0";
                /// <summary>
                /// 신용카드 취소
                /// </summary>
                public const string CAT_CARD_CANCEL = "S1";
                /// <summary>
                /// 은련 승인
                /// </summary>
                public const string CAT_UNION_AGREE = "S2";
                /// <summary>
                /// 은련취소
                /// </summary>
                public const string CAT_UNION_CANCEL = "S3";
                /// <summary>
                /// 현금영수증 승인
                /// </summary>
                public const string CAT_CASH_AGREE = "C0";
                /// <summary>
                /// 현금영수증 취소
                /// </summary>
                public const string CAT_CASH_CANCEL = "C1";
                /// <summary>
                /// 포인트 적립
                /// </summary>
                public const string CAT_POINT_SAVE = "K0";
                /// <summary>
                /// 포인트 적립 취소
                /// </summary>
                public const string CAT_POINT_SAVE_CANCEL = "K1";
                /// <summary>
                /// 포인트 사용
                /// </summary>
                public const string CAT_POINT_USE = "K2";
                /// <summary>
                /// 포인트 사용 취소
                /// </summary>
                public const string CAT_POINT_USE_CANCEL = "K3";
                /// <summary>
                /// 포인트 할인
                /// </summary>
                public const string CAT_POINT_DC = "K4";
                /// <summary>
                /// 포인트 할인 취소
                /// </summary>
                public const string CAT_POINT_DC_CANCEL = "K5";
                /// <summary>
                /// 포인트 조회
                /// </summary>
                public const string CAT_POINT_SEARCH = "K6";
                /// <summary>
                /// SKT 할인
                /// </summary>
                public const string CAT_SKT_AGREE = "T0";
                /// <summary>
                /// SKT 할인 취소
                /// </summary>
                public const string CAT_SKT_CANCEL = "T1";
                /// <summary>
                /// SKT 할인 조회
                /// </summary>
                public const string CAT_SKT_SEARCH = "T2";
                /// <summary>
                /// KT 할인
                /// </summary>
                public const string CAT_KT_AGREE = "T3";
                /// <summary>
                /// KT 할인 취소
                /// </summary>
                public const string CAT_KT_CANCEL = "T4";
                /// <summary>
                /// KT 할인 조회
                /// </summary>
                public const string CAT_KT_SEARCH = "T5";
                /// <summary>
                /// LGT 할인
                /// </summary>
                public const string CAT_LGT_AGREE = "T6";
                /// <summary>
                /// LGT 할인 취소
                /// </summary>
                public const string CAT_LGT_CANCEL = "T7";
                /// <summary>
                /// LGT 할인 조회
                /// </summary>
                public const string CAT_LGT_SEARCH = "T8";

                //#20180413 웰컴카드 신규기능 추가 start,phj
                /// <summary>
                /// MC 할인 
                /// </summary>
                public const string CAT_WCC_AGREE = "T9";
                /// <summary>
                /// MC 할인 취소
                /// </summary>
                public const string CAT_WCC_CANCEL = "T10";
                /// <summary>
                /// MC 할인 조회
                /// </summary>
                public const string CAT_WCC_SEARCH = "T11";
                //#20180413 웰컴카드 신규기능 추가 end,phj

                /// <summary>
                /// 해피포인트 적립
                /// </summary>
                public const string CAT_HAPPY_SAVE = "H0";
                /// <summary>
                /// 해피포인트 적립 취소
                /// </summary>
                public const string CAT_HAPPY_CANCEL = "H1";
                /// <summary>
                /// 해피포인트 사용
                /// </summary>
                public const string CAT_HAPPY_USE = "H2";
                /// <summary>
                /// 해피포인트 사용 취소
                /// </summary>
                public const string CAT_HAPPY_USE_CANCEL = "H3";
                /// <summary>
                /// 해피포인트 조회
                /// </summary>
                public const string CAT_HAPPY_SEARCH = "H4";
            }
        }
        #endregion

        #region 밴전문 헥사값
        /// <summary>
        /// 밴전문 헥사값 정의
        /// </summary>
        public class VAN_HEXA
        {
            /// <summary>
            /// STX - 0x02
            /// </summary>
            public static readonly string STX = string.Format("{0}", (char)0x02);
            /// <summary>
            /// FS - 0x1C
            /// </summary>
            public static readonly string FS = string.Format("{0}", (char)0x1C);
            /// <summary>
            /// RS - 0X1E
            /// </summary>
            public static readonly string RS = string.Format("{0}", (char)0x1E);
            /// <summary>
            /// GS - 0X1D
            /// </summary>
            public static readonly string GS = string.Format("{0}", (char)0x1D);
            /// <summary>
            /// ETX - 0X03
            /// </summary>
            public static readonly string ETX = string.Format("{0}", (char)0x03);
            /// <summary>
            /// CR - 0X0D
            /// </summary>
            public static readonly string CR = string.Format("{0}", (char)0x0D);
            /// <summary>
            /// ACK - 0X06
            /// </summary>
            public static readonly string ACK = string.Format("{0}", (char)0x06);

        }

        /// <summary>
        /// 밴전문 헥사값 바이트
        /// </summary>
        public class VAN_HEXA_BYTE
        {
            /////////////////////////////////////////////////////////////////////
            // 전문응답 비교
            /////////////////////////////////////////////////////////////////////
            /// <summary>
            /// BYTE STX - 0x02
            /// </summary>
            public static readonly byte STX = 0x02;
            /// <summary>
            /// BYTE FS - 0x1C
            /// </summary>
            public static readonly byte FS = 0x1C;
            /// <summary>
            /// BYTE RS - 0X1E
            /// </summary>
            public static readonly byte RS = 0x1E;
            /// <summary>
            /// BYTE GS - 0X1D
            /// </summary>
            public static readonly byte GS = 0x1D;
            /// <summary>
            /// BYTE ETX - 0X03
            /// </summary>
            public static readonly byte ETX = 0x03;
            /// <summary>
            /// BYTE CR - 0X0D
            /// </summary>
            public static readonly byte CR = 0x0D;

        }
        #endregion

        #region 임의할인,서비스 타입:POS OP용
        /// <summary>
        /// 임의할인,서비스 타입:POS OP용
        /// </summary>
        public class ITEM_DC_DIV_POS_DC
        {
            /// <summary>
            /// 율 할인
            /// </summary>
            public const string RATE = "1";
            /// <summary>
            /// 금액 할인
            /// </summary>
            public const string AMT = "2";
            /// <summary>
            /// 서비스(무료)
            /// </summary>
            public const string FREE = "3";
        }
        #endregion

        #region 상품권,선불카드 구분(상품마스터 MST_ITEM)
        /// <summary>
        /// 상품권,선불카드 구분(상품마스터 MST_ITEM)
        /// </summary>
        public class ITEM_TYPE
        {
            /// <summary>
            /// 상품권
            /// </summary>
            public const string GIFT = "12";
            /// <summary>
            /// 선불카드
            /// </summary>
            public const string PREPAID = "13";
        }
        #endregion

        #region TTS Voice Name
        public class TTS_VOICE_NAME
        {
            /// <summary>
            /// 한국어
            /// </summary>
            public const string VOICE_ko_KR = "Microsoft Server Speech Text to Speech Voice (ko-KR, Heami)";
            /// <summary>
            /// 영어
            /// </summary>
            public const string VOICE_en_US = "Microsoft Server Speech Text to Speech Voice (en-US, Helen)";
            /// <summary>
            /// 일본어
            /// </summary>
            public const string VOICE_ja_JP = "Microsoft Server Speech Text to Speech Voice (ja-JP, Haruka)";
            /// <summary>
            /// 중국어
            /// </summary>
            public const string VOICE_zh_CN = "Microsoft Server Speech Text to Speech Voice (zh-CN, HuiHui)";
        }
        #endregion

        #region IC리더기 카드 요청 TRAN TYPE
        /// <summary>
        /// IC리더기 카드 요청 TRAN TYPE
        /// </summary>
        public class IC_READER_TRAN_TYPE
        {
            /// <summary>
            /// 0:신용카드
            /// </summary>
            public const int CREDIT = 0;
            /// <summary>
            /// 1:현금영수증
            /// </summary>
            public const int CASHBILL = 1;
            /// <summary>
            /// 3:포인트
            /// </summary>
            public const int POINT = 2;
            /// <summary>
            /// 4:기타
            /// </summary>
            public const int ETC = 3;
        }
        #endregion

        #region 상품 과세 구분
        /// <summary>
        /// 상품 과세 구분
        /// </summary>
        public class ITEM_TAX_DIV
        {
            /// <summary>
            /// 0:면세
            /// </summary>
            public const string FREE = "0";
            /// <summary>
            /// 1:과세
            /// </summary>
            public const string TAX = "1";
        }

        /// <summary>
        /// NOTAX 적용 구분
        /// </summary>
        public class ITEM_NOTAX_DIV
        {
            /// <summary>
            /// 0:미적용
            /// </summary>
            public const string NO = "0";
            /// <summary>
            /// 1:적용
            /// </summary>
            public const string YES = "1";
        }

        #endregion

        #region 결제/할인 구분
        /// <summary>
        /// 결제/할인 구분
        /// </summary>
        public class PAY_DC_TYPE
        {
            /// <summary>
            /// 0:없음
            /// </summary>
            public const string NORMAL = "0";
            /// <summary>
            /// 1:결제
            /// </summary>
            public const string PAY = "1";
            /// <summary>
            /// 2:할인
            /// </summary>
            public const string DC = "2";
        }
        #endregion

        #region 부가메뉴 공통 중분류 코드
        /// <summary>
        /// 부가메뉴 공통 중분류 코드
        /// </summary>
        public const string SUB_MEMO_L_CLSS_COMMON = "ZZZZZZ";
        #endregion

        #region SALE_PLU_INPUT_TYPE 상품등록모듈 입력 구분
        /// <summary>
        /// 상품등록모듈 입력 구분(0:수입력, 1:메뉴, 2:스켄, 3:플레이버)
        /// </summary>
        public class SALE_PLU_INPUT_TYPE
        {
            /// <summary>
            /// 0:수입력
            /// </summary>
            public const string KEY_IN = "0";
            /// <summary>
            /// 1:메뉴키
            /// </summary>
            public const string MENUKEY = "1";
            /// <summary>
            /// 2:스캔
            /// </summary>
            public const string SCANNER = "2";
            /// <summary>
            /// 3:플레이버 메뉴
            /// </summary>
            public const string FLAVOUR = "3";
            
            //////////////////////////////////////////////////////////////////////
            // POS 자체사용
            //////////////////////////////////////////////////////////////////////
            /// <summary>
            /// A:부가메뉴
            /// </summary>
            public const string SUBMENU = "A";
            /// <summary>
            /// B:사은품(상품)
            /// </summary>
            public const string FREEGIFT = "B";
            /// <summary>
            /// C:사은품(HP)
            /// </summary>
            public const string FREEGIFT_HP = "C";

        }
        #endregion

        #region 신용카드 조회 업무 구분
        /// <summary>
        /// 신용카드 조회 업무 구분
        /// </summary>
        public class CREDITCARD_SEARCH_TYPE
        {
            /// <summary>
            /// 0:카드프리픽스
            /// </summary>
            public const string PREFIX = "0";
            /// <summary>
            /// 1:SFC조회
            /// </summary>
            public const string SFC = "1";
            /// <summary>
            /// 2:삼성포이트 조회
            /// </summary>
            public const string POINT = "2";
            /// <summary>
            /// 이동단말기 로그 조회
            /// </summary>
            public const string VAN_CARD_LOG_SEARCH = "3";
            /// <summary>
            /// 이동단말기 로그 등록 확정
            /// </summary>
            public const string VAN_CARD_LOG_FINAL = "4";
            /// <summary>
            /// 현대 M 포인트 조회
            /// </summary>
            public const string M_POINT = "5";
        }
        #endregion

        #region 주방 시스템 구분
        public class KTCH_SYS_DIV
        {
            /// <summary>
            /// KPS
            /// </summary>
            public const string KPS = "1";
            /// <summary>
            /// KVS
            /// </summary>
            public const string KVS = "2";
            /// <summary>
            /// KDS
            /// </summary>
            public const string KDS = "3";
        }
        #endregion 주방 시스템 구분

        #region 주방 시스템 사용 구분
        public class KTCH_SYS_USE_DIV
        {
            /// <summary>
            /// Serial
            /// </summary>
            public const string RS232 = "1";
            /// <summary>
            /// Database  
            /// </summary>
            public const string DATABASE = "2";
            /// <summary>
            /// Socket
            /// </summary>
            public const string SOCK = "3";
        }
        #endregion

        #region 주방프린터 주문메시지 구분 (KPS_ORD_MSG_ID)
        /// <summary>
        /// 주방프린터 주문메시지 구분
        /// </summary>
        public class KPS_ORD_MSG_ID
        {
            ///// <summary>
            ///// 일괄취소 "0"
            ///// </summary>
            //public const string TRADE_STOP = "0";
            /// <summary>
            /// 상품메모 "1"
            /// </summary>
            public const string ITEM_MEMO = "1";
            /// <summary>
            /// 좌석메모 "2"
            /// </summary>
            public const string SEAT_MEMO = "2";
            /// <summary>
            /// 테이블 합석 "3"
            /// </summary>
            public const string TABLE_COMBINE = "3";
            /// <summary>
            /// 테이블 이동 "4"
            /// </summary>
            public const string TABLE_MOVE = "4";
            /// <summary>
            /// 메뉴 이동 "5"
            /// </summary>
            public const string MENU_MOVE = "5";

            /// <summary>
            /// FIRE_KEY "9"
            /// </summary>
            public const string FIRE_KEY = "9";
        } 
        #endregion

        #region 전문구분
        public class POS_VAN_MSG_TYPE
        {
            public const string NORMAL = "0200";        // 정상

            public const string REFUND = "0420";        // 반품
        }
        #endregion

        #region 전문 요청구분
        public class POS_VAN_INQ_TYPE
        {
            public const string SEARCH = "10";          // 조회

            public const string APPROVAL = "20";        // 승인
        }
        #endregion

        #region 전문 판매구분
        public class POS_VAN_SALE_TYPE
        {
            public const string EMPLOYEE = "10";        // 직원식

            public const string EMPLOYEE_DC = "20";     // 직원할인
        }
        #endregion

        #region 전문 요청 모드
        public class POS_INQ_MODE
        {
            public const string SEARCH = "0";           // 조회

            public const string APPROVAL = "1";         // 승인

            public const string REFUND = "2";           // 취소

            public const string NETCANCEL = "3";        // 망취소

            public const string SEARCH_LOG = "4";       // 이력 조회
        }
        #endregion

        #region 모바일쿠폰 - 해피콘제외 전문 요청구분
        public class POS_MOBILECON_HPCON_INQ_TYPE
        {
            public const string SEARCH = "100";         // 조회

            public const string APPROVAL = "101";       // 승인

            public const string REFUND = "102";         // 취소
        }
        #endregion

        #region 모바일쿠폰 - 해피콘 전문 요청구분
        public class POS_MOBILECON_HPCON_INQ_TYPE_NEW
        {
            public const string SEARCH = "101";         // 조회

            public const string SEARCH_LOG = "102";     // 이력 조회

            public const string APPROVAL = "203";       // 승인

            public const string REFUND = "204";         // 취소
        }
        #endregion

        #region 모바일쿠폰 - 기프티콘 전문 요청구분
        public class POS_MOBILECON_GIFTCON_INQ_TYPE
        {
            public const string SEARCH = "P100";        // 조회

            public const string APPROVAL = "P110";      // 승인

            public const string REFUND = "P120";        // 취소

            public const string NETCANCEL = "P130";     // 망취소
        }
        #endregion

        #region 모바일쿠폰 - 기프티쇼 전문 요청구분
        public class POS_MOBILECON_GIFTSHOW_INQ_TYPE
        {
            public const string SEARCH = "100";         // 조회

            public const string APPROVAL = "101";       // 승인

            public const string REFUND = "102";         // 취소

            public const string APPROVAL_AMT = "201";   // 금액권 차감

            public const string REFUND_AMT = "202";     // 금액권 차감 취소
        }
        #endregion

        #region SPC 임직원 결제 전문 요청구분
        public class POS_SPC_EMPLOYEE_INQ_TYPE
        {
            public const string SEARCH = "1000";                // 조회

            public const string APPROVAL = "1210";              // 승인

            public const string REFUND = "1220";                // 취소

            public const string NETCANCEL_APPROVAL = "1910";    // 망취소 - 사용

            public const string NETCANCEL_REFUND = "1920";      // 망취소 - 사용취소
        }
        #endregion

        #region SPC 임직원 할인 전문 요청구분 - 중국
        public class POS_SPC_EMPLOYEE_DC_CHINA_INQ_TYPE
        {
            public const string SEARCH = "002020020";           // 조회

            public const string APPROVAL = "002020010";         // 승인

            public const string REFUND = "002042010";           // 취소
        }
        #endregion

        #region 해피포인트/선불카드 전문유형 구분 - 중국
        public class POS_POINT_INQ_TYPE_CHINA
        {
            public const string SEARCH = "0100";                // 조회

            public const string SAVE = "0200";                  // 적립/충전

            public const string USE = "0300";                   // 사용
        }
        #endregion

        #region 해피포인트/선불카드 업무구분 구분 - 중국
        public class POS_POINT_TRAN_TYPE_CHINA
        {
            public const string SEARCH_POINT = "10";            // 포인트 조회
            public const string SEARCH_PP = "20";               // 선불카드 조회

            public const string SAVE_POINT_APPROVAL = "11";     // 포인트 적립
            public const string SAVE_POINT_REFUND = "12";       // 포인트 적립 취소
            public const string SAVE_POINT_NETREFUND = "13";    // 포인트 적립 망취소

            public const string SAVE_PP_APPROVAL = "21";        // 선불카드 충전
            public const string SAVE_PP_REFUND = "22";          // 선불카드 충전 취소
            public const string SAVE_PP_NETREFUND = "23";       // 선불카드 충전 망취소

            public const string USE_POINT_APPROVAL = "31";      // 포인트 사용
            public const string USE_POINT_REFUND = "32";        // 포인트 사용 취소
            public const string USE_POINT_NETREFUND = "33";     // 포인트 사용 망취소

            public const string USE_PP_APPROVAL = "41";         // 선불카드 사용
            public const string USE_PP_REFUND = "42";           // 선불카드 사용 취소
            public const string USE_PP_NETREFUND = "43";        // 선불카드 사용 망취소
        }
        #endregion

        #region 해피 기프트 - 전문 요청구분
        public class POS_HAPPYGIFT_INQ_TYPE
        {
            /// <summary>
            /// 충전
            /// </summary>
            public const string RECHANGE = "100";           
            /// <summary>
            /// 조회
            /// </summary>
            public const string SEARCH = "110";             
            /// <summary>
            /// 충전 취소
            /// </summary>
            public const string RECHANGE_CANCEL = "120";    
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPROVAL = "200";           
            /// <summary>
            /// 취소
            /// </summary>
            public const string APPROVAL_CANCEL = "210";    
            // 환불 가능 조회
            public const string REFUND_SEARCH = "300";      
            /// <summary>
            /// 환불
            /// </summary>
            public const string REFUND = "310";             
            /// <summary>
            /// 환불 취소
            /// </summary>
            public const string REFUND_CANCEL = "320";      
        }
        #endregion

        #region 메인 포스 구분
        public class MAIN_POS_DIV
        {
            /// <summary>
            /// 주문 POS
            /// </summary>
            public const string SUB_POS = "0";
            /// <summary>
            /// 메인 POS
            /// </summary>
            public const string MAIN_POS = "1";
        }
        #endregion

        #region 암호화 구분
        public class ENCRYPT_MODE
        {
            /// <summary>
            /// 일반
            /// </summary>
            public const string ENC_OFF = "0";
            /// <summary>
            /// 암호화(AES256-BASE64)
            /// </summary>
            public const string ENC_ON = "1";
        }

        #endregion

        #region T페이 조회 업무구분
        /// <summary>
        /// T페이 조회 업무구분
        /// </summary>
        public class TPAY_SEARCH_TYPE
        {
            /// <summary>
            /// 카드프리픽스
            /// </summary>
            public const string PREFIX = "PREFIX";
            /// <summary>
            /// 통합결제 통신사(SKT) 할인 아이템
            /// </summary>
            public const string SKTDC_ITEM = "SKTDC_ITEM";
            /// <summary>
            /// 통합결제 T페이 결제 아이템
            /// </summary>
            public const string TPAY_ITEM = "TPAY_ITEM";
        } 
        #endregion

        #region T페이 거래 구분
        /// <summary>
        ///  T페이 거래 구분
        /// </summary>
        public class TPAY_TRADE_TYPE
        {
            /// <summary>
            /// 통합결제 (0 : SKT할인 + T페이결제)
            /// </summary>
            public const string COMPLEX = "0";
            /// <summary>
            /// 일반결제 (1 : T페이결제)
            /// </summary>
            public const string NORMAL = "1";
        } 
        #endregion

        #region TAKE_IN_OUT_DIV(TR_DETAIL(상품상세) - TAKE IN/OUT 구분)
        /// <summary>
        /// 상품 상세 TAKE IN/OUT 구분
        /// </summary>
        public class TAKE_IN_OUT_DIV
        {
            /// <summary>
            /// 0: TAKE_IN
            /// </summary>
            public const string TAKE_IN = "0";
            /// <summary>
            /// 1: TAKE_OUT
            /// </summary>
            public const string TAKE_OUT = "1";
        }
        #endregion

        #region BILL_PRT_LOC 영수증마스터 용도구분
        /// <summary>
        /// 영수증마스터 용도구분
        /// </summary>
        public class BILL_PRT_LOC
        {
            /// <summary>
            /// 0:명판
            /// </summary>
            public const string STAMP = "0";
            /// <summary>
            /// 1:상단메시지
            /// </summary>
            public const string TOP = "1";
            /// <summary>
            /// 2:하단메시지
            /// </summary>
            public const string BOTTOM = "2";
            /// <summary>
            /// 3:카드메시지
            /// </summary>
            public const string CARD = "3";
            /// <summary>
            /// 4:추가메시지
            /// </summary>
            public const string ADD = "4";
        }
        #endregion

        #region BILL_TYPE_DIV 영수증유형마스터 유형구분
        /// <summary>
        /// 영수증유형마스터 유형구분
        /// </summary>
        public class BILL_TYPE_DIV
        {
            /// <summary>
            /// 00:영수증 상단
            /// </summary>
            public const string TOP_INFO = "00";
            /// <summary>
            /// 01:합계정보
            /// </summary>
            public const string TOTAL = "01";
            /// <summary>
            /// 02:신용카드
            /// </summary>
            public const string CREDTCARD = "02";
            /// <summary>
            /// 03:포인트적립
            /// </summary>
            public const string POINT_SAVE = "03";
            /// <summary>
            /// 04:포인트사용
            /// </summary>
            public const string POINT_USE = "04";
            /// <summary>
            /// 80:정산지
            /// </summary>
            public const string ADMT_TRAN = "80";
            /// <summary>
            /// 81:정산 점검지
            /// </summary>
            public const string ADMT_REPORT = "81";
            /// <summary>
            /// 99:영수증 하단
            /// </summary>
            public const string BTM_INFO = "99";
        }
        #endregion

        #region SALE_DISP_SPCL_CHAR(판매 화면 특수 문자)
        /// <summary>
        /// 판매 화면 특수 문자
        /// </summary>
        public class SALE_DISP_SPCL_CHAR
        {
            /// <summary>
            /// 수량/금액 "√ "
            /// </summary>
            public const string QTY_AMT_CHR = ""; //"√ ";
            /// <summary>
            /// 할인금액 "% " -> "- " CS 요청 사항으로 변경!
            /// </summary>
            public const string DC_AMT_CHR = ""; //"-  ";
            /// <summary>
            /// 받은 금액 "@ "
            /// </summary>
            public const string RECV_AMT_CHR = ""; //"@ ";
            /// <summary>
            /// 부가세/서비스
            /// </summary>
            public const string VAT_SVC_CHR = ""; //"% ";
        }
        #endregion

        #region 각종 입력 데이터
        /// <summary>
        /// 각종 사유코드
        /// </summary>
        public class FRM_INPUT_DATA
        {
            /// <summary>
            /// 율
            /// </summary>
            public const string RATE = "RATE";
            /// <summary>
            /// 금액
            /// </summary>
            public const string AMT = "AMT";
            /// <summary>
            /// 주문번호
            /// </summary>
            public const string ORDERNO = "ORDERNO";
            /// <summary>
            /// 환경사랑
            /// </summary>
            public const string ELOVE = "ELOVE";
            /// <summary>
            /// 수량
            /// </summary>
            public const string QTY = "QTY";
            /// <summary>
            /// 거래번호
            /// </summary>
            public const string TRADENO = "TRADENO";
            /// <summary>
            /// POS번호
            /// </summary>
            public const string POSNO = "POSNO";
            /// <summary>
            /// 고객수
            /// </summary>
            public const string GUEST_CNT = "GUEST_CNT";
            /// <summary>
            /// 상품단가
            /// </summary>
            public const string PRICE = "PRICE";
            /// <summary>
            /// 승인번호
            /// </summary>
            public const string APPRNO = "APPRNO";
            
        }
        #endregion

        #region 준비금 합계 구분 코드
        /// <summary>
        /// 준비금 합계 구분 코드
        /// </summary>
        public class FRM_ACC_REMONEY_CODE
        {
            /// <summary>
            /// 준비금 합계 코드
            /// </summary>
            public const string TOTAL_REMONEY = "ZZ";

        }
        #endregion

        #region System Shutdown Defination (시스템종료 DEFINE)
        /// <summary>
        /// System Shutdown Defination (시스템종료 DEFINE)
        /// </summary>
        public class SYS_SHUTDOWN
        {
            /// <summary>
            /// System Shutdown (시스템 종료)
            /// </summary>
            public const string POWEROFF = "SHUTDOWN";  
            /// <summary>
            /// System Restart (시스템 재시작)
            /// </summary>
            public const string REBOOT = "REBOOT";
            /// <summary>
            /// Program Quit (프로그램 종료)
            /// </summary>
            public const string PGMQUIT = "PGMQUIT"; 
            /// <summary>
            /// Program Restart (프로그램 재시작)
            /// </summary>
            public const string PGMRESTART = "PGMRESTART"; 
            /// <summary>
            /// Log Off (로그 OFF)
            /// </summary>
            public const string LOGOFF = "LOGOFF"; 
        }
        #endregion

        #region 프로그램 업데이트 유형
        /// <summary>
        /// 프로그램 업데이트 유형
        /// </summary>
        public class PGM_UPDATE_TYPE
        {
            /// <summary>
            /// 00:전체
            /// </summary>
            public const string POSDOWN_GROUP_ALL = "00";
            public class POSDOWN_GROUP_ALL_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
            }

            /// <summary>
            /// 10:이미지
            /// </summary>
            public const string POSDOWN_GROUP_10 = "10";
            public class POSDOWN_GROUP_10_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
                /// <summary>
                /// 04:상품 이미지
                /// </summary>
                public const string ITEM_IMAGE = "04";
                /// <summary>
                /// 05:캠페인
                /// </summary>
                public const string CAMPAIGN = "05";
                /// <summary>
                /// 06:TEST 모드
                /// </summary>
                public const string TEST_MODE = "06";
                /// <summary>
                /// 07:POS 운영 이미지
                /// </summary>
                public const string CONTENTS = "07";

                /// <summary>
                /// 2019-03-28 - 1997fx11 : Kiosk 관련 추가
                /// </summary>
                public const string ITEM = "11";
                public const string OPTN = "12";
                public const string CAMPN = "13";
                public const string CATE = "14";
                public const string SCREEN = "15";
                public const string PRESENT = "16";
                public const string TAG = "17";
                public const string LOGO = "18";
            }

            /// <summary>
            /// 11:POS 이미지
            /// </summary>
            public const string POSDOWN_GROUP_11 = "11";
            public class POSDOWN_GROUP_11_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
                /// <summary>
                /// 03:고객화면
                /// </summary>
                public const string CUSTOMER = "03";
                /// <summary>
                /// 04:상품 이미지
                /// </summary>
                public const string ITEM_IMAGE = "04";
            }

            /// <summary>
            /// 20:프로그램
            /// </summary>
            public const string POSDOWN_GROUP_20 = "20";
            public class POSDOWN_GROUP_20_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
                /// <summary>
                /// 10:프로그램
                /// </summary>
                public const string POS_PGM10 = "10";
                /// <summary>
                /// 11:프로그램
                /// </summary>
                public const string POS_PGM11 = "11";
                /// <summary>
                /// 12:프로그램
                /// </summary>
                public const string POS_PGM12 = "12";
                /// <summary>
                /// 13:프로그램
                /// </summary>
                public const string POS_PGM13 = "13";
                /// <summary>
                /// 14:프로그램
                /// </summary>
                public const string POS_PGM14 = "14";
                /// <summary>
                /// 15:프로그램
                /// </summary>
                public const string POS_PGM15 = "15";
                /// <summary>
                /// 16:프로그램
                /// </summary>
                public const string POS_PGM16 = "16";
                /// <summary>
                /// 17:프로그램
                /// </summary>
                public const string POS_PGM17 = "17";
                /// <summary>
                /// 18:프로그램
                /// </summary>
                public const string POS_PGM18 = "18";
                /// <summary>
                /// 19:프로그램
                /// </summary>
                public const string POS_PGM19 = "19";
            }

            /// <summary>
            /// 30:영수증 로고 이미지
            /// </summary>
            public const string POSDOWN_GROUP_30 = "30";
            public class POSDOWN_GROUP_30_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
                /// <summary>
                /// 20:영수증 로고 이미지
                /// </summary>
                public const string RCPTLOGO_IMAGE = "20";
            }

            /// <summary>
            /// 40:서명패드 펌웨어
            /// </summary>
            public const string POSDOWN_GROUP_40 = "40";
            public class POSDOWN_GROUP_40_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";

                /// <summary>
                /// 서명패드 모델 (SSP-100)
                /// </summary>
                public const string SIGNPAD_MODEL_SSP_100 = "SSP-100";
                /// <summary>
                /// 서명패드 모델 (SN-350P)
                /// </summary>
                public const string SIGNPAD_MODEL_SN_350P = "SN-350P";
                /// <summary>
                /// 서명패드 모델 (SN-150P)
                /// </summary>
                public const string SIGNPAD_MODEL_SN_150P = "SN-150P";
                /// <summary>
                /// 서명패드 모델 (SR-170P)
                /// </summary>
                public const string SIGNPAD_MODEL_SR_170P = "SR-170P";
                /// <summary>
                /// 서명패드 모델 (OLTMS)
                /// </summary>
                public const string SIGNPAD_MODEL_OLTMS = "OLTMS";
                /// <summary>
                /// 서명패드 모델 (OLCSP)
                /// </summary>
                public const string SIGNPAD_MODEL_OLCSP = "OLCSP";

                /// <summary>
                /// 01:서명패드 펌웨어 (SSP-100 IC)
                /// </summary>
                public const string SIGNPAD_01 = "01";
                /// <summary>
                /// 02:서명패드 펌웨어 (SN-350P IC)
                /// </summary>
                public const string SIGNPAD_02 = "02";
                /// <summary>
                /// 03:서명패드 펌웨어 (SN-150P IC)
                /// </summary>
                public const string SIGNPAD_03 = "03";
                /// <summary>
                /// 04:서명패드 펌웨어 (SR-170P IC)
                /// </summary>
                public const string SIGNPAD_04 = "04";
                /// <summary>
                /// 05:서명패드 펌웨어 (OLTMS IC)
                /// </summary>
                public const string SIGNPAD_05 = "05";
                /// <summary>
                /// 06:서명패드 펌웨어 (OLCSP IC)
                /// </summary>
                public const string SIGNPAD_06 = "06";

                /// <summary>
                /// 51:서명패드 펌웨어 (SSP-100 MSR)
                /// </summary>
                public const string SIGNPAD_51 = "51";
                /// <summary>
                /// 52:서명패드 펌웨어 (SN-350P MSR)
                /// </summary>
                public const string SIGNPAD_52 = "52";
                /// <summary>
                /// 53:서명패드 펌웨어 (SN-150P MSR)
                /// </summary>
                public const string SIGNPAD_53 = "53";
                /// <summary>
                /// 54:서명패드 펌웨어 (SR-170P MSR)
                /// </summary>
                public const string SIGNPAD_54 = "54";
                /// <summary>
                /// 55:서명패드 펌웨어 (OLTMS MSR)
                /// </summary>
                public const string SIGNPAD_55 = "55";
                /// <summary>
                /// 56:서명패드 펌웨어 (OLCSP MSR)
                /// </summary>
                public const string SIGNPAD_56 = "56"; 
            }

            /// <summary>
            /// 50:서명패드 동영상
            /// </summary>
            public const string POSDOWN_GROUP_50 = "50";
            public class POSDOWN_GROUP_50_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";

                /// <summary>
                /// 01:서명패드 동영상 (SSP-100)
                /// </summary>
                public const string SIGNPAD_01 = "01";
                /// <summary>
                /// 02:서명패드 동영상 (SN-350P)
                /// </summary>
                public const string SIGNPAD_02 = "02";
                /// <summary>
                /// 03:서명패드 동영상 (SN-150P)
                /// </summary>
                public const string SIGNPAD_03 = "03";
                /// <summary>
                /// 04:서명패드 동영상 (SR-170P)
                /// </summary>
                public const string SIGNPAD_04 = "04";
                /// <summary>
                /// 05:서명패드 동영상 (OLTMS)
                /// </summary>
                public const string SIGNPAD_05 = "05";
                /// <summary>
                /// 06:서명패드 동영상 (OLCSP)
                /// </summary>
                public const string SIGNPAD_06 = "06"; 
            }

            /// <summary>
            /// 60:서명패드 이미지
            /// </summary>
            public const string POSDOWN_GROUP_60 = "60";
            public class POSDOWN_GROUP_60_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";

                /// <summary>
                /// 01:서명패드 이미지 (SSP-100)
                /// </summary>
                public const string SIGNPAD_01 = "01";
                /// <summary>
                /// 02:서명패드 이미지 (SN-350P)
                /// </summary>
                public const string SIGNPAD_02 = "02";
                /// <summary>
                /// 03:서명패드 이미지 (SN-150P)
                /// </summary>
                public const string SIGNPAD_03 = "03";
                /// <summary>
                /// 04:서명패드 이미지 (SR-170P)
                /// </summary>
                public const string SIGNPAD_04 = "04";
                /// <summary>
                /// 05:서명패드 이미지 (OLTMS)
                /// </summary>
                public const string SIGNPAD_05 = "05";
                /// <summary>
                /// 06:서명패드 이미지 (OLCSP)
                /// </summary>
                public const string SIGNPAD_06 = "06"; 
            }

            /// <summary>
            /// 70:IC리더기 업데이트
            /// </summary>
            public const string POSDOWN_GROUP_70 = "70";
            public class POSDOWN_GROUP_70_DIV
            {
                /// <summary>
                /// 해당그룹전체
                /// </summary>
                public const string ALL_PGM = "00";
                //#20171016 IC리더기 펌웨어 업데이트 Start, srlee
                /// <summary>
                /// IC리더기 모델 (SR-440P)
                /// </summary>
                public const string IC_READER_MODEL_SR_440P = "SR-440P";
                //#20171016 IC리더기 펌웨어 업데이트 End, srlee
                /// <summary>
                /// IC리더기 01
                /// </summary>
                public const string IC_READER_01 = "01";
            } 
        }

        /// <summary>
        /// 프로그램 업데이트 요청 구분
        /// </summary>
        public class PGM_UPDATE_DOWN_DIV
        {
            /// <summary>
            /// A:전체
            /// </summary>
            public const string ALL = "A";
            /// <summary>
            /// U:변경분
            /// </summary>
            public const string UPDATE = "U";
            /// <summary>
            /// T:최초 (전체 + 변경분)
            /// </summary>
            public const string TOTAL = "T";
        }
        #endregion

        //#region 다운로드 목록 정의 값
        ///// <summary>
        ///// 다운로드 목록 정의 값
        ///// </summary>
        //public class DOWNLOAD_KIND_DIV
        //{
        //    /// <summary>
        //    /// 01:프로그램
        //    /// </summary>
        //    public const string POS_PGM01 = "01";
        //    /// <summary>
        //    /// 02:프로그램
        //    /// </summary>
        //    public const string POS_PGM02 = "02";

        //    /// <summary>
        //    /// 고객창 이미지
        //    /// </summary>
        //    public const string CUSTOMER_IMG = "03";
        //    /// <summary>
        //    /// 상품 이미지
        //    /// </summary>
        //    public const string ITEM_IMG = "04";
        //    /// <summary>
        //    /// 캠페인 이미지
        //    /// </summary>
        //    public const string CAMPAIGN_IMG = "05";
        //    /// <summary>
        //    /// TEST 모드 이미지
        //    /// </summary>
        //    public const string TEST_MODE_IMG = "06";
        //    /// <summary>
        //    /// CDP 이미지
        //    /// </summary>
        //    public const string CDP_IMG = "07";
        //    /// <summary>
        //    /// 기타 파일
        //    /// </summary>
        //    public const string ETC_IMG = "08";

        //    /// <summary>
        //    /// 10:프로그램
        //    /// </summary>
        //    public const string POS_PGM10 = "10";
        //    /// <summary>
        //    /// 11:프로그램
        //    /// </summary>
        //    public const string POS_PGM11 = "11";
        //    /// <summary>
        //    /// 12:프로그램
        //    /// </summary>
        //    public const string POS_PGM12 = "12";
        //    /// <summary>
        //    /// 13:프로그램
        //    /// </summary>
        //    public const string POS_PGM13 = "13";
        //    /// <summary>
        //    /// 14:프로그램
        //    /// </summary>
        //    public const string POS_PGM14 = "14";
        //    /// <summary>
        //    /// 15:프로그램
        //    /// </summary>
        //    public const string POS_PGM15 = "15";
        //    /// <summary>
        //    /// 16:프로그램
        //    /// </summary>
        //    public const string POS_PGM16 = "16";
        //    /// <summary>
        //    /// 17:프로그램
        //    /// </summary>
        //    public const string POS_PGM17 = "17";
        //    /// <summary>
        //    /// 18:프로그램
        //    /// </summary>
        //    public const string POS_PGM18 = "18";
        //    /// <summary>
        //    /// 19:프로그램
        //    /// </summary>
        //    public const string POS_PGM19 = "19";

        //    /// <summary>
        //    /// 영수증 로고 이미지
        //    /// </summary>
        //    public const string RCPT_LOGO_IMG = "20";
        //    /// <summary>
        //    /// 서명패드 펌웨어
        //    /// </summary>
        //    public const string SIGNPAD_FIRM = "21";
        //    /// <summary>
        //    /// 서명패드 동영상
        //    /// </summary>
        //    public const string SIGNPAD_AVI = "22";
        //    /// <summary>
        //    /// 서명패드 이미지
        //    /// </summary>
        //    public const string SIGNPAD_IMG = "23";
        //}
        //#endregion 

        #region 아워홈 결제 구분
        /// <summary>
        /// 아워홈 결제 구분
        /// </summary>
        public class OURHOME_TRAN_TYPE
        {
            /// <summary>
            /// 003:정상
            /// </summary>
            public const string NORMAL = "003";
            /// <summary>
            /// 013:반품
            /// </summary>
            public const string REFUND = "013";
        }
        #endregion

        #region 마스터 다운 방식 구분
        public class MASTER_DOWN_OP
        {
            /// <summary>
            /// 마스터 전체 다운로드
            /// </summary>
            public const string ALL = "ALL";
            /// <summary>
            /// 마스터 변경분 다운로드
            /// </summary>
            public const string CHANGED = "CHANGED";
            /// <summary>
            /// 캠페인 관련 마스터 전체 다운로드
            /// </summary>
            public const string ALL_CAMPAIGN = "ALL_CAMPAIGN";
        }
        #endregion

        #region 주변장비 체크 여부
        public class POS_PERIPHERAL_CHECK
        {
            /// <summary>
            /// 주변장비 체크 사용
            /// </summary>
            public const string CHECK = "CHECK";
            /// <summary>
            /// 주변장비 체크 미사용
            /// </summary>
            public const string NO_CHECK = "NO_CHECK";
        }
        #endregion 

        #region 마스터 이미지 경로
        public class MST_IMG_PATH
        {
            /// <summary>
            /// 상품 관련 이미지
            /// </summary>
            public const string ITEM = @"ITEM\";
            /// <summary>
            /// 캠페인 관련 이미지 및 동영상
            /// </summary>
            public const string CAMPAIGN = @"CAMPAIGN\";
            /// <summary>
            /// 고객화면 관련 이미지 및 동영상
            /// </summary>
            public const string CUSTOMER =  @"CUSTOMER\";
            /// <summary>
            /// 시험관련 이미지 및 동영상
            /// </summary>
            public const string TEST_MODE = @"TEST_MODE\";
            /// <summary>
            /// MOT, CI 등 기타 공통 이미지 및 동영상
            /// </summary>
            public const string CDP_COM = @"CDP_COM\";
            public const string RLOGO = @"RLOGO\";
            /// <summary>
            /// 옵션 관련 이미지
            /// </summary>
            public const string OPTION = @"OPTN\";
        }
        #endregion

        #region 백업 파일 경로
        public class BACKUP_PATH
        {
            /// <summary>
            /// 프로그램
            /// </summary>
            public const string PGM = @"PGM\";
            /// <summary>
            /// 데이터베이스
            /// </summary>
            public const string DB = @"DB\";
            /// <summary>
            /// 서명패드
            /// </summary>
            public const string SIGNPAD = @"SIGNPAD\";
            //#20171016 IC리더기 펌웨어 업데이트 Start, srlee
            /// <summary>
            /// IC리더기
            /// </summary>
            public const string ICREADER = @"ICREADER\";
            //#20171016 IC리더기 펌웨어 업데이트 End, srlee

            //  2019-05-16 -1997fx11 : Kiosk용 백업경로
            public const string KIOSK = @"KIOSK\";
        }
        #endregion

        #region 브랜드코드
        public class MST_BRAND_CODE
        {
            /// <summary>
            /// 파리크라상
            /// </summary>
            public const string PC_PC = "001";	
            /// <summary>
            /// 파리바게뜨
            /// </summary>
            public const string PC_PB = "002";	
            /// <summary>
            /// 르노뜨르
            /// </summary>
            public const string PC_LT = "003";	
            /// <summary>
            /// 리나스
            /// </summary>
            public const string PC_LC = "004";	
            /// <summary>
            /// 파스쿠찌
            /// </summary>
            public const string PC_CP = "005";	
            /// <summary>
            /// 파리스키친
            /// </summary>
            public const string PC_PK = "006";	
            /// <summary>
            /// 타마티
            /// </summary>
            public const string PC_TT = "007";	
            /// <summary>
            /// 아멜리
            /// </summary>
            public const string PC_AL = "008";	
            /// <summary>
            /// Passion5
            /// </summary>
            public const string PC_PS = "009";	
            /// <summary>
            /// 퀸스파크
            /// </summary>
            public const string PC_QP = "010";	
            /// <summary>
            /// 해외법인SPC
            /// </summary>
            public const string PC_OS = "011";	
            /// <summary>
            /// 라그릴리아
            /// </summary>
            public const string PC_LL = "012";	
            /// <summary>
            /// 월드바인
            /// </summary>
            public const string PC_WB = "013";	
            /// <summary>
            /// 컨세션사업
            /// </summary>
            public const string PC_CB = "015";	
            /// <summary>
            /// 라브리
            /// </summary>
            public const string PC_LB = "017";	
            /// <summary>
            /// 베라피자나폴리
            /// </summary>
            public const string PC_BP = "018";	
            /// <summary>
            /// 쁘띠5
            /// </summary>
            public const string PC_BD = "019";	
            /// <summary>
            /// strEAT
            /// </summary>
            public const string PC_SE = "020";	
            /// <summary>
            /// Coffee@Works
            /// </summary>
            public const string PC_CW = "023";	
            /// <summary>
            /// 잠바주스
            /// </summary>
            public const string PC_JJ = "014";	
            /// <summary>
            /// 한상차림
            /// </summary>
            public const string PC_HC = "022";	
            /// <summary>
            /// 라뜰리에
            /// </summary>
            public const string PC_LE = "021";	
            /// <summary>
            /// 팔러
            /// </summary>
            public const string PC_PL = "016";	
            /// <summary>
            /// 푸드코트
            /// </summary>
            public const string PC_FC = "024";	
            /// <summary>
            /// 그릭슈바인
            /// </summary>
            public const string PC_GS = "026";	
            /// <summary>
            /// 타이거인터내셔널
            /// </summary>
            public const string PC_TI = "027";	
            /// <summary>
            /// 쉐이크쉑
            /// </summary>
            public const string PC_SS = "029";	
            /// <summary>
            /// 스퀘어통합
            /// </summary>
            public const string PC_SC = "090";	
            /// <summary>
            /// 타브랜드
            /// </summary>
            public const string PC_EB = "030";	
            /// <summary>
            /// 특수거래처
            /// </summary>
            public const string PC_SL = "028";	
            /// <summary>
            /// 던킨도너츠
            /// </summary>
            public const string BR_DD = "5000";	
            /// <summary>
            /// 배스킨라빈스
            /// </summary>
            public const string BR_BR = "3000";	
            /// <summary>
            /// 사누끼보레
            /// </summary>
            public const string SL_SG = "7000";	
            /// <summary>
            /// 빚은
            /// </summary>
            public const string SL_BE = "8000";	
            /// <summary>
            /// 벨에삐
            /// </summary>
            public const string SL_BB = "8800";	
            /// <summary>
            /// 르뽀미에
            /// </summary>
            public const string SL_LM = "1000";	
            /// <summary>
            /// 그릭슈바인
            /// </summary>
            public const string SL_GS = "2000";	
            /// <summary>
            /// 델리가든
            /// </summary>
            public const string SL_DG = "9000";	
            /// <summary>
            /// 삼립GFS
            /// </summary>
            public const string SL_SL = "3100";	
            /// <summary>
            /// BZ+LP
            /// </summary>
            public const string SL_BL = "8100";	
            /// <summary>
            /// BZ+차오름
            /// </summary>
            public const string SL_BC = "8200";	
            /// <summary>
            /// str)EAT
            /// </summary>
            public const string SL_SE = "6000";	
            /// <summary>
            /// eat2go
            /// </summary>
            public const string SL_EG = "1100";	
            /// <summary>
            /// 하이면
            /// </summary>
            public const string SL_HM = "8300";	
            /// <summary>
            /// PB(SH)-중국
            /// </summary>
            public const string PC_SH = "5000";
            /// <summary>
            /// PB(BJ)-중국
            /// </summary>
            public const string PC_BJ = "8000";
            /// <summary>
            /// TM(SH)-중국
            /// </summary>
            public const string PC_TM = "2000";	
            /// <summary>
            /// PB(NJ)-중국
            /// </summary>
            public const string PC_NJ = "9000";	
            /// <summary>
            /// PB(HZ)-중국
            /// </summary>
            public const string PC_HZ = "7000";
            /// <summary>
            /// PB(DL)-중국
            /// </summary>
            public const string PC_DL = "3000";
            /// <summary>
            /// PB(CD)-중국
            /// </summary>
            public const string PC_CD = "4000";
            /// <summary>
            /// PB(HCM)-베트남
            /// </summary>
            public const string PC_HM = "100";
            /// <summary>
            /// PB(HN)-베트남
            /// </summary>
            public const string PC_HN = "200";		
            /// <summary>
            /// Singapore-싱가포르
            /// </summary>
            public const string PC_SP = "101";
            /// <summary>
            /// PB France-프랑스
            /// </summary>
            public const string PC_FR = "3100";
            /// <summary>
            /// WB-미국
            /// </summary>
            public const string PC_UW = "1000";
            /// <summary>
            /// PB(NY)-미국
            /// </summary>
            public const string PC_UY = "2100";
            /// <summary>
            /// PB(SC)-미국
            /// </summary>
            public const string PC_US = "2000";
            /// <summary>
            /// PB(NC)-미국
            /// </summary>
            public const string PC_UC = "2300";
            /// <summary>
            /// 미국
            /// </summary>
            public const string PC_AM = "9999";
        }
        #endregion

        #region ORDER_CALLCENTER => 콜센터 배달
        /// <summary>
        /// 콜센터 배달
        /// </summary>
        public class ORDER_CALLCENTER
        {
            /// <summary>
            /// 콜센터 배달 상품 코드
            /// </summary>
            public const string PLU_CD = "N86053";
        }
        #endregion

        #region Card Reader Device 유형
        /// <summary>
        /// Card Reader Device 유형
        /// </summary>
        public class POS_CARD_READER_DEVICE_TYPE
        {
            /// <summary>
            /// IC
            /// </summary>
            public const string IC_READER = "IC";
            /// <summary>
            /// 서명패드
            /// </summary>
            public const string SAIGNPAD = "SIGNPAD";
            /// <summary>
            /// TMONEY  
            /// </summary>
            public const string TMONEY = "T";
            /// <summary>
            /// CASHBEE 
            /// </summary>
            public const string CASHBEE = "E";
            /// <summary>
            /// PayOn 
            /// </summary>
            public const string PAYON = "Y";
        }
        #endregion

        #region SCFBA_PROC_TYPE(여전법 처리 구분)
        /// <summary>
        /// 무결성 처리 구분
        /// </summary>
        public class SCFBA_PROC_TYPE
        {
            /// <summary>
            /// 자동
            /// </summary>
            public const string AUTO = "A";
            /// <summary>
            /// 수동
            /// </summary>
            public const string MANUAL = "M";
        }
        #endregion

        #region SCFBA_BIZ_PROC_TYPE(여전법 업무 구분)
        /// <summary>
        /// 여전법 업무 처리 구분
        /// </summary>
        public class SCFBA_BIZ_TYPE
        {
            /// <summary>
            /// 무결성
            /// </summary>
            public const string INTEGRITY = "01";
            /// <summary>
            /// 상호인증
            /// </summary>
            public const string CERTIFICATION = "02";
            /// <summary>
            /// 운영정보 다운로드
            /// </summary>
            public const string BIZDOWNLOAD = "03";
            /// <summary>
            /// 교통카드 개시
            /// </summary>
            public const string OPENSTART = "04";
        }
        #endregion

        #region 영수증로고 Upload 구분
        public class LOGO_UPLOAD_DIV
        {
            /// <summary>
            /// 업로드 안 함
            /// </summary>
            public const string NO = "0";
            /// <summary>
            /// 업로드 함(업로드 이후 0으로 변경 됨)
            /// </summary>
            public const string YES = "1";
        }
        #endregion 영수증로고 Upload 구분

        #region RE_TRANSACTIONDATA(서버 전송 데이터 구분)
        /// <summary>
        /// 서버 전송 데이터 구분
        /// </summary>
        public class RE_TRANSACTIONDATA
        {
            /// <summary>
            /// 점주 알바 모드 전송
            /// </summary>
            public const string OWNER_MODE = "OWNER_MODE";

        }
        #endregion

        #region CAMPAIGN_PAY_KEY(캠페인 결제 순번(취소시사용))
        /// <summary>
        /// 캠페인 결제 순번(취소시사용)
        /// </summary>
        public class CAMPAIGN_PAY_KEY
        {
            /// <summary>
            /// 해피포인트 할인
            /// </summary>
            public const string HP_DIS = "10000";
            /// <summary>
            /// 해피포인트 적립
            /// </summary>
            public const string HP_SAVE = "20000";

        }
        #endregion

        #region 인코딩 구분
        public class ENCODING_FLAG
        {
            /// <summary>
            /// UTF-8
            /// </summary>
            public const string UTF = "UTF";
            /// <summary>
            /// ks_c_5601-1987
            /// </summary>
            public const string KSC = "KSC";
        }
        #endregion

        #region 점포점검 체크 구분
        public class STORE_CHECK_FLAG
        {
            /// <summary>
            /// 점포점검(개점)
            /// </summary>
            public const string STORE_OPEN_CHECK = "STORE_OPEN_CHECK";
            /// <summary>
            /// 점포점검(마감)
            /// </summary>
            public const string STORE_CLOSE_CHECK = "STORE_CLOSE_CHECK";
            /// <summary>
            /// 점포점검(LOGIN)
            /// </summary>
            public const string STORE_LOGIN_CHECK = "STORE_LOGIN_CHECK";
            /// <summary>
            /// 유통기한 점검
            /// </summary>
            public const string EXPIRATION_DATE_CHECK = "EXPIRATION_DATE_CHECK";
            /// <summary>
            /// 식품안전의 날 점검
            /// </summary>
            public const string FOOD_SAFETY_DAY_CHECK = "FOOD_SAFETY_DAY_CHECK";
        }
        #endregion

        #region 영수증 정렬유형
        public class PRT_ALIGN_TYPE
        {
            /// <summary>
            /// 오른쪽(1)
            /// </summary>
            public const string RIGHT = "1";
            /// <summary>
            /// 가운데(2)
            /// </summary>
            public const string CENTER = "2";
            /// <summary>
            /// 왼쪽(3)
            /// </summary>
            public const string LEFT = "3";
        }
        #endregion

        #region 영수증 확대유형
        public class PRT_EXPAND_TYPE
        {
            /// <summary>
            /// 보통(0)
            /// </summary>
            public const string NOMAL = "0";
            /// <summary>
            /// 진하게(1)
            /// </summary>
            public const string BOLD = "1";
            /// <summary>
            /// 가로확대(2)
            /// </summary>
            public const string HOR = "2";
            /// <summary>
            /// 세로확대(3)
            /// </summary>
            public const string VER = "3";
            /// <summary>
            /// 전체확대(4)
            /// </summary>
            public const string BOTH = "4";
        }
        #endregion

        #region 해피버즈 업무 타입
        public class HAPPYBUZZ_BIZ_TYPE
        {
            /// <summary>
            /// 저장
            /// </summary>
            public const string SET = "SET";
            /// <summary>
            /// 취소
            /// </summary>
            public const string CAN = "CAN";
            /// <summary>
            /// WEB호출
            /// </summary>
            public const string WEB = "WEB";
        }
        #endregion

        #region 해피버즈 서브 URL
        public class HAPPYBUZZ_SUB_URL
        {
            /// <summary>
            /// 저장
            /// </summary>
            public const string SET = "/api/pos/regist";
            /// <summary>
            /// 취소
            /// </summary>
            public const string CAN = "/api/pos/cancel";
            /// <summary>
            /// WEB호출
            /// </summary>
            public const string WEB = "/view/pos/list";
        }
        #endregion

        #region SaleMainForm 호출자 구분
        public class SAL_MAIN_FORM_CALLER_TYPE
        {
            /// <summary>
            /// 테이블 서비스
            /// </summary>
            public const string TABLE_SVC = "TABLE_SVC";
            /// <summary>
            /// 해피오더/양재오더
            /// </summary>
            public const string HPORD = "HPORD";
        }
        #endregion

        #region MEDIA_FILE_DIV(미디어 파일구분)
        public class MEDIA_FILE_DIV
        {
            /// <summary>
            /// 1:이미지
            /// </summary>
            public const string IMAGE = "1";
            /// <summary>
            /// 2:동영상
            /// </summary>
            public const string MOVIE = "2";
        }
        #endregion

        #region 테이블 예약 조회업무 구분
        /// <summary>
        /// 테이블 예약 조회업무 구분
        /// </summary>
        public class TABLE_RESERVE_SEARCH_TYPE
        {
            /// <summary>
            /// 예약번호로 조회
            /// </summary>
            public const string TABLE_RESERVE_NO = "TABLE_RESERVE_NO";
            /// <summary>
            /// 예약년월로 조회
            /// </summary>
            public const string TABLE_RESERVE_YM = "TABLE_RESERVE_YM";
            /// <summary>
            /// 예약알람 대상 조회
            /// </summary>
            public const string TABLE_RESERVE_ALRAM = "TABLE_RESERVE_ALRAM";
        } 
        #endregion

        #region Measuring Agent 출력 구분
        //public class MEASURING_AGENT_PRINT_MODE
        //{
        //    /// <summary>
        //    /// 중량 출력-일반
        //    /// </summary>
        //    public const string NORMAL = "NORMAL";
        //    /// <summary>
        //    /// 중량 출력-해피오더
        //    /// </summary>
        //    public const string HAPPY_ORDER = "HAPPY_ORDER";
        //}
        public enum MEASURING_AGENT_PRINT_MODE
        {
            NORMAL,
            HAPPY_ORDER
        }
        #endregion Measuring Agent 출력 구분

        #region 온라인쿠폰 종류
        /// <summary>
        /// 온라인쿠폰 종류
        /// </summary>
        public class ONLINE_CPN_KIND
        {
            /// <summary>
            /// 1:교환권[액면금액 결제처리 하고, 잔액(액면금액-점포판매가)은 금액할인처리]
            /// </summary>
            public const string CHANGE = "1";
            /// <summary>
            /// 2:증정권[금액과 상관없이 해당상품 무료증정(할인 처리)]
            /// </summary>
            public const string PRESENT = "2";
            /// <summary>
            /// 3:금액권[발행가 결제처리 하고, 할인금액(액면가-발행가) 발생시 전체상품에 할인 처리]
            /// </summary>
            public const string AMTPAY = "3";
            /// <summary>
            /// 4:할인권[상품상관없이 할인금액만큼 전체상품에 할인 처리]
            /// </summary>
            public const string DISCOUNT = "4";
            /// <summary>
            /// 5:상품지정할인권[해당 상품에 할인금액 만큼 할인 처리]
            /// </summary>
            public const string PLUDIS = "5";
        }
        #endregion

        #region CAT Model 구분
        /// <summary>
        /// CAT Model 구분
        /// </summary>
        public class CAT_MODEL_DIV
        {
            /// <summary>
            /// 국내 SPCN
            /// </summary>
            public const string _KOR_SPCN = "11";

            /// <summary>
            /// 중죽 샨더
            /// </summary>
            public const string _CHN_SAND = "21";
            /// <summary>
            /// 중국 은련
            /// </summary>
            public const string _CHN_UNION = "22";

        }
        #endregion 

        #region CustDisplay 관련 구조체

        /// <summary>
        /// 실행중 상태값
        /// </summary>
        public class CUST_WOKRING
        {
            /// <summary>
            /// 실행중
            /// </summary>
            public const string PLAY = "PLAY";
            /// <summary>
            /// 중지
            /// </summary>
            public const string STOP = "STOP";
        }

        /// <summary>
        /// 통신방식
        /// </summary>
        public class CUST_SYNC
        {
            /// <summary>
            /// Sync
            /// </summary>
            public const string PP_SYNC = "SYNC";
            /// <summary>
            /// An Sync
            /// </summary>
            public const string PP_ASYNC = "ASYNC";
        }

        public class CUST_PIPE_NAME
        {
            /// <summary>
            /// 동영상 플레이어
            /// </summary>
            public const string CUST_DOUALPLAY = "xSpcDualPlayerServer"; //"POS DUALPLAYER SERVER";
            /// <summary>
            /// 포스 서버
            /// </summary>
            public const string CUST_POS_SERVER = "xSpcDualPosServer"; //"POS SERVER";
            /// <summary>
            /// 프로세스명
            /// </summary>
            public const string CUST_PROCESS = "dualPlayer";
            /// <summary>
            /// 프로세스명(확장자)
            /// </summary>
            public const string CUST_PROCESS_EX = "dualPlayer.exe";

        }

        /// <summary>
        /// 시리얼 변환 프로그램
        /// </summary>
        public class MSR_SERIAL_EMULATOR
        {
            /// <summary>
            /// 실행 파일
            /// </summary>
            public const string APP_FILE = "O2MSR.exe";
            /// <summary>
            /// 프로세스명
            /// </summary>
            public const string APP_PROCESS = "O2MSR";
            /// <summary>
            /// 환경설정 파일
            /// </summary>
            public const string CFG_FILE = "O2MSR.Conf";
            /// <summary>
            /// 구 연동 프로세스
            /// </summary>
            public const string OLD_APP_PROCESS = "TECMCR";
        }

        /// <summary>
        /// 공항공사 I/F 프로그램
        /// </summary>
        public class KAC_AGENT
        {
            /// <summary>
            /// 실행 파일
            /// </summary>
            public const string APP_FILE = @"C:\KACAgent\KACAgent.exe";
            /// <summary>
            /// 프로세스명
            /// </summary>
            public const string APP_PROCESS = "KACAgent";
        }
        
        /// <summary>
        /// 전송 아이디
        /// </summary>
        public class CUST_TRAN_ID
        {
            /// <summary>
            /// 1번 픽처 - SEND
            /// </summary>
            public const string PIC1 = "1001";
            /// <summary>
            /// 2번 픽처 - SEND
            /// </summary>
            public const string PIC2 = "2001";

            /// <summary>
            /// 1번 픽처 - RECV
            /// </summary>
            public const string R_PIC1 = "1000";
            /// <summary>
            /// 2번 픽처 - RECV
            /// </summary>
            public const string R_PIC2 = "2000";

        }

        /// <summary>
        /// 가변 값
        /// </summary>
        public class CUST_VARIABLE
        {
            /// <summary>
            /// $1B
            /// </summary>
            public const char ESC = (char)0x1B;
            /// <summary>
            /// $1D
            /// </summary>
            public const char GS = (char)0x1D;
            /// <summary>
            /// $1C
            /// </summary>
            public const char FS = (char)0x1C;
            /// <summary>
            /// $0D
            /// </summary>
            public const char CR = (char)0x0D;
            /// <summary>
            /// $0A
            /// </summary>
            public const char LF = (char)0x0A;
            /// <summary>
            /// $09
            /// </summary>
            public const char HT = (char)0x09;
            /// <summary>
            /// $0C
            /// </summary>
            public const char FF = (char)0x0C;
            /// <summary>
            /// $18
            /// </summary>
            public const char CAN = (char)0x18;
            /// <summary>
            /// $10
            /// </summary>
            public const char DLE = (char)0x10;
        }

        #endregion

        #region 긴급공지 읽음 플래그
        /// <summary>
        /// 긴급공지 읽음 플래그
        /// </summary>
        public class MST_EMG_NOTE_READ_FLAG
        {
            /// <summary>
            /// 표시
            /// </summary>
            public const string SHOW = "1";
            /// <summary>
            /// 확인 완료
            /// </summary>
            public const string FINSH = "2";
        }
        #endregion

        #region FTP 접속 타입
        /// <summary>
        /// FTP 접속 타입
        /// </summary>
        public class FTP_CONN_TYPE
        {
            /// <summary>
            /// Active mode
            /// </summary>
            public const string ACTIVE = "0";
            /// <summary>
            /// Passive mode
            /// </summary>
            public const string PASSIVE = "1";
        }
        #endregion

        #region XCHARGE 관련 플래그
        /// <summary>
        /// XCHARGE 관련 플래그
        /// </summary>
        public class XCHARGE
        {
            /// <summary>
            /// 승인구분
            /// </summary>
            public const string TRANSACTION = "XCHAGE";
            /// <summary>
            /// 승인
            /// </summary>
            public const string APPR = "XCGA";
            /// <summary>
            /// 취소
            /// </summary>
            public const string VOID = "XCGC";
            /// <summary>
            /// DLL 파일명
            /// </summary>
            public const string DLL_FILE = "XCTransaction2.dll";

        }
        #endregion

        #region OCB 직통신
        /// <summary>
        /// POS VAN 
        /// </summary>
        public class POS_OCB_DIRECT
        {
            /// <summary>
            /// 가맹점 등록
            /// </summary>
            public const string STOR_REGISTER = "2A10";

            /// <summary>
            /// 가맹점 인증
            /// </summary>
            public const string STOR_AUTH = "2A20";

            /// <summary>
            /// 포인트 조회
            /// </summary>
            public const string INQ_POINT = "2M30";

            /// <summary>
            /// 포인트 적립
            /// </summary>
            public const string SAVE_POINT = "2100";

            /// <summary>
            /// 포인트 적립 취소
            /// </summary>
            public const string SAVE_CAN_POINT = "2110";

            /// <summary>
            /// 포인트 사용
            /// </summary>
            public const string USE_POINT = "2400";

            /// <summary>
            /// 포인트 사용 취소
            /// </summary>
            public const string USE_CAN_POINT = "2410";

            /// <summary>
            /// 망 취소
            /// </summary>
            public const string NET_CAN_POINT = "2NET";
        }
        #endregion 

        #region POS 알람유형(POS 점포 점검 마스터)
        /// <summary>
        /// POS 유형
        /// </summary>
        public class POS_CHECK_ALARM_TYPE
        {
            /// <summary>
            /// 없음
            /// </summary>
            public const string CHECK_TYPE_NONE = "0";
            /// <summary>
            /// 로그인
            /// </summary>
            public const string CHECK_TYPE_LOGIN = "1";
            /// <summary>
            /// 개점
            /// </summary>
            public const string CHECK_TYPE_SOD = "2";
            /// <summary>
            /// 마감
            /// </summary>
            public const string CHECK_TYPE_EOD = "3";
        }
        #endregion

        #region POS LOG파일 조회 요청 구분
        public class POS_LOGFILE_REQ_TYPE
        {
            /// <summary>
            /// "1":로그요청
            /// </summary>
            public const string LOGFILE_REQ = "1";
            /// <summary>
            /// "2":로그요청 응답
            /// </summary>
            public const string LOGFILE_RSP = "2";
            /// <summary>
            /// "3":로그파일 UPLOAD 완료
            /// </summary>
            public const string LOGFILE_UPLOAD = "3";
            /// <summary>
            /// "4":해당 로그파일 없음
            /// </summary>
            public const string NO_LOGFILE = "4";
            /// <summary>
            /// "5":로그파일 UPLOAD 실패
            /// </summary>
            public const string LOGFILE_UPLOAD_FAIL = "5";
        }
        #endregion

        #region 점포장비 일일점검리스트
        public class EquipCheckCode
        {
            /// <summary>
            /// 미점검
            /// </summary>
            public const string NO_CHECK = "0";
            /// <summary>
            /// 이상무
            /// </summary>
            public const string OK_CHECK = "1";
            /// <summary>
            /// 점검중
            /// </summary>
            public const string ING_CHECK = "2";
            /// <summary>
            /// 점검완료
            /// </summary>
            public const string FIN_CHECK = "3";
        }
        #endregion

        //#20170731, 해피기프트카드(코나머니) 개발 Start, srlee
        #region 해피기프트카드(코나머니) 조회 업무구분
        /// <summary>
        /// 해피기프트카드(코나머니) 조회 업무구분
        /// </summary>
        public class HPGIFTCARD_SEARCH_TYPE
        {
            /// <summary>
            /// 카드프리픽스
            /// </summary>
            public const string PREFIX = "PREFIX";
            /// <summary>
            /// 해피기프트카드 조회
            /// </summary>
            public const string HPGIFTCARD_SEARCH = "HPGIFTCARD_SEARCH";
            //20171013 dkshin 해피기프트(신) IC/RF 충전 및 승인
            /// <summary>
            /// 해피기프트카드 충전 KMCH
            /// </summary>
            public const string HPGIFTCARD_RECHANGE = "HPGIFTCARD_RECHANGE";
            /// <summary>
            /// 해피기프트카드 개시 KMAC
            /// </summary>
            public const string HPGIFTCARD_OPEN = "HPGIFTCARD_OPEN";
            /// <summary>
            /// 해피기프트카드 충전 취소 - 반품거래 KMCH
            /// </summary>
            public const string HPGIFTCARD_RECHANGE_CANCEL = "HPGIFTCARD_RECHANGE_CANCEL";
        }
        #endregion
        //#20170731, 해피기프트카드(코나머니) 개발 End, srlee

        //girak.kim,#2017/08/29,환경설정>점포환경>회사코드 값 start
        #region 회사코드
        public class POS_COMPANY_CODE
        {
            public const string BRKR = "BRKR";
            public const string PCKR = "PCKR";
            public const string SLKR = "SLKR";
            public const string PCCN = "PCCN";
            public const string PCFR = "PCFR";            
            public const string PCUS = "PCUS";
        }
        //girak.kim,#2017/08/29,환경설정>점포환경>회사코드 값 end
        #endregion

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 웰컴카드 기능타입
        /// <summary>
        /// 웰컴카드 타입
        /// </summary>
        public class WELCOMECARD_TYPE
        {
            public const string ISSUE_SEARCH = "MC010010V102";                  // 발급-조회        : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string ISSUE_REGISTER = "MC210050V100";                // 발급-요청        : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string ISSUE_CANCEL = "MC220050V100";                  // 발급-취소        : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string HPC_CLIENT_REGISTER = "MC290040V100";           // HPC고객등록      : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string HPC_CLIENT_REGISTER_CANCEL = "MC300040V100";    // HPC고객등록 취소 : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string POS_CLIENT_REGISTER = "MC230040V100";           // POS고객등록      : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string POS_CLIENT_REGISTER_CANCEL = "MC240040V100";    // POS고객등록 취소 : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string DC_AGREE = "MC020020V102";                      // 할인요청         : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string DC_CANCEL = "MC030020V102";                     // 할인취소         : 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4)
            public const string DC_NETAGREE = "MC040020V102";                   // 망상취소 할인요청: 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4) //망상할인취소
            public const string DC_NETCANCEL = "MC050020V102";                  // 망상취소 할인취소: 구분(2) + 전문유형(4) + 업무구분(2) + 전문버전(4) //망상할인 

        }
        #endregion

        #region 해피포인트 조회 구분
        /// <summary>
        /// 웰컴카드 고객 조회 
        /// </summary>
        public class WELCOMECARD_MSG
        {
            /// <summary>
            /// 바로 조회전문날림
            /// </summary>
            public const string HP_SEARCH = "HP_SEARCH";
            /// <summary>
            /// 해피 조회 데이터 체크 
            /// </summary>
            public const string HP_SEARCH_DATA = "HP_SEARCH_DATA";
            /// <summary>
            /// 해피 등록 데이터 체크 
            /// </summary>
            public const string HP_REGISTER_DATA = "HP_REGISTER_DATA";
        }
        //#20180413 웰컴카드 신규기능 추가 end,phj
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 start
        #region PROD_TAKE_IN_OUT_DIV 구분(1:Take In, 2: Take Out)
        /// <summary>
        /// PROD_TAKE_IN_OUT_DIV 구분(1:Take In, 2: Take Out)
        /// </summary>
        public class PROD_TAKE_IN_OUT_DIV
        {
            /// <summary>
            /// 1: TAKE_IN
            /// </summary>
            public const string PROD_TAKE_IN = "1";
            /// <summary>
            /// 2: TAKE_OUT
            /// </summary>
            public const string PROD_TAKE_OUT = "2";
        }
        #endregion PROD_TAKE_IN_OUT_DIV 구분(1:Take In, 2: Take Out)
        //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 end

    }
}
