﻿using System;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 폼(화면) 관리
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.CommonManager
{
    /// <summary>
    /// 
    /// </summary>
    public class FormManager
    {
        /// <summary>
        /// 프로그램 시작(프로그램/마스터 다운로드)
        /// </summary>
        public const string FORM_PROGRAM_START = "SD0000";

        /// <summary>
        /// POS MAIN
        /// </summary>
        public const string FORM_POS_MAIN = "SC0000";
        /// <summary>
        /// 메뉴(메인)
        /// </summary>
        public const string FORM_MENU_MAIN = "SC0101";
        /// <summary>
        /// 메뉴(팝업)
        /// </summary>
        public const string FORM_MENU_SUB = "SC0102";

        /// <summary>
        /// 메인 화면 업무 기능 통합
        /// </summary>
        public const string FORM_BIZ_MAIN = "SC0103";

        //#13753 POS MOT음성 기능 추가 개발요청 start,phj
        /// <summary>
        /// 음성MOT 설정 화면
        /// </summary>
        public const string FORM_SOUND_MOT_SETTING = "SC0296";
        //#13753 POS MOT음성 기능 추가 개발요청 end,phj
        
        /// <summary>
        /// LOG ON
        /// </summary>
        public const string FORM_LOG_ON = "SC9100";

        /// <summary>
        /// LOG OFF
        /// </summary>
        public const string FORM_LOG_OFF = "SC9101";

        /// <summary>
        /// 판매등록(테이블)
        /// </summary>
        public const string FORM_TBL_REG = "SC1000";

        /// <summary>
        /// 층관리 
        /// </summary>
        public const string FORM_FLOOR_MGR = "SC1001";

        /// <summary>
        /// 테이블관리 
        /// </summary>
        public const string FORM_TABLE_MGR = "SC1002";

        /// <summary>
        /// 테이블 이동
        /// </summary>
        public const string FORM_TBL_MOVE = "SC1003";

        /// <summary>
        /// 테이블 분리
        /// </summary>
        public const string FORM_TBL_SPR = "SC1004";

        /// <summary>
        /// 테이블 예약
        /// </summary>
        public const string FORM_TBL_RESERVATION = "SC1005";

        /// <summary>
        /// 공지사항등록
        /// </summary>
        public const string FORM_TBL_NOTICE = "SC1006";

        /// <summary>
        /// 판매(테이블)
        /// </summary>
        public const string FORM_TBL_SALE = "SC1007";

        /// <summary>
        /// 관리메뉴
        /// </summary>
        public const string FORM_TBL_MNG = "SC1008";


        /// <summary>
        /// 테이블 영업메뉴
        /// </summary>
        public const string FORM_TBL_SAL_MENU = "SC1009";


        /// <summary>
        /// 연령선택
        /// </summary>
        public const string FORM_SAL_AGE = "SC1010";

        /// <summary>
        /// 테이블 예약 등록
        /// </summary>
        public const string FORM_TBL_RESERVATION_REG = "SC1011";

        /// <summary>
        /// 판매등록(등록전)
        /// </summary>
        public const string FORM_SAL_MAIN = "SC1100";


        /// <summary>
        /// 반품
        /// </summary>
        public const string FORM_SAL_RETRUN = "SC1101";

        /// <summary>
        /// 영수증 반품
        /// </summary>
        public const string FORM_SAL_RETURN_RECEIPT = "SC1102";

        /// <summary>
        /// 재발행
        /// </summary>
        public const string FORM_SAL_RE_PRINT = "SC1103";

        /// <summary>
        /// 영수증재발행
        /// </summary>
        public const string FORM_SAL_RECEIPT_REPRINT = "SC1104";

        /// <summary>
        /// 현금영수증 재발행
        /// </summary>
        public const string FORM_SAL_CASH_APPROVAL_LATER = "SC1105";

        /// <summary>
        /// 해피포인트 추후 적립
        /// </summary>
        public const string FORM_SAL_HPP_APPROVAL_LATER = "SC1106";


        /// <summary>
        /// 예약
        /// </summary>
        public const string FORM_SAL_RESERVATION_MENU = "SC1107";

        /// <summary>
        /// 예약등록
        /// </summary>
        public const string FORM_SAL_RESERVATION_REG = "SC1108";

        /// <summary>
        /// 예약완료
        /// </summary>
        public const string FORM_SAL_RESERVATION_FNS = "SC1109";

        /// <summary>
        /// 충전/판매
        /// </summary>
        public const string FORM_SAL_CHARGE = "SC1110";

        /// <summary>
        /// 선불카드판매
        /// </summary>
        public const string FORM_SAL_PREPAID_CARD = "SC1111";

        /// <summary>
        /// 상품권 판매
        /// </summary>
        public const string FORM_SAL_GIFT = "SC1112";

        /// <summary>
        /// 해피기프트 충전
        /// </summary>
        public const string FORM_SAL_HP_GIFT_CHARGED = "SC1113";

        /// <summary>
        /// 보류
        /// </summary>
        public const string FORM_SAL_HOLD = "SC1114";

        /// <summary>
        /// 판매LOSS
        /// </summary>
        public const string FORM_SAL_LOSS = "SC1115";

        /// <summary>
        /// 선불고객등록
        /// </summary>
        public const string FORM_SAL_PREPAID_CUST = "SC1116";

        /// <summary>
        /// 영수증 반품(결제수단)
        /// </summary>
        public const string FORM_SAL_RETURN_RECEIPT_PAY = "SC1117";
        /// <summary>
        /// 해피포인트 추후 적립(카드 입력 처리)
        /// </summary>
        public const string FORM_POINT_HAPPYPOINT_AFTER = "SC1118";
        ///// <summary>
        ///// 판매원 등록
        ///// </summary>
        //public const string FORM_CASHIER_INPUT = "SC1119";

        /// <summary>
        /// 판매등록(등록후)
        /// </summary>
        public const string FORM_SAL_BEFORE = "SC1200";

        /// <summary>
        /// 할인
        /// </summary>
        public const string FORM_SAL_DC = "SC1201";

        /// <summary>
        /// 기타
        /// </summary>
        public const string FORM_SAL_ETC = "SC1202";

        /// <summary>
        /// 메모
        /// </summary>
        public const string FORM_SAL_MEMO = "SC1203";

        /// <summary>
        /// 부가메뉴
        /// </summary>
        public const string FORM_SAL_ADD_MENU = "SC1204";

        /// <summary>
        /// 해피오더
        /// </summary>
        public const string FORM_SAL_HPORD = "SC1205";

        /// <summary>
        /// 플레이버
        /// </summary>
        public const string FORM_SAL_PLV = "SC1206";

        /// <summary>
        /// 묶음상품
        /// </summary>
        public const string FORM_SAL_BUNDLE_ITEM = "SC1207";

        /// <summary>
        /// Take In/out
        /// </summary>
        public const string FORM_SAL_TAKE_IN_OUT = "SC1208";

        /// <summary>
        /// 고객클레임 조회 화면
        /// </summary>
        public const string FORM_SAL_CUSTOMER_CLAIMS_LIST = "SC1209";


        /// <summary>
        /// 긴급공지
        /// </summary>
        public const string FORM_SAL_EMERGENCY_NOTICE = "SC1210";

        /// <summary>
        /// 외국인응대
        /// </summary>
        public const string FORM_SAL_FOREIGNERS_RESPONSE = "SC1211";

        /// <summary>
        /// 더치페이
        /// </summary>
        public const string FORM_SAL_DUTCH_PAY = "SC1212";

        /// <summary>
        /// 제품검색
        /// </summary>
        public const string FORM_SAL_ITEM_SEARCH = "SC1213";

        /// <summary>
        /// 점주/알바 모드
        /// </summary>
        public const string FORM_SAL_ADMIN = "SC1214";

        /// <summary>
        /// 메인화면 상단 기타 업무
        /// </summary>
        public const string FORM_SAL_TOP_ETC = "SC1215";

        /// <summary>
        /// WEB업무
        /// </summary>
        public const string FORM_WEB_LINK = "SC1216";

        /// <summary>
        /// 계산기
        /// </summary>
        public const string FORM_SAL_CAL = "SC1217";

        /// <summary>
        /// 고객클레임 등록/수정 화면
        /// </summary>
        public const string FORM_SAL_CUSTOMER_CLAIMS_INPUT = "SC1218";

        /// <summary>
        /// 더치페이(금액)
        /// </summary>
        public const string FORM_SAL_DUTCH_PAY_AMT = "SC1219";

        /// <summary>
        /// 해피오더 POP-UP
        /// </summary>
        public const string FORM_SAL_HPORD_POPUP = "SC1220";
        
        /// <summary>
        /// 해피오더 바코드 등록 화면
        /// </summary>
        public const string FORM_SAL_HPORD_BARCODE_REG = "SC1221";

        /// <summary>
        /// 세트메뉴 상품 변경 등록 화면
        /// </summary>
        public const string FORM_SET_MENU_CHANGE = "SC1222";
        
        /// <summary>
        /// 해피오더 중량 출력 화면
        /// </summary>
        public const string FORM_SAL_HPORD_WEIGHT_PRINT = "SC1223";

        /// <summary>
        /// 기념일배송 주문정보 출력
        /// </summary>
        public const string FORM_REMB_ORDER_PRINT = "SC1224";

        //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 start
        /// <summary>
        /// 해피오더 랜덤박스 바코드 등록 화면
        /// </summary>
        public const string FORM_SAL_HPORD_BARCODE = "SC1225";
        //#15746 해피오더 '쇼킹박스' 관련 POS 시스템 개발 요청 end

        //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 start
        /// <summary>
        /// 해피오더 주문 자동 처리 안내팝업 화면 
        /// </summary>
        public const string FORM_SAL_HPORD_MSG = "SC1226";
        //#16401 해피오더)주문내역 바코드 리딩 시 자동 완료처리 end

        /// <summary>
        /// 결제 메인
        /// </summary>
        public const string FORM_PAY_MAIN = "SC1300";

        /// <summary>
        /// 할인수단
        /// </summary>
        public const string FORM_PAY_DC = "SC1500";

        /// <summary>
        /// 해피포인트 적립
        /// </summary>
        public const string FORM_PAY_POINT_HAPPY_POINT = "SC1401";

        /// <summary>
        /// 제휴 멤버쉽 사용 OCB / OILBANK / BLUE / RED
        /// </summary>
        public const string FORM_PAY_POINT_MEMBERS_USE = "SC1404";
        /// <summary>
        /// OCB 적립
        /// </summary>
        public const string FORM_PAY_POINT_OCB_SAVE = "SC1405";

        /// <summary>
        /// 제휴카드(SKT,KT,LGT) 할인
        /// </summary>
        public const string FORM_PAY_POINT_MOBILE_COM = "SC1501";

        /// <summary>
        /// 결제 기타 할인
        /// </summary>
        public const string FORM_PAY_DC_ETC = "SC1502";

        /// <summary>
        /// 해피쿠폰할인
        /// </summary>
        public const string FORM_PAY_POINT_HPCOUPON = "SC1503";
        
        /// <summary>
        /// SPC임직원할인
        /// </summary>
        public const string FORM_PAY_DC_EMP = "SC1504";

        /// <summary>
        /// SPC임직원할인-중국
        /// </summary>
        public const string FORM_PAY_DC_EMP_CHINA = "SC1511";

        /// <summary>
        /// 케익교환권
        /// </summary>
        public const string FORM_PAY_DC_CAKE_VOUCHERS = "SC1505";

        /// <summary>
        /// 쿠폰할인
        /// </summary>
        public const string FORM_PAY_DC_COUPON = "SC1506";

        /// <summary>
        /// 전체할인
        /// </summary>
        public const string FORM_PAY_DC_TOTAL = "SC1507";

        ///// <summary>
        ///// 전체%할인
        ///// </summary>
        //public const string FORM_PAY_DC_TOTAL_RATE = "SC1508";

        /// <summary>
        /// 입점매장직원할인
        /// </summary>
        public const string FORM_INSTOR_DC = "SC1509";

        /// <summary>
        /// 세브란스병원 임직원 할인
        /// </summary>
        public const string FORM_SEVERANCE_DC = "SC1510";

        /// <summary>
        /// 제휴카드(SKT,KT,LGT,OILBANK,BLUE,RED) 통합할인(2017.08.29) -- START
        /// </summary>
        public const string FORM_PAY_POINT_MOBILE_UNITY = "SC1512";

        /// <summary>
        /// 결제수단
        /// </summary>
        public const string FORM_PAY_ETC_MENU = "SC1600";

        /// <summary>
        /// 현금결제
        /// </summary>
        public const string FORM_PAY_CASH = "SC1601";

        /// <summary>
        /// 수표
        /// </summary>
        public const string FORM_PAY_CHECK = "SC1602";

        /// <summary>
        /// 신용카드
        /// </summary>
        public const string FORM_PAY_CREDITCARD = "SC1603";

        /// <summary>
        /// 기타결제
        /// </summary>
        public const string FORM_PAY_ETC = "SC1604";

        /// <summary>
        /// 해피포인트 사용
        /// </summary>
        public const string FORM_PAY_POINT_HAPPY_POINT_USE = "SC1605";

        /// <summary>
        /// 온라인 쿠폰
        /// </summary>
        public const string FORM_PAY_ONLINE_COUPON = "SC1606";

        /// <summary>
        /// 상품권
        /// </summary>
        public const string FORM_PAY_GIFT = "SC1607";

        /// <summary>
        /// 알리페이
        /// </summary>
        public const string FORM_PAY_ALIPAY = "SC1608";

        /// <summary>
        /// 식권
        /// </summary>
        public const string FORM_PAY_MEAL_TICKET = "SC1609";

        /// <summary>
        /// 매장쿠폰
        /// </summary>
        public const string FORM_PAY_STORE_COUPON = "SC1610";

        /// <summary>
        /// 잔액교환권
        /// </summary>
        public const string FORM_PAY_BALANCE_VOUCHER = "SC1611";

        /// <summary>
        /// 모바일 쿠폰
        /// </summary>
        public const string FORM_PAY_MOBILE_COUPON = "SC1612";

        /// <summary>
        /// SPC 임직원 결제
        /// </summary>
        public const string FORM_PAY_EMP = "SC1613";

        /// <summary>
        /// 외상
        /// </summary>
        public const string FORM_PAY_CREDIT_CUSTOMER = "SC1614";

        /// <summary>
        /// 외화
        /// </summary>
        public const string FORM_PAY_FOREIGN_CURRENCY = "SC1615";

        /// <summary>
        /// 예약
        /// </summary>
        public const string FORM_PAY_RESERVATION = "SC1616";


        /// <summary>
        /// T-MONEY
        /// </summary>
        public const string FORM_PAY_TMONEY = "SC1617";

        /// <summary>
        /// 선불카드(해피조이)
        /// </summary>
        public const string FORM_PAY_HPJOY = "SC1618";

        /// <summary>
        /// 캐시비
        /// </summary>
        public const string FORM_PAY_CASHBEE = "SC1619";

        /// <summary>
        /// 선불카드 
        /// </summary>
        public const string FORM_PAY_PREPAID_CARDS = "SC1620";

        /// <summary>
        /// 해피기프트
        /// </summary>
        public const string FORM_PAY_HAPPY_GIFTCARD = "SC1621";

        /// <summary>
        /// Service Charge
        /// </summary>
        public const string FORM_PAY_SERVICE_CHARGE = "SC1622";


        /// <summary>
        /// 현금영수증
        /// </summary>
        public const string FORM_PAY_CASH_APPROVAL = "SC1623";

        /// <summary>
        /// 신용카드(이동단말기)
        /// </summary>
        public const string FORM_PAY_PDA = "SC1624";

        /// <summary>
        /// 아워홈
        /// </summary>
        public const string FORM_PAY_LG = "SC1625";

        /// <summary>
        /// 삼성카드 제휴할인 SFC
        /// </summary>
        public const string FORM_SAMSUNG_SFC = "SC1626";

        ///// <summary>
        ///// 해피쿠폰(인카드쿠폰조회)
        ///// </summary>
        //public const string FORM_PAY_POINT_HPCOUPON_LIST = "SC1627";

        /// <summary>
        /// 대상 상품 선택
        /// </summary>
        public const string FORM_SEL_SALE_PLU = "SC1628";

        /// <summary>
        /// 카드 번호 받기(공통)
        /// </summary>
        public const string FORM_INPUT_CARD = "SC1629";

        /// <summary>
        /// 삼성카드 포인트
        /// </summary>
        public const string FORM_SAMSUNG_POINT = "SC1630";
        
        /// <summary>
        /// 상품권 승인
        /// </summary>
        public const string FORM_PAY_GIFT_APP = "SC1631";

        ///// <summary>
        ///// 해피포인트 조회
        ///// </summary>
        //public const string FORM_HAPPY_POINT_SEARCH = "SC1632";

        /// <summary>
        /// 고객조회 팝업
        /// </summary>
        public const string FORM_PAY_CUST_SEARCH = "SC1633";

        /// <summary>
        /// 모바일 쿠폰-차세대 해피콘
        /// </summary>
        public const string FORM_PAY_MOBILE_COUPON_HAPPYCON = "SC1634";

        /// <summary>
        /// 세브란스병원 임직원 결제
        /// </summary>
        public const string FORM_PAY_SEVERANCE = "SC1635";

        /// <summary>
        /// 아워홈
        /// </summary>
        public const string FORM_PAY_OURHOME = "SC1636";

        /// <summary>
        /// 점포결제유형
        /// </summary>
        public const string FORM_SHOP_PAY_TYPE = "SC1637";

        /// <summary>
        /// 신용카드(임의등록)
        /// </summary>
        public const string FORM_MANUAL_APPR = "SC1638";

        /// <summary>
        /// 매입처 조회 팝업
        /// </summary>
        public const string FORM_VENDER_SEARCH = "SC1639";

        /// <summary>
        /// 모바일 쿠폰-차세대 해피콘 로그
        /// </summary>
        public const string FORM_PAY_MOBILE_COUPON_HAPPYCON_LOG = "SC1640";

        /// <summary>
        /// 해피포인트 적립 - 중국
        /// </summary>
        public const string FORM_PAY_POINT_HAPPY_POINT_SAVE_CHINA = "SC1641";
        /// <summary>
        /// 해피포인트 사용 - 중국
        /// </summary>
        public const string FORM_PAY_POINT_HAPPY_POINT_USE_CHINA = "SC1642";

        /// <summary>
        /// 해피머니상품권 도움말
        /// </summary>
        public const string FORM_PAY_HAPPY_GIF_HELP = "SC1643";

        /// <summary>
        /// 스마일페이
        /// </summary>
        public const string FORM_PAY_SMILEPAY = "SC1644";

        /// <summary>
        /// T페이
        /// </summary>
        public const string FORM_PAY_TPAY= "SC1645";
        /// <summary>
        /// T페이 고객목록 
        /// </summary>
        public const string FORM_PAY_TPAY_CONNECT_LIST = "SC1646";
        /// <summary>
        /// 선택 박스 
        /// </summary>
        public const string FORM_CHOICE_BOX = "SC1647";

        /// <summary>
        /// 상품권 조회
        /// </summary>
        public const string FORM_GIFT_SCH = "SC1648";

        /// <summary>
        /// 모바일쿠폰 조회
        /// </summary>
        public const string FORM_MOBILE_COUPON_SCH = "SC1649";

        /// <summary>
        /// 우리모아 포인트
        /// </summary>
        public const string FORM_WOORIMORE_POINT = "SC1650";

        /// <summary>
        /// 현대M 포인트
        /// </summary>
        public const string FORM_HYUNDAI_M_POINT = "SC1651";

        /// <summary>
        /// 신용카드 (MSR)
        /// </summary>
        public const string FORM_PAY_MSR_CARD = "SC1652";

        /// <summary>
        /// 선불카드 판매 - 중국
        /// </summary>
        public const string FORM_SALE_PRECARD = "SC1653";

        /// <summary>
        /// 위챗페이
        /// </summary>
        public const string FORM_PAY_WECHATPAY = "SC1654";

        /// <summary>
        /// 고객조회 팝업2
        /// </summary>
        public const string FORM_PAY_CUST_BROWSE = "SC1655";

        /// <summary>
        /// X-CHARGE 금액 입력
        /// </summary>
        public const string FORM_PAY_XCHARGE_INPUT = "SC1656";

        /// <summary>
        /// X-CHARGE 승인
        /// </summary>
        public const string FORM_PAY_XCHARGE_APPR = "SC1657";

        /// <summary>
        /// 베트남 신용카드(VIP POINT) - 프리픽스 캠페인 적용
        /// </summary>
        public const string FORM_PAY_VIP_POINT = "SC1658";

        /// <summary>
        /// 생일 초 계산
        /// </summary>
        public const string FORM_BRITHDAY_CANDLE = "SC1659";

        /// <summary>
        /// 선택 아이템 할인
        /// </summary>
        public const string FORM_MULTI_DCITEM = "SC1660";

        //#20170731, 해피기프트카드(코나머니) 개발 Start, srlee
        /// <summary>
        /// 해피기프트카드(코나머니)
        /// </summary>
        public const string FORM_HPGIFTCARD = "SC1661";
        //#20170731, 해피기프트카드(코나머니) 개발 End, srlee


        //#20170911.001, 중국 위쳇 페이, 샤오청쉬 기프트 카드 바이롱과 연동 개발 Start, girak.kim
        /// <summary>
        /// 위챗페이 Bai Rong 과 연동
        /// </summary>
        public const string FORM_PAY_WECHATPAY_BAIRONG = "SC1662";

        
        /// <summary>
        /// 샤오청쉬(미니앱) Bai Rong 과 연동
        /// </summary>
        public const string FORM_PAY_XIAOCHENGXU_GIFTCARD= "SC1663";
        //#20170911.001, 중국 위쳇 페이, 샤오청쉬 기프트 카드 바이롱과 연동 개발 End, girak.kim

        #region 신한카드 포인트 결제을 위한 폼 추가
        /// <summary>
        /// 신한카드 포인트
        /// </summary>
        public const string FORM_SINHANCARD_POINT = "SC1664";
        #endregion

        //#20180413 웰컴카드 신규기능 추가 start,phj
        /// <summary>
        /// 웰컴카드 발급화면
        /// </summary>
        public const string FORM_WELCOMECARD_ISSUE = "SC1665";
        //#20180413 웰컴카드 신규기능 추가 end,phj

        /// <summary>
        /// 개점
        /// </summary>
        public const string FORM_SOD_SALE = "SC2000";

        /// <summary>
        /// 판매 준비 점검
        /// </summary>
        public const string FORM_SOD_CHECK = "SC2100";

        /// <summary>
        /// 준비 점검 공지 사항
        /// </summary>
        public const string FORM_SOD_REDAY = "SC2101";

        /// <summary>
        /// 유통기한 점검 체크리스트
        /// </summary>
        public const string FORM_EXPIRATION_DATE_CHECK = "SC2102";

        /// <summary>
        /// 식품안전의 날
        /// </summary>
        public const string FORM_FOOD_SAFETY_DAY = "SC2103";

        /// <summary>
        /// 식품안전의 날
        /// </summary>
        public const string FORM_FOOD_SAFETY_DAY_POPUP = "SC2104";

        /// <summary>
        /// 일일점검리스트(PCKR)
        /// </summary>
        public const string FORM_STORE_EQUIP_CHECK_LIST = "SC2105";

        /// <summary>
        /// 일일점검리스트상세(PCKR)
        /// </summary>
        public const string FORM_STORE_EQUIP_CHECK = "SC2106";

        /// <summary>
        /// 기타결제
        /// </summary>
        public const string FORM_INSTOR_PAY = "SC2107";

        /// <summary>
        /// 입출금
        /// </summary>
        public const string FORM_ACC_INOUT = "SC3000";

        /// <summary>
        /// 준비금
        /// </summary>
        public const string FORM_ACC_REMONEY = "SC3100";

        /// <summary>
        /// 기타 입출금
        /// </summary>
        public const string FORM_ACC_ETC_INOUT = "SC3200";

        /// <summary>
        /// 중간입금/마감입금 
        /// </summary>
        public const string FORM_ACC_SALE_END = "SC3300";

        /// <summary>
        /// 중간입금/마감입금 취소
        /// </summary>
        public const string FORM_ACC_SALE_END_CAN = "SC3400";
        
        /// <summary>
        /// 마감 메인 화면
        /// </summary>
        public const string FORM_ACC_MAIN = "SC4000";

        /// <summary>
        /// 조회 메인 화면
        /// </summary>
        public const string FORM_SCH_MAIN = "SC5000";

        /// <summary>
        /// 매출자료조회
        /// </summary>
        public const string FORM_SCH_SALE_DATA = "SC5100";

        /// <summary>
        /// 자료조회
        /// </summary>
        public const string FORM_SCH_DATA = "SC5101";

        /// <summary>
        /// 쇼핑몰 주문 정보 출력
        /// </summary>
        public const string FORM_SCH_SMINFO = "SC5102";

        /// <summary>
        /// 해피포인트 추후 적립 조회
        /// </summary>
        public const string FORM_SCH_HPLATE = "SC5103";

        /// <summary>
        /// 출하/예정 내역 조회
        /// </summary>
        public const string FORM_SCH_SHIPEMNT = "SC5104";

        /// <summary>
        /// 담당자별 매출 자료 조회
        /// </summary>
        public const string FORM_SCH_SALE_EMP = "SC5105";

        /// <summary>
        /// 행사 주문 취합 내역 조회
        /// </summary>
        public const string FORM_SCH_EVT = "SC5106";

        /// <summary>
        /// 배송지시서 출력
        /// </summary>
        public const string FORM_SCH_DVL_PRT = "SC5107";

        /// <summary>
        /// 본사 반품 내역 조회
        /// </summary>
        public const string FORM_SCH_RETURN_COMPAY = "SC5108";

        /// <summary>
        /// 알리페이 인위 개입 내역 조회
        /// </summary>
        public const string FORM_SCH_ALIPAY = "SC5109";

        /// <summary>
        /// 교통카드 내역 조회
        /// </summary>
        public const string FORM_TMONEY_SEARCH = "SC5110";

        /// <summary>
        /// 해피포인트 단골매장등록
        /// </summary>
        public const string FORM_HPP_REGULAR_CUST = "SC5111";

        /// <summary>
        /// 매출 자료 수신
        /// </summary>
        public const string FORM_TRANLOG_DOWNLOAD = "SC5112";

        /// <summary>
        /// PGM 다운로드
        /// </summary>
        public const string FORM_PGM_DOWNLOAD = "SC5113";

        /// <summary>
        /// 주방주문내역조회
        /// </summary>
        public const string FORM_SCH_KTCH_ORDER = "SC5114";

        /// <summary>
        /// 백신실행
        /// </summary>
        public const string FORM_EXE_VACCINE = "SC5115";

        /// <summary>
        /// 서명패드 업데이트
        /// </summary>
        public const string FORM_SIGNPAD_UPDATE = "SC5116";

        /// <summary>
        /// POS LOG 조회
        /// </summary>
        public const string FORM_SCH_POS_LOG = "SC5117";

        /// <summary>
        /// 준비점검 공지사항
        /// </summary>
        public const string FORM_SCH_PREP_STOR_NOTICE = "SC5118";

        /// <summary>
        /// 매출 재전송
        /// </summary>
        public const string FORM_TRAN_RESEND = "SC5119";

        /// <summary>
        /// 도로공사 매출 재전송
        /// </summary>
        public const string FORM_EX_RESEND = "SC5120";

        //#20171016 IC리더기 펌웨어 업데이트 Start, srlee
        /// <summary>
        /// IC리더기 업데이트_NEW
        /// </summary>
        public const string FORM_ICREADER_UPDATE = "SC5121";
        //#20171016 IC리더기 펌웨어 업데이트 End, srlee

        /// <summary>
        /// 관리 메인 화면
        /// </summary>
        public const string FORM_MNG_MAIN = "SC6000";

        /// <summary>
        /// 다운로드
        /// </summary>
        public const string FORM_MNG_DOWNLOAD = "SC6100";

        /// <summary>
        /// Check of kitchen Printer
        /// </summary>
        public const string FORM_MNG_CKP = "SC6001";

        /// <summary>
        /// 설정 메인 화면
        /// </summary>
        public const string FORM_OPT_MAIN = "SC7000";

        /// <summary>
        /// 기타 메인 화면
        /// </summary>
        public const string FORM_ETC_MAIN = "SC8000";

        /// <summary>
        /// 간이영수증
        /// </summary>
        public const string FORM_ETC_RECEIPT = "SC8100";

        /// <summary>
        /// 직원방문등록
        /// </summary>
        public const string FORM_ETC_INEMP = "SC8101";

        /// <summary>
        /// 출/퇴근등록
        /// </summary>
        public const string FORM_ETC_CHECK_EMP = "SC8102";

        /// <summary>
        /// 환율등록
        /// </summary>
        public const string FORM_ETC_EXCHANGE_REG = "SC8103";

        /// <summary>
        /// PVC 상자 재고
        /// </summary>
        public const string FORM_ETC_PVC = "SC8104";

        /// <summary>
        /// 시험모드 리스트
        /// </summary>
        public const string FORM_TEST_MODE_LIST = "SC8105";
        /// <summary>
        /// 시험모드 진행화면
        /// </summary>
        public const string FORM_TEST_MODE = "SC8106";

        /// <summary>
        /// 캠페인 정보 조회
        /// </summary>
        public const string FORM_CAMPAIGN_INFO = "SC8107";
        /// <summary>
        /// 시험 결과조회
        /// </summary>
        public const string FORM_TEST_MODE_SEARCH = "SC8108";
        /// <summary>
        /// 시험 상품교육
        /// </summary>
        public const string FORM_TEST_EDU_PLU = "SC8109";
        /// <summary>
        /// 시험 상품조회
        /// </summary>
        public const string FORM_TEST_PLU_SEARCH = "SC8110";
        /// <summary>
        /// 공지사항 조회
        /// </summary>
        public const string FORM_NOTICE_SEARCH = "SC8111";
        /// <summary>
        /// 달력 조회
        /// </summary>
        public const string FORM_CALENDAR = "SC8112";

        /// <summary>
        /// 선택 버튼 팝업
        /// </summary>
        public const string FORM_ETC_SELECT_BTN = "SC8113";

        ///// <summary>
        ///// Server(담당자) 등록
        ///// </summary>
        //public const string FORM_ETC_SERVER_REG = "SC9001";
        /// <summary>
        /// 매장 공지사항 등록
        /// </summary>
        public const string FORM_ETC_STORE_NOTICE_REG = "SC9002";
        /// <summary>
        /// 메뉴 이동
        /// </summary>
        public const string FORM_ETC_TABLE_ITEM_MOVE = "SC9003";
        /// <summary>
        /// 좌석메모/상품메모
        /// </summary>
        public const string FORM_ETC_TABLE_MEMO = "SC9004";
        /// <summary>
        /// 예약관리
        /// </summary>
        public const string FORM_ETC_RESERV_MAIN = "SC9005";
        /// <summary>
        /// 예약등록
        /// </summary>
        public const string FORM_ETC_RESERV_REG = "SC9006";
        /// <summary>
        /// 사유코드 입력 팝업
        /// </summary>
        public const string FORM_REASON_CODE = "SC9007";
        /// <summary>
        /// 좌석메모목록
        /// </summary>
        public const string FORM_ETC_TABLE_MEMO_LIST = "SC9008";
        /// <summary>
        /// 주방프린터 수동 출력 (장치선택, OPT425 = "1")
        /// </summary>
        public const string FORM_MENUAL_ORDER_KPS = "SC9009";
        /// <summary>
        /// 주방프린터 수동 출력 (장치선택, OPT425 = "2")
        /// </summary>
        public const string FORM_MENUAL_ORDER_ITEM = "SC9010";
        
        /// <summary>
        /// 온라인 쿠폰 조회
        /// </summary>
        public const string FORM_PAY_ONLINE_COUPON_SCH = "SC9011";

        /// <summary>
        /// 주방프린터 상태 체크 
        /// </summary>
        public const string FORM_KPS_CHECK = "SC9012";

        /// <summary>
        /// 해피포인트 적립 안내 메시지
        /// </summary>
        public const string FORM_HP_SAVE_COMPLETE_MSG = "SC9013";


        //#20180611 해피오더 주문취소 사유 start
        /// <summary>
        /// 해피오더 주문취소 사유
        /// </summary>
        public const string FORM_HPORD_REASON_CODE = "SC9014";
        //#20180611 해피오더 주문취소 사유 end

        /// <summary>
        /// 고객화면
        /// </summary>
        public const string FORM_ETC_CUSTOMER_DISPLAY = "SC9500";
        /// <summary>
        /// 사용자 입력 화면
        /// </summary>
        public const string FORM_USER_INPUT_DATA = "SC9901";
        /// <summary>
        /// 거래처 조회 팝업창
        /// </summary>
        public const string FORM_SCH_VENDOR = "SC9902";
        /// <summary>
        /// 영업공지사항
        /// </summary>
        public const string FORM_BUSI_NOTICE = "SC9903";
        /// <summary>
        /// 영업공지사항
        /// </summary>
        public const string FORM_CERTIFY_INTEGRITY = "SC9904";

        /// <summary>
        /// 카운다운 메세지
        /// </summary>
        public const string FORM_COUNT_DOWN_MSG = "SC9905";

        /// <summary>
        /// 마스터 백업
        /// </summary>
        public const string FORM_MASTER_BACKUP = "SC9906";

        /// <summary>
        /// 무결성 쓰레드
        /// </summary>
        public const string FORM_CERTIFY_INTEGRITY_THREAD = "SC9907";

        /// <summary>
        /// 주변장치 상태 조회
        /// </summary>
        public const string FORM_DEVICE_STATUS_SEARCH = "SC9908";

        /// <summary>
        /// 해피 버즈
        /// </summary>
        public const string FORM_HAPPY_BUZZ = "SC9909";

        /// <summary>
        /// 할인내역 리스트
        /// </summary>
        public const string FORM_DISCOUNT_LIST = "SC9910";

        /// <summary>
        /// BR팝업 업무
        /// </summary>
        public const string FORM_POPUP_COM = "SC9911";

        /// <summary>
        /// 시작 프로그램 다운로드
        /// </summary>
        public const string FORM_START_PGMUPDATE = "SC9912";

        /// <summary>
        /// 결락 조회
        /// </summary>
        public const string FORM_MISSTRAN_CHECK = "SC9913";

        /// <summary>
        /// 판매상품 리스트
        /// </summary>
        public const string FORM_SALEPLU_LIST = "SC9914";

        //20171013 dkshin 해피기프트(신) IC/RF 충전 및 승인
        /// <summary>
        /// 해피기프트(신) 충전
        /// </summary>
        public const string FORM_SAL_HP_GIFT_NEW_CHARGED = "SC9915";

        //#20171227 인천공항 포스연동 start, phj
        /// <summary>
        /// 인천공항 통합POS 폼 
        /// </summary>
        public const string FORM_INCHEONAIRPORT = "SC9916";
        //#20171227 인천공항 포스연동 end, phj

        //grayber@20180208 미사용 기능 주석 처리
        //// grayber@20180115 인천공항 VIP 라운지 start - 폼 추가
        ///// <summary>
        ///// 인천공항 VIP 라운지 폼
        ///// </summary>
        //public const string FORM_AIRPORT_VIP_LOUNGE = "SC9917";
        //// grayber@20180115 인천공항 VIP 라운지 end
        //grayber@20180208 미사용 기능 주석 처리

        //grayber@20180208 코레일 마일리지 입력 start - 폼 추가
        /// <summary>
        /// 코레일 마일리지 폼
        /// </summary>
        public const string FORM_KORAIL_MILEAGE = "SC9918";
        //grayber@20180208 코레일 마일리지 입력 end

        /// <summary>
        /// 미구 해피포인트 폼
        /// </summary>
        public const string FORM_PAY_POINT_HAPPY_POINT_PCUS = "SC9919";//2018.02.26, girak.kim

        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 start
        /// <summary>
        /// 쿠폰 발송 폼
        /// </summary>
        public const string FORM_CPN_SEND = "SC9920";
        //#20180418 고객 구매이력 정보 표시 및 해피쿠폰 발송 end

        //#15525 고객구매이력 수정 요청 start, 20180704
        /// <summary>
        /// vip 표시
        /// </summary>
        public const string FORM_VIP = "SC9921";
        //#15525 고객구매이력 수정 요청 end, 20180704

        //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 start
        /// <summary>
        /// 제조음료 Take In/out
        /// </summary>
        public const string FORM_SAL_TAKE_IN_OUT_PROD = "SC9922";
        //#16232 환경부 1회용컵 사용줄이기 관련 테이크인아웃 설정 end

        //#16577 결제창 내부 봉투 추가 기능 도입 start
        /// <summary>
        /// 제조음료 Take In/out
        /// </summary>
        public const string FORM_ADD_BAG = "SC9923";
        //#16577 결제창 내부 봉투 추가 기능 도입 end

        /// <summary>
        /// 결제 배경용
        /// </summary>
        public const string FORM_PAY_BACKGROUND = "PB9999";

        // 추후 체크 _pss
        /// <summary>
        /// 점착정보(배송정보)
        /// </summary>
        public const string FORM_WEB_STOR_ARRV_INFO = "WL1000";
        /// <summary>
        /// 점착정보(배송추적)
        /// </summary>
        public const string FORM_WEB_STOR_ARRV_DETAIL = "WL1001";
        /// <summary>
        /// 온도정보
        /// </summary>
        public const string FORM_WEB_TMPRT = "WL1002";
        /// <summary>
        /// 쇼핑몰(WEB)
        /// </summary>
        public const string FORM_WEB_SHOPPING_MALL = "WL1003";
        /// <summary>
        /// 주문공지(WEB)
        /// </summary>
        public const string FORM_WEB_ORDER_LIST = "WL1004";

        /// <summary>
        /// 이지웰(WEB)
        /// </summary>
        public const string FORM_WEB_EZWELW = "WL1005";
        /// <summary>
        /// 해피오더 점주(WEB)
        /// </summary>
        public const string FORM_WEB_HAPPY_ORDER = "WL1006";
        /// <summary>
        /// 빚은몰(WEB)
        /// </summary>
        public const string FORM_WEB_BIZEUN = "WL1007";
        /// <summary>
        /// 긴급공지
        /// </summary>
        public const string FORM_WEB_EMGNCY_LIST = "WL1008";
        /// <summary>
        /// 세브란스
        /// </summary>
        public const string FORM_WEB_SEVERANCE = "WL1009";
        /// <summary>
        /// 제조메뉴얼
        /// </summary>
        public const string FORM_WEB_MAKE_MENUAL = "WL1010";
        /// <summary>
        /// 이달의행사
        /// </summary>
        public const string FORM_WEB_MONTH_EVENT = "WL1011";
        /// <summary>
        /// 상품키관리
        /// </summary>
        public const string FORM_WEB_POS_PLU_MGR = "WL1012";
        /// <summary>
        /// 판매POS환경설정
        /// </summary>
        public const string FORM_WEB_POS_SETTING = "WL1013";
        /// <summary>
        /// 판매POS옵션설정
        /// </summary>
        public const string FORM_WEB_POS_OPTION = "WL1014";
        /// <summary>
        /// 플레이버관리
        /// </summary>
        public const string FORM_WEB_POS_REG_FLOVOR = "WL1015";
        /// <summary>
        /// 매장테이블관리
        /// </summary>
        public const string FORM_WEB_POS_TABLE_MANAGEMENT = "WL1016";
        /// <summary>
        /// 승인내역조회
        /// </summary>
        public const string FORM_WEB_SCH_APPROVAL = "WL1017";
        /// <summary>
        /// BGM 관리 사이트
        /// </summary>
        public const string FORM_WEB_MGR_BGM = "WL1018";
        /// <summary>
        /// 기타설정
        /// </summary>
        public const string FORM_ETC_POS_SETTING = "SC1120";
        /// <summary>
        /// 바코드출력
        /// </summary>
        public const string FORM_BARCODE_PRINT = "SC1121";
        /// <summary>
        /// WEB_BIZ
        /// </summary>
        public const string FORM_WEB_POS_BIZ = "WL1019";
        /// <summary>
        /// WEB_POS
        /// </summary>
        public const string FORM_WEB_POS = "WL1020";

        /// <summary>
        /// Form Manager
        /// </summary>
        private static Hashtable g_htFormManager;

        /// <summary>
        /// Form Parameter
        /// </summary>
        public static object g_oFormParameter;

        /// <summary>
        /// 숨김폼 인덱스 번호(0:메인, 1:판매, 2:테이블)
        /// </summary>
        public static int m_HideFormIndex = 0;

        static FormManager()
        {
            g_htFormManager = new Hashtable();
        }

        /// <summary>
        /// Clear FORM(폼초기화)
        /// </summary>
        public static void ClearForm()
        {
            try
            {
                g_htFormManager = new Hashtable();
            }
            catch { }
        }

        /// <summary>
        /// Add FORM (폼추가)
        /// </summary>
        /// <param name="pKey"></param>
        /// <param name="pForm"></param>
        /// <returns></returns>
        public static bool AddForm(string pKey, Object pForm)
        {
            try
            {
                if (g_htFormManager.Contains(pKey) == false)
                {
                    g_htFormManager.Add(pKey, pForm);
                    return true;
                }
                else
                {
                    g_htFormManager.Remove(pKey);
                    g_htFormManager.Add(pKey, pForm);
                    return true;
                }
            }
            catch { }

            return false;
        }

        #region MovePopUpForm 주석
        /// <summary>
        /// FORM 이동
        /// </summary>
        /// <param name="pForm"></param>
        /// <param name="bPayFrom"></param>
        /// <param name="nScrSize"></param>
        /// <returns></returns>
        public static bool MovePopUpForm(Object pForm, bool bPayFrom,  long nScrSize)
        {
            try
            {
                if (nScrSize == 0)
                {
                    nScrSize = 1024;
                    for (int i = 0; i < Screen.AllScreens.Length; i++)
                    {
                        if (Screen.AllScreens[i].Primary == true)                       // 캐셔화면
                        {
                            nScrSize = (Screen.AllScreens[i].WorkingArea.Width == 800) ? 800 : 1024;
                        }
                    }
                }

                Form cForm = (Form)pForm;
                if (nScrSize == 800)
                {
                    if (bPayFrom == true)       // 결제화면 고정
                        cForm.Location = new Point(216, 173);
                    else if (cForm.Width <= 800 && cForm.Height <= 544)
                        cForm.Location = new Point((800 - cForm.Width) / 2, 50 + ((544 - cForm.Height) / 2));
                    else
                        cForm.Location = new Point(0, 0);
                }
                else
                {
                    if (bPayFrom == true)       // 결제화면 고정
                        cForm.Location = new Point(216, 173);
                    else if (cForm.Width <= 1024 && cForm.Height <= 696)
                        cForm.Location = new Point((1024 - cForm.Width) / 2, 50 + ((696 - cForm.Height) / 2));
                    else
                        cForm.Location = new Point(0, 0);
                }
            }
            catch { }

            return false;
        }
        #endregion

        /// <summary>
        /// Get FORM (폼 얻음)
        /// </summary>
        /// <param name="pKey"></param>
        /// <returns></returns>
        public static Object GetForm(string pKey)
        {
            try
            {
                if (g_htFormManager.Contains(pKey) == true)
                {
                    g_oFormParameter = null;
                    return (object)g_htFormManager[pKey];
                }
            }
            catch { }

            return null;
        }

        /// <summary>
        /// Show FORM(폼 표시)
        /// </summary>
        /// <param name="pKey"></param>
        /// <returns></returns>
        public static DialogResult ShowForm(string pKey)
        {
            try
            {
                g_oFormParameter = null;

                return ShowForm(pKey, null);
            }
            catch { }

            return DialogResult.Ignore;
        }

        /// <summary>
        /// Show FORM(폼표시)
        /// </summary>
        /// <param name="pKey"></param>
        /// <param name="pParameter"></param>
        /// <returns></returns>
        public static DialogResult ShowForm(string pKey, object pParameter)
        {
            try
            {
                if (g_htFormManager.Contains(pKey) == true)
                {
                    g_oFormParameter = pParameter;
                    System.Windows.Forms.Form fShowForm = (System.Windows.Forms.Form)g_htFormManager[pKey];
                    // FormDisplayTricker 사용을 위한 수정(CHOCY-20160701)
                    return fShowForm.ShowDialog();
                    //fShowForm.Opacity = 0.99999999;
                    //var activeForm = Form.ActiveForm;
                    //FormDisplayTricker.SetLayer(null);
                    //fShowForm.TopMost = false;
                    //return fShowForm.ShowDialog(activeForm);
                }
            }
            catch(Exception ex)
            { }

            return DialogResult.Ignore;
        }

        /// <summary>
        /// Form에 올려진 모든 Control들에 대한 Font를 설정
        /// </summary>
        /// <param name="fShowForm"></param>
        /// <param name="strFontName"></param>
        public static void SetFormAllControlFont(Form fShowForm, string strFontName)
        {
            try
            {
                for (int nLoop = 0; nLoop < fShowForm.Controls.Count; nLoop++)
                {
                    fShowForm.Controls[nLoop].Font = new Font(strFontName, fShowForm.Controls[nLoop].Font.Size, fShowForm.Controls[nLoop].Font.Style);
                    if (fShowForm.Controls[nLoop] is Cosmos.UI.CsmGrid)
                    {
                        Cosmos.UI.CsmGrid cCtl = (Cosmos.UI.CsmGrid)fShowForm.Controls[nLoop];
                        cCtl.CsmGridColumnHeadersFont = new Font(strFontName, cCtl.CsmGridColumnHeadersFont.Size, cCtl.CsmGridColumnHeadersFont.Style);
                    }
                    if (fShowForm.Controls[nLoop] is Panel)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            fShowForm.Controls[nLoop].Controls[nLoop2].Font = new Font(strFontName, fShowForm.Controls[nLoop].Controls[nLoop2].Font.Size, fShowForm.Controls[nLoop].Controls[nLoop2].Font.Style);
                            if (fShowForm.Controls[nLoop].Controls[nLoop2] is Panel)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font = new Font(strFontName, fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font.Size, fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font.Style);
                                }
                            }
                            else if (fShowForm.Controls[nLoop].Controls[nLoop2] is GroupBox)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font = new Font(strFontName, fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font.Size, fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Font.Style);
                                }
                            }
                        }
                    }
                    else if (fShowForm.Controls[nLoop] is GroupBox)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            fShowForm.Controls[nLoop].Controls[nLoop2].Font = new Font(strFontName, fShowForm.Controls[nLoop].Controls[nLoop2].Font.Size, fShowForm.Controls[nLoop].Controls[nLoop2].Font.Style);
                        }
                    }
                }
            }
            catch { }
        }

        /// <summary>
        /// Form에 올려진 모든 Control들에 대한 이동을 설정 설정
        /// </summary>
        /// <param name="fShowForm"></param>
        /// <param name="nX"></param>
        /// <param name="nY"></param>
        public static void SetFormAllControlMove(Form fShowForm, int nX, int nY)
        {
            try
            {
                for (int nLoop = 0; nLoop < fShowForm.Controls.Count; nLoop++)
                {
                    if (fShowForm.Controls[nLoop].Name != "picBack")
                        fShowForm.Controls[nLoop].Location = new Point(fShowForm.Controls[nLoop].Left + nX, fShowForm.Controls[nLoop].Top + nY);
                }
            }
            catch { }
        }

        /// <summary> SetFormAllControlColor </summary>
        public static void SetFormAllControlColor(Form fShowForm, string sImgPath)
        {
            string sFileName = sImgPath + fShowForm.Name + ".cfg";
            try
            {
                if (File.Exists(sFileName) == false)
                {
                    sFileName = sImgPath + "frmDefault.cfg";
                    if (File.Exists(sFileName) == false) return;
                }

                FileStream fs = new FileStream(sFileName, FileMode.Open, FileAccess.Read);
                StreamReader sr = new StreamReader(fs, Encoding.Default);

                try
                {
                    sr.BaseStream.Seek(0, SeekOrigin.Begin);
                    while (sr.Peek() > -1)
                    {
                        string sData = sr.ReadLine();
                        if (sData.Trim().Length == 0) continue;

                        string[] saData = sData.Split('|');
                        SetControlBackColor(fShowForm, saData[0].Trim(), saData[1].Trim());
                    }
                    sr.Close();
                    fs.Close();
                }
                catch (Exception ex)
                {
                    sr.Close();
                    fs.Close();
                }
            }
            catch (Exception ex) { }
        }

        private static void SetControlBackColor(Form fShowForm, string sControlName, string sBackColor)
        {
            try
            {
                string[] saColor = sBackColor.Split(',');
                for (int nLoop = 0; nLoop < fShowForm.Controls.Count; nLoop++)
                {
                    if (sControlName == fShowForm.Controls[nLoop].Name)
                    {
                        fShowForm.Controls[nLoop].BackColor = Color.FromArgb(int.Parse(saColor[0]), int.Parse(saColor[1]), int.Parse(saColor[2]));
                        return;
                    }
                    if (fShowForm.Controls[nLoop] is Panel)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            if (sControlName == fShowForm.Controls[nLoop].Controls[nLoop2].Name)
                            {
                                fShowForm.Controls[nLoop].Controls[nLoop2].BackColor = Color.FromArgb(int.Parse(saColor[0]), int.Parse(saColor[1]), int.Parse(saColor[2]));
                                return;
                            }
                            if (fShowForm.Controls[nLoop].Controls[nLoop2] is Panel)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    if (sControlName == fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Name)
                                    {
                                        fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].BackColor = Color.FromArgb(int.Parse(saColor[0]), int.Parse(saColor[1]), int.Parse(saColor[2]));
                                        return;
                                    }
                                }
                            }
                            else if (fShowForm.Controls[nLoop].Controls[nLoop2] is GroupBox)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    if (sControlName == fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].Name)
                                    {
                                        fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3].BackColor = Color.FromArgb(int.Parse(saColor[0]), int.Parse(saColor[1]), int.Parse(saColor[2]));
                                        return;
                                    }
                                }
                            }
                        }
                    }
                    else if (fShowForm.Controls[nLoop] is GroupBox)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            if (sControlName == fShowForm.Controls[nLoop].Controls[nLoop2].Name)
                            {
                                fShowForm.Controls[nLoop].Controls[nLoop2].BackColor = Color.FromArgb(int.Parse(saColor[0]), int.Parse(saColor[1]), int.Parse(saColor[2]));
                                return;
                            }
                        }
                    }
                }
            }
            catch { }
        }

        /// <summary> SetControlSize </summary>
        public static void SetControlSize(Control oCtl, int nStartX, int nStartY, int nWidth, int nHeight)
        {
            try
            {
                //oCtl.Location = new Point(nStartX, nStartY);
                //oCtl.Size = new Size(nWidth, nHeight);
                oCtl.SetBounds(nStartX, nStartY, nWidth, nHeight);
            }
            catch { }
        }
        /// <summary> SetControlSize </summary>
        public static void SetControlSize(Control oCtl, int nStartX, int nStartY, int nWidth, int nHeight, float nFontSize)
        {
            try
            {
                //oCtl.Location = new Point(nStartX, nStartY);
                //oCtl.Size = new Size(nWidth, nHeight);
                oCtl.SetBounds(nStartX, nStartY, nWidth, nHeight);
                oCtl.Font = new Font(oCtl.Font.Name, nFontSize, oCtl.Font.Style);
            }
            catch { }
        }


        #region 기능버튼중 'IC카드' 활성화 및 위치 설정
        /// <summary>
        /// 기능버튼중 'IC카드' 활성화 및 위치 설정
        /// </summary>
        /// <param name="txtCardNo"></param>
        /// <param name="bICReaderYn"></param>
        /// <param name="sender1"></param>
        /// <param name="sender2"></param>
        /// <param name="sender3"></param>
        /// <param name="sender4"></param>
        /// <returns></returns>
        public static bool SetbtnMenu(Cosmos.UI.CsmPosEditBox txtCardNo, bool bICReaderYn, object sender1, object sender2, object sender3, object sender4)
        {
            bool bRet = false;
            try
            {
                // 이정돈 위치로 이동
                //#20180108 페이온 start, phj
                //기존
                //if (((Cosmos.UI.CsmButton)sender2) != null) ((Cosmos.UI.CsmButton)sender2).Location = new Point(((Cosmos.UI.CsmButton)sender1).Location.X + ((Cosmos.UI.CsmButton)sender1).Size.Width, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                //if (((Cosmos.UI.CsmButton)sender3) != null) ((Cosmos.UI.CsmButton)sender3).Location = new Point(((Cosmos.UI.CsmButton)sender2).Location.X + ((Cosmos.UI.CsmButton)sender1).Size.Width, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                //if (((Cosmos.UI.CsmButton)sender4) != null) ((Cosmos.UI.CsmButton)sender4).Location = new Point(((Cosmos.UI.CsmButton)sender3).Location.X + ((Cosmos.UI.CsmButton)sender1).Size.Width, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                //변경
                if (((Cosmos.UI.CsmButton)sender2) != null) ((Cosmos.UI.CsmButton)sender2).Location = new Point(((Cosmos.UI.CsmButton)sender1).Location.X + ((Cosmos.UI.CsmButton)sender1).Size.Width -1, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                if (((Cosmos.UI.CsmButton)sender3) != null) ((Cosmos.UI.CsmButton)sender3).Location = new Point(((Cosmos.UI.CsmButton)sender2).Location.X + ((Cosmos.UI.CsmButton)sender2).Size.Width -1, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                if (((Cosmos.UI.CsmButton)sender4) != null) ((Cosmos.UI.CsmButton)sender4).Location = new Point(((Cosmos.UI.CsmButton)sender3).Location.X + ((Cosmos.UI.CsmButton)sender3).Size.Width -1, ((Cosmos.UI.CsmButton)sender1).Location.Y);
                //#20180108 페이온 end, phj

                if (bICReaderYn != true)     // 여신전문금융업법 적용여부 체크
                {
                    if ((Cosmos.UI.CsmButton)sender1 != null && ((Cosmos.UI.CsmButton)sender1).Text == MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0132))
                    {
                        // 액션버튼이 IC카드인 경우 비활성화 하고 나머지 버튼 위치 이동
                        ((Cosmos.UI.CsmButton)sender1).Text = "";

                        if (((Cosmos.UI.CsmButton)sender4) != null) ((Cosmos.UI.CsmButton)sender4).Location = ((Cosmos.UI.CsmButton)sender3).Location;
                        if (((Cosmos.UI.CsmButton)sender3) != null) ((Cosmos.UI.CsmButton)sender3).Location = ((Cosmos.UI.CsmButton)sender2).Location;
                        if (((Cosmos.UI.CsmButton)sender2) != null) ((Cosmos.UI.CsmButton)sender2).Location = ((Cosmos.UI.CsmButton)sender1).Location;
                    }
                }
                else
                {
                    if (txtCardNo != null ) txtCardNo.MaxLength = 40;
                }
                if (((Cosmos.UI.CsmButton)sender1) != null) if (((Cosmos.UI.CsmButton)sender1).Text.Length == 0) ((Cosmos.UI.CsmButton)sender1).Visible = false;
                if (((Cosmos.UI.CsmButton)sender2) != null) if (((Cosmos.UI.CsmButton)sender2).Text.Length == 0) ((Cosmos.UI.CsmButton)sender2).Visible = false;
                if (((Cosmos.UI.CsmButton)sender3) != null) if (((Cosmos.UI.CsmButton)sender3).Text.Length == 0) ((Cosmos.UI.CsmButton)sender3).Visible = false;
                if (((Cosmos.UI.CsmButton)sender4) != null) if (((Cosmos.UI.CsmButton)sender4).Text.Length == 0) ((Cosmos.UI.CsmButton)sender4).Visible = false;

                bRet = true;
            }
            catch  
            {
            }
            return bRet;
        }
        #endregion 

        /// <summary>
        /// 입력박스 글로벌 설정(금액표시 형태)
        /// </summary>
        /// <param name="fShowForm"></param>
        /// <param name="nGroupCnt"></param>
        /// <param name="sGroupMark"></param>
        /// <param name="nDecimalCnt"></param>
        /// <param name="sDecimalMark"></param>
        public static void SetTextBoxGlobalInfo(Form fShowForm, int nGroupCnt, string sGroupMark, int nDecimalCnt, string sDecimalMark)
        {
            try
            {
                for (int nLoop = 0; nLoop < fShowForm.Controls.Count; nLoop++)
                {
                    if (fShowForm.Controls[nLoop] is Cosmos.UI.CsmPosEditBox)
                        ((Cosmos.UI.CsmPosEditBox)fShowForm.Controls[nLoop]).SetGlobalInfo(nGroupCnt, sGroupMark, nDecimalCnt, sDecimalMark);

                    if (fShowForm.Controls[nLoop] is Panel)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            if (fShowForm.Controls[nLoop].Controls[nLoop2] is Cosmos.UI.CsmPosEditBox)
                                ((Cosmos.UI.CsmPosEditBox)fShowForm.Controls[nLoop].Controls[nLoop2]).SetGlobalInfo(nGroupCnt, sGroupMark, nDecimalCnt, sDecimalMark);

                            if (fShowForm.Controls[nLoop].Controls[nLoop2] is Panel)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    if (fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3] is Cosmos.UI.CsmPosEditBox)
                                        ((Cosmos.UI.CsmPosEditBox)fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3]).SetGlobalInfo(nGroupCnt, sGroupMark, nDecimalCnt, sDecimalMark);
                                }
                            }
                            else if (fShowForm.Controls[nLoop].Controls[nLoop2] is GroupBox)
                            {
                                for (int nLoop3 = 0; nLoop3 < fShowForm.Controls[nLoop].Controls[nLoop2].Controls.Count; nLoop3++)
                                {
                                    if (fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3] is Cosmos.UI.CsmPosEditBox)
                                        ((Cosmos.UI.CsmPosEditBox)fShowForm.Controls[nLoop].Controls[nLoop2].Controls[nLoop3]).SetGlobalInfo(nGroupCnt, sGroupMark, nDecimalCnt, sDecimalMark);
                                }
                            }
                        }
                    }
                    else if (fShowForm.Controls[nLoop] is GroupBox)
                    {
                        for (int nLoop2 = 0; nLoop2 < fShowForm.Controls[nLoop].Controls.Count; nLoop2++)
                        {
                            if (fShowForm.Controls[nLoop].Controls[nLoop2] is Cosmos.UI.CsmPosEditBox)
                                ((Cosmos.UI.CsmPosEditBox)fShowForm.Controls[nLoop].Controls[nLoop2]).SetGlobalInfo(nGroupCnt, sGroupMark, nDecimalCnt, sDecimalMark);
                        }
                    }
                }
            }
            catch { }
        }
    }
}
