﻿using System.Collections;
using System.Drawing;
using System.IO;

namespace Cosmos.CommonManager
{
    /// <summary>
    /// ImageManager
    /// </summary>
    public class ImageManager
    {
        /// <summary>
        /// 판매결제등록 바탕
        /// </summary>
        public const string SALE_BG = "sale_bg_";
        /// <summary>
        /// 메인화면 상단
        /// </summary>
        public const string MAIN_TOP_BG = "topbg.png";
        /// <summary>
        /// 메인화면 하단
        /// </summary>
        public const string MAIN_FOOTER_BG = "footerbg.png";
        /// <summary>
        /// 인트로 로그 영역
        /// </summary>
        public const string INTRO_BACK = "intro_bimg.png";
        /// <summary>
        /// 인트로 컨텐츠 영역
        /// </summary>
        public const string INTRO_CONTENTS = "intro_contents.png";
        /// <summary>
        /// 인트로 개점
        /// </summary>
        public const string INTRO_OPEN = "btn_intro_open.png";
        /// <summary>
        /// 인트로 개점-누름
        /// </summary>
        public const string INTRO_OPEN_PRESS = "btn_intro_open_press.png";
        /// <summary>
        /// 인트로 판매
        /// </summary>
        public const string INTRO_SELL = "btn_intro_sell.png";
        /// <summary>
        /// 인트로 판매-누름
        /// </summary>
        public const string INTRO_SELL_PRESS = "btn_intro_sell_press.png";
        /// <summary>
        /// 인트로 입출금,마감
        /// </summary>
        public const string INTRO_CLOSE = "btn_intro_close.png";
        /// <summary>
        /// 인트로 입출금,마감-누름
        /// </summary>
        public const string INTRO_CLOSE_PRESS = "btn_intro_close_press.png";
        /// <summary>
        ///  인트로 조회
        /// </summary>
        public const string INTRO_SEARCH = "btn_intro_search.png";
        /// <summary>
        ///  인트로 조회-누름
        /// </summary>
        public const string INTRO_SEARCH_PRESS = "btn_intro_search_press.png";
        /// <summary>
        /// 인트로 관리
        /// </summary>
        public const string INTRO_SETTING = "btn_intro_setting.png";
        /// <summary>
        /// 인트로 관리-누름
        /// </summary>
        public const string INTRO_SETTING_PRESS = "btn_intro_setting_press.png";
        /// <summary>
        /// 인트로 연습모드
        /// </summary>
        public const string INTRO_TRAINING = "btn_intro_training.png";
        /// <summary>
        /// 인트로 연습모드-누름
        /// </summary>
        public const string INTRO_TRAINING_PRESS = "btn_intro_training_press.png";
        /// <summary>
        /// 인트로 기타
        /// </summary>
        public const string INTRO_ETC = "btn_intro_etc.png";
        /// <summary>
        /// 인트로 기타-누름
        /// </summary>
        public const string INTRO_ETC_PRESS = "btn_intro_etc_press.png";
        /// <summary>
        /// 인트로 종료
        /// </summary>
        public const string INTRO_END = "btn_intro_end.png";
        /// <summary>
        /// 인트로 종료-누름
        /// </summary>
        public const string INTRO_END_PRESS = "btn_intro_end_press.png";

        /// <summary>
        /// 대문자 영문
        /// </summary>
        public const string LOGIN_ALPHAL = "btn_login_keyoption_lower.png";
        /// <summary>
        /// 소문자 영문
        /// </summary>
        public const string LOGIN_ALPHAS = "btn_login_keyoption_upper.png";
        /// <summary>
        /// 숫자
        /// </summary>
        public const string LOGIN_NUMBER = "btn_login_keyoption_number.png";
        /// <summary>
        /// 지우기
        /// </summary>
        public const string LOGIN_CLAER = "btn_login_keyoption_del.png";
        /// <summary>
        /// 로그인 백그라운드
        /// </summary>
        public const string LOGIN_BACKGROUND = "login_bg.png";
        /// <summary>
        /// 브랜드 CI 이미지
        /// </summary>
        public const string BRADN_CI = "brand_ci.png";
        /// <summary>
        /// 판매대기 MOT 이미지
        /// </summary>
        public const string SALE_MOT_WAIT = "sale_mot_wait.png";

        /// <summary>
        /// 대문자 영문
        /// </summary>
        public const string LOGIN_ALPHAL2 = "btn_login_keyoption_lower2.png";
        /// <summary>
        /// 소문자 영문
        /// </summary>
        public const string LOGIN_ALPHAS2 = "btn_login_keyoption_upper2.png";
        /// <summary>
        /// 숫자
        /// </summary>
        public const string LOGIN_NUMBER2 = "btn_login_keyoption_number2.png";
        /// <summary>
        /// 지우기
        /// </summary>
        public const string LOGIN_CLAER2 = "btn_login_keyoption_del2.png";
        /// <summary>
        /// 로그인 백그라운드
        /// </summary>
        public const string LOGIN_BACKGROUND2 = "login_bg2.png";


        /// <summary>
        /// 대문자 영문_800
        /// </summary>
        public const string LOGIN_ALPHAL_800 = "btn_login_keyoption_lower_800.png";
        /// <summary>
        /// 소문자 영문_800
        /// </summary>
        public const string LOGIN_ALPHAS_800 = "btn_login_keyoption_upper_800.png";
        /// <summary>
        /// 숫자_800
        /// </summary>
        public const string LOGIN_NUMBER_800 = "btn_login_keyoption_number_800.png";
        /// <summary>
        /// 지우기_800
        /// </summary>
        public const string LOGIN_CLAER_800 = "btn_login_keyoption_del_800.png";
        /// <summary>
        /// 로그인 백그라운드_800
        /// </summary>
        public const string LOGIN_BACKGROUND_800 = "login_bg_800.png";
        /// <summary>
        /// CI 로고
        /// </summary>
        public const string CI_LOGO = "Ci_logo.png";
        /// <summary>
        /// CI TEXT 로고
        /// </summary>
        public const string CI_TEXT_LOGO = "spc_text.png";         
        /// <summary>
        /// 메시지박스
        /// </summary>
        public const string MESSAGE_BOX = "msgbox.png";
        /// <summary>
        /// 긴급 메시지박스
        /// </summary>
        public const string EMG_MESSAGE_BOX = "emg_msgbox.png";
        /// <summary>
        /// 조회 메시지박스
        /// </summary>
        public const string SCH_MESSAGE_BOX = "schmsgbox.png";
        /// <summary>
        /// 결제 백그라운드
        /// </summary>
        public const string PAY_BACKGROUND = "pay_bg.png";
        /// <summary>
        /// 페이 메인 백그라운드
        /// </summary>
        public const string PAY_MAIN_BACKGROUND = "pay_popup_bg.png";
        /// <summary>
        /// 팝업 풀 사이즈
        /// </summary>
        public const string POP_FULL_SIZE = "popup_size_full.png";
        /// <summary>
        /// 팝업 788 X 402
        /// </summary>
        public const string POP_SIZE_S = "popup_size_S.png";
        /// <summary>
        /// 팝업 MINI
        /// </summary>
        public const string POP_SIZE_MIN = "popup_size_min.png";
        /*
        /// <summary>
        /// 팝업 결제화면
        /// </summary>
        //public const string POP_SIZE_S_PAY = "popup_size_S_PAY.png";
        /// <summary>
        */
        /// <summary>
        /// 팝업 864 X 575
        /// </summary>
        public const string POP_SIZE_M = "popup_size_M.png";
        /// <summary>
        /// 팝업 800 X 600
        /// </summary>
        public const string POP_SIZE_800X600 = "popup_size_800X600.png";
        /// <summary>
        /// 팝업 800 X 578
        /// </summary>
        public const string POP_SIZE_800X578 = "popup_size_800X578.png";
        /// <summary>
        /// 팝업 800 X 320
        /// </summary>
        public const string POP_SIZE_800X320 = "popup_size_800X320.png";

        /*
        /// <summary>
        /// 팝업 800 X 600
        /// </summary>
        //public const string POP_SIZE_800X544 = "spc_sale_popup_etc_800px.png";
        /// <summary>
        */

        /// <summary>
        /// 로딩 배경
        /// </summary>
        public const string LODING_BACKGROUND = "01_spc_loading_A1_BG.png";
        /// <summary>
        /// 메시지 박스 배경
        /// </summary>
        public const string POP_MSGBOX = "msgbox.png";
        /// <summary>
        /// 영업공지사항
        /// </summary>
        public const string POP_BUSI_NOTICE = "busi_notice.png";

        /// <summary>
        /// View Change Button
        /// </summary>
        public const string BUTTON_CHG_VIEW = "btn_change_view.png";
        /// <summary> BUTTON_CHG_VIEW_CLICK </summary>
        public const string BUTTON_CHG_VIEW_CLICK = "btn_change_view_click.png";

        /// <summary> POP_HAPPY_GIF_HELP </summary>
        public const string POP_HAPPY_GIF_HELP = "HAPPY_GIF_HELP.jpg";

        /// <summary>
        /// 결제 메인 기능키 누름 이미지
        /// </summary>
        public const string BUTTON_PAY_MAIN_FUNC_PRESS = "PayMainFuncPress.png";

        /// <summary>
        /// 거스름돈 팝업창 배경 이미지 (668x122)
        /// </summary>
        public const string CHANGE_POPUP = "blue_668x122.png";          //"tbl_change_popup.png";

        /// <summary>
        /// Grid Up/Down Button
        /// </summary>
        //public const string BUTTON_GRID_UP_ARROW = "grid_up_arrow.jpg";
        //public const string BUTTON_GRID_DOWN_ARROW = "grid_down_arrow.jpg";
        public const string BUTTON_GRID_UP_ARROW = "Navibtn_14x9_Up1_basic.png";
        /// <summary> BUTTON_GRID_DOWN_ARROW </summary>
        public const string BUTTON_GRID_DOWN_ARROW = "Navibtn_14x9_Down1_basic.png";
        /// <summary>
        /// Left/Right Arrow Button
        /// </summary>
        public const string BUTTON_LEFT_ARROW_BASIC = "btn_move01_left_basic.png";
        /// <summary> BUTTON_LEFT_ARROW_PRESS </summary>
        public const string BUTTON_LEFT_ARROW_PRESS = "btn_move01_left_press.png";
        /// <summary> BUTTON_RIGHT_ARROW_BASIC </summary>
        public const string BUTTON_RIGHT_ARROW_BASIC = "btn_move01_right_basic.png";
        /// <summary> BUTTON_RIGHT_ARROW_PRESS </summary>
        public const string BUTTON_RIGHT_ARROW_PRESS = "btn_move01_right_press.png";
        /// <summary> BUTTON_LEFT_ALL_ARROW_BASIC </summary>
        public const string BUTTON_LEFT_ALL_ARROW_BASIC = "btn_move02_left_basic.png";
        /// <summary> BUTTON_LEFT_ALL_ARROW_PRESS </summary>
        public const string BUTTON_LEFT_ALL_ARROW_PRESS = "btn_move02_left_press.png";
        /// <summary> BUTTON_RIGHT_ALL_ARROW_BASIC </summary>
        public const string BUTTON_RIGHT_ALL_ARROW_BASIC = "btn_move02_right_basic.png";
        /// <summary> BUTTON_RIGHT_ALL_ARROW_PRESS </summary>
        public const string BUTTON_RIGHT_ALL_ARROW_PRESS = "btn_move02_right_press.png";


        /// <summary>
        /// 그리드 헤더 삭제
        /// </summary>
        public const string ITEM_GRID_HDR_DEL = "03_spc_main_typeC_after_10.png";
        /// <summary>
        /// 그리드 아이템로우 삭제
        /// </summary>
        public const string ITEM_GRID_ROW_DEL = "03_spc_main_typeC_after_17.png";

        /// <summary>
        /// 주변장비 체크(DeviceCheck Image)
        /// </summary>
        public const string DEVICE_OK = "gearcheck_OK.png";
        /// <summary> DEVICE_NG </summary>
        public const string DEVICE_NG = "gearcheck_NG.png";
        /// <summary> DEVICE_PASS </summary>
        public const string DEVICE_PASS = "gearcheck_PASS.png";
        /// <summary> DEVICE_CHECK </summary>
        public const string DEVICE_CHECK = "gearcheck_CHECK.png";
        /// <summary> DEVICE_WAIT </summary>
        public const string DEVICE_WAIT = "gearcheck_WAIT.png";

        /// <summary>
        /// 결제 스텝 이미지 1 ~ 3
        /// </summary>
        public const string PAY_STEP_01 = "05_spc_pay_03.png";
        /// <summary> PAY_STEP_02 </summary>
        public const string PAY_STEP_02 = "05_spc_pay_12.png";
        /// <summary> PAY_STEP_03 </summary>
        public const string PAY_STEP_03 = "05_spc_pay_20.png";

        /// <summary> WEB_ICON </summary>
        public const string WEB_ICON = "webicon.png";
        /// <summary> WEB_ICON_ERROR </summary>
        public const string WEB_ICON_ERROR = "webicon_error.png";

        /// <summary>
        /// 달력 아이콘 기본
        /// </summary>
        public const string ICON_DATE_BASIC = "icon_date_basic.png";
        /// <summary>
        /// 달력 아이콘 클릭
        /// </summary>
        public const string ICON_DATE_PRESS = "icon_date_press.png";
        

        /// <summary>
        /// 스캐너 초기화 이미지 1 ~ 4
        /// </summary>
        public const string SCANNER_INIT_01 = "ScannerInit_01.png";
        /// <summary> SCANNER_INIT_02 </summary>
        public const string SCANNER_INIT_02 = "ScannerInit_02.png";
        /// <summary> SCANNER_INIT_03 </summary>
        public const string SCANNER_INIT_03 = "ScannerInit_03.png";
        /// <summary> SCANNER_INIT_04 </summary>
        public const string SCANNER_INIT_04 = "ScannerInit_04.png";
        
        /// <summary>
        /// MenuSlide 백그라운드
        /// </summary>
        public const string MENUSLIDE_BG = "MenuSlide_bg.png";
        /// <summary>
        /// MenuSlide 카테고리 버튼 기본
        /// </summary>
        public const string MENUSLIDE_CATEGORY_BTN_DEFAULT = "MenuSlide_category_btn_default.png";
        /// <summary>
        /// MenuSlide 카테고리 버튼 눌렸을때
        /// </summary>
        public const string MENUSLIDE_CATEGORY_BTN_PRESS = "MenuSlide_category_btn_press.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 왼쪽 (없을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_LEFT_DEFAULT = "MenuSlide_pagebtn_left_default.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 왼쪽 (있을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_LEFT_DIM = "MenuSlide_pagebtn_left_dim.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 왼쪽 (눌렸을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_LEFT_PRESS = "MenuSlide_pagebtn_left_press.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 오른쪽 (없을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_RIGHT_DEFAULT = "MenuSlide_pagebtn_right_default.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 오른쪽 (있을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_RIGHT_DIM = "MenuSlide_pagebtn_right_dim.png";
        /// <summary>
        /// MenuSlide 페이지 방향키 오른쪽 (눌렸을때)
        /// </summary>
        public const string MENUSLIDE_PAGEBTN_RIGHT_PRESS = "MenuSlide_pagebtn_right_press.png";


        /// <summary>
        /// 기능 화면 버튼 이미지 - 블루
        /// </summary>
        public const string MENU_BTN_BLUE_BASIC = "menu_btn_bule_basic.png";
        /// <summary>
        /// 기능 화면 버튼 이미지 - 블루 클릭
        /// </summary>
        public const string MENU_BTN_BLUE_PRESS = "menu_btn_bule_press.png";
        /// <summary>
        /// 기능 화면 버튼 이미지 - 그린
        /// </summary>
        public const string MENU_BTN_GREEN_BASIC = "menu_btn_green_basic.png";
        /// <summary>
        /// 기능 화면 버튼 이미지 - 그린 클릭
        /// </summary>
        public const string MENU_BTN_GREEN_PRESS = "menu_btn_green_press.png";
        /// <summary>
        /// 기능 화면 버튼 이미지 - 오렌지
        /// </summary>
        public const string MENU_BTN_ORANGE_BASIC = "menu_btn_orange_basic.png";
        /// <summary>
        /// 기능 화면 버튼 이미지 - 오렌지 클릭
        /// </summary>
        public const string MENU_BTN_ORANGE_PRESS = "menu_btn_orange_press.png";


        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_105X48_DOWN1_BASIC = "Navibtn_105x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_105X48_DOWN1_PRESS = "Navibtn_105x48_Down1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_105X48_DOWN2_BASIC = "Navibtn_105x48_Down2_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_105X48_DOWN2_PRESS = "Navibtn_105x48_Down2_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_105X48_UP1_BASIC = "Navibtn_105x48_up1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_105X48_UP1_PRESS = "Navibtn_105x48_up1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_105X48_UP2_BASIC = "Navibtn_105x48_up2_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_105X48_UP2_PRESS = "Navibtn_105x48_up2_press.png";

        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_164X48_DOWN1_BASIC = "Navibtn_164x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_164X48_DOWN1_PRESS = "Navibtn_164x48_Down1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_164X48_DOWN2_BASIC = "Navibtn_164x48_Down2_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_164X48_DOWN2_PRESS = "Navibtn_164x48_Down2_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_164X48_UP1_BASIC = "Navibtn_164x48_up1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_164X48_UP1_PRESS = "Navibtn_164x48_up1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 
        /// </summary>
        public const string NAVIBTN_164X48_UP2_BASIC = "Navibtn_164x48_up2_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_164X48_UP2_PRESS = "Navibtn_164x48_up2_press.png";

        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_170X48_UP1_BASIC = "Navibtn_170x48_Up1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_170X48_UP1_PRESS = "Navibtn_170x48_Up1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_170X48_DOWN1_BASIC = "Navibtn_170x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_170X48_DOWN1_PRESS = "Navibtn_170x48_Down1_press.png";

        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_210X48_UP1_BASIC = "Navibtn_210x48_Up1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_210X48_UP1_PRESS = "Navibtn_210x48_Up1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_210X48_DOWN1_BASIC = "Navibtn_210x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_210X48_DOWN1_PRESS = "Navibtn_210x48_Down1_press.png";

        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_378X48_UP1_BASIC = "Navibtn_378x48_Up1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_378X48_UP1_PRESS = "Navibtn_378x48_Up1_press.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_378X48_DOWN1_BASIC = "Navibtn_378x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 기본 이미지 클릭
        /// </summary>
        public const string NAVIBTN_378X48_DOWN1_PRESS = "Navibtn_378x48_Down1_press.png";

        /// <summary>
        /// 네비게이션 버튼 기본 이미지 (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_UP1_BASIC = "Navibtn_496x48_Up1_basic.png";
        /// <summary>
        /// 네비게이션 버튼 기본 이미지 클릭 (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_UP1_PRESS = "Navibtn_496x48_Up1_press.png";
        /// <summary>
        /// 네비게이션 버튼 dim (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_UP1_DIM = "Navibtn_496x48_Up1_dim.png";
        /// <summary>
        /// 네비게이션 버튼 기본 이미지 (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_DOWN1_BASIC = "Navibtn_496x48_Down1_basic.png";
        /// <summary>
        /// 네비게이션 버튼 기본 이미지 클릭 (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_DOWN1_PRESS = "Navibtn_496x48_Down1_press.png";
        /// <summary>
        /// 네비게이션 버튼 dim (496x48)
        /// </summary>
        public const string NAVIBTN_496X48_DOWN1_DIM= "Navibtn_496x48_Down1_dim.png";


        /// <summary>
        /// 외국인대응(영어)
        /// </summary>
        public const string ENGLISH_INFO = "English_Info.png";
        /// <summary>
        /// 외국인대응(일본어)
        /// </summary>
        public const string JAPANESE_INFO = "Japanese_Info.png";
        /// <summary>
        /// 외국인대응(중국어)
        /// </summary>
        public const string CHINESE_INFO = "Chinese_Info.png";


        /// <summary>
        /// 종료버튼
        /// </summary>
        public const string BTN_CLOSE = "btn_close.png";

        /// <summary> BTN_SAVER_PART </summary>
        public const string BTN_SAVER_PART = "btnSaverPart.png";
        /// <summary> BTN_SAVER_OWN </summary>
        public const string BTN_SAVER_OWN = "btnSaverOwn.png";

        /// <summary>
        /// 버튼업1
        /// </summary>
        public const string NAVIBTN_14X9_DOWN1_BASIC = "Navibtn_14x9_Down1_basic.png";
        /// <summary>
        /// 버튼업2
        /// </summary>
        public const string NAVIBTN_14X9_DOWN2_BASIC = "Navibtn_14x9_Down2_basic.png";
        /// <summary>
        /// 버튼다운1
        /// </summary>
        public const string NAVIBTN_14X9_UP1_BASIC = "Navibtn_14x9_Up1_basic.png";
        /// <summary>
        /// 버튼다운2
        /// </summary>
        public const string NAVIBTN_14X9_UP2_BASIC = "Navibtn_14x9_Up2_basic.png";

        /// <summary>
        /// 이미지 저장 변수
        /// </summary>
        private static Hashtable g_htImageManager;

        static ImageManager()
        {
            g_htImageManager = new Hashtable();
        }

        /// <summary>
        /// Image Add
        /// </summary>
        /// <param name="sImagePath"></param>
        /// <param name="sImageName"></param>
        public static bool AddImage(string sImagePath, string sImageName)
        {
            try
            {
                if(File.Exists(sImagePath + sImageName) == true)
                {
                    g_htImageManager.Add(sImageName, Image.FromFile(sImagePath + sImageName));
                    return true;
                }
            }
            catch { }

            return false;
        }

        /// <summary>
        /// GetImage
        /// </summary>
        /// <param name="sImageName"></param>
        /// <returns></returns>
        public static Image GetImage(string sImageName)
        {
            Image oImage = null;

            try
            {
                if(g_htImageManager.Contains(sImageName) == true)
                {
                    oImage = (Image)g_htImageManager[sImageName];
                }
            }
            catch { }

            return oImage;
        }
        /// <summary> GetImage </summary>
        public static Image GetImage(string sImagePath, string sImageName)
        {
            Image oImage = null;
            try
            {
                oImage = GetImage(sImageName);
                if(oImage == null)
                {
                    if(AddImage(sImagePath, sImageName) == true)
                    {
                        oImage = GetImage(sImageName);
                    }
                }
            }
            catch { }

            return oImage;
        }
    }
}
