﻿using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 해피포인트 추후 적립
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class PointHappyPointAfter : PaymentBase, IPaymentUs
    {
        /// <summary>
        /// 현재 등록중인 기타 정보
        /// </summary>
        protected Column.TR_ETC.DATA m_cEtcItem = null;

        public PointHappyPointAfter()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회(해피포인트조회)
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "", sAppCardNo = "";
            
            try
            {
                sInPutType = aParam[0];                             // 입력구분
                sInPutData = aParam[1];                             // 입력데이터
                sInEncData = aParam[2];                             // 카드데이터
                m_bErrMsgShow = aParam[3] == "0" ? false : true;    // 메시지 출력여부(0:미출력, 1;출력)
                if (aParam.Length > 4) sAppCardNo = aParam[4];      // 승인카드번호

                m_cEtcItem = new Column.TR_ETC.DATA();              // 결과 저장 변수 생성
                m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT;

                sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A, "HPY", sInPutType, sInPutData, sInEncData, 0, 0, "", "", "", "");
                if (sRet != UserCom.RST_OK) return sRet;

                if (m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "")
                {
                    int nNowPos = 0;
                    string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH), ref nNowPos, ref aIrtRsp);

                    // 포인트 적립가능여부
                    if (aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPADDYN] != "Y")
                    {
                        if (m_bErrMsgShow == true) WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0070));
                        return UserCom.RST_ERR;
                    }
                    // 앱고객 여부앱고객 여부(N:일반, Y:앱고객)
                    m_cEtcItem.OCCUR_ENTRY_12 = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPAPPYN];
                    // 고객명 설정
                    string sCustInfo = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMINFO];
                    if (sCustInfo != "" && CmUtil.IntParse(sCustInfo.Substring(0, 1)) > 0)
                    {
                        m_cEtcItem.HP_CUST_NAME = CmUtil.MidH(sCustInfo, 17, 20).Trim();    // 고객명
                        //#20180821 해피포인트 고객이름 마스킹 start
                        if (m_cEtcItem.HP_CUST_NAME != "") { m_cEtcItem.HP_CUST_NAME = m_cDataCommon.NameMasking(m_cEtcItem.HP_CUST_NAME); } 
                        //#20180821 해피포인트 고객이름 마스킹 end
                        m_cEtcItem.OCCUR_ENTRY_10 = CmUtil.MidH(sCustInfo, 45, 35).Trim();  // 회원번호
                    }
                    // 소멸예정포인트
                    m_cEtcItem.HP_EXT_POINT = CmUtil.LongParse(aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointDELHPPOINT]);
                }
                m_cEtcItem.OCCUR_ENTRY_14 = sAppCardNo;     // 승인카드번호
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cEtcItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록(해피포인트 사후 적립)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "", sAppCardNo = "";

            try
            {
                if (aParam.Length > 0 && aParam[0] == PosConst.POS_CAT_MASTER.TRAN_TYPE)    //단말기승인
                {

                    m_cEtcItem = new Column.TR_ETC.DATA();
                                        
                    m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                    m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT;


                    // 적립 대상 금액 셋팅
                    m_cEtcItem.AMT_ENTRY_09 = CmUtil.DoubleParse(aParam[16]);

                    sRet = CatExecuteIrt(aParam[1], aParam);
                    if (sRet != UserCom.RST_OK) return sRet;
                }
                else
                {
                    sInPutType = aParam[0];                             // 입력구분
                    sInPutData = aParam[1];                             // 입력데이터(마스킹)
                    sInEncData = aParam[2];                             // 카드데이터(암호화)
                    double nNetSaleAmt = CmUtil.DoubleParse(aParam[3]); 
                    double nAfterSaveAmt = CmUtil.DoubleParse(aParam[4]);
                    string sAfterSaveInfo = aParam[5].TrimEnd();           // 추가적립 정보
                    if (aParam.Length > 6) sAppCardNo = aParam[6];      // 승인카드번호

                    //m_cEtcItem = new Column.TR_ETC.DATA();  // 결과 저장 변수 생성
                    m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                    m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT;

                    //sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A, "HPY", sInPutType, sInPutData, sInEncData, nNetSaleAmt, nAfterSaveAmt, "", "", "", "");
                    //if (sRet != UserCom.RST_OK) return sRet;


                    // 추가적립 정보 = [캠페인코드(10)+대상상품금액(15)+추가적립여부(1)+추가적립상세코드(2)+본사부담금(7)+매장부담금(7)]
                    string sHP_ADD_ACCUME = "";
                    if (sAfterSaveInfo != "")
                    {
                        string sCPI_CD = sAfterSaveInfo.Substring(0, 10).Trim();
                        double nAddSaveAmt = CmUtil.DoubleParse(sAfterSaveInfo.Substring(10, 15).Trim());
                        sHP_ADD_ACCUME = sAfterSaveInfo.Substring(25);
                        double nAddSavePnt = CmUtil.DoubleParse(sHP_ADD_ACCUME.Substring(3, 7));
                        if (sHP_ADD_ACCUME.StartsWith("N") == true)
                        {
                            sHP_ADD_ACCUME = sHP_ADD_ACCUME.Substring(0, 3) + string.Format("{0:D7}{1:D7}", 0, 0);
                        }
                        m_cEtcItem.ETC_DTL_CD_02 = sCPI_CD;                         // 캠페인코드
                        m_cEtcItem.AMT_ENTRY_10 = nAddSaveAmt;                      // 추가적립대상금액
                    }
                    m_cEtcItem.AMT_ENTRY_09 = CmUtil.DoubleParse(aParam[7]);       // 기본적립대상금액

                    // 추후 적립 처리
                    sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_A, "HPY", sInPutType, sInPutData, sInEncData
                            , nNetSaleAmt, nAfterSaveAmt, sHP_ADD_ACCUME, "", "", "");
                    if (sRet != UserCom.RST_OK) return sRet;

                    m_cEtcItem.OCCUR_ENTRY_11 = "0";
                    if (m_cEtcItem.HP_ADD_INFO_SAVE.Trim() != "")
                    {
                        int nNowPos = 0;
                        string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SAVE.LEN.Length];
                        ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SAVE.LEN, Column.POINT_ADD_INFO_SAVE.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SAVE), ref nNowPos, ref aIrtRsp);

                        m_cEtcItem.AMT_ENTRY_07 = CmUtil.DoubleParse(aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.AddSavePnt]);   // 추가적립포인트
                        m_cEtcItem.OCCUR_ENTRY_11 = (aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.AddSaveYN] == "Y") ? "1" : "0"; // 추가적립여부

                        
                        m_cEtcItem.HP_CUST_NAME = aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.CustName].Trim();                  // 고객명 설정
                        //#20180821 해피포인트 고객이름 마스킹 start
                        if (m_cEtcItem.HP_CUST_NAME != "") { m_cEtcItem.HP_CUST_NAME = m_cDataCommon.NameMasking(m_cEtcItem.HP_CUST_NAME); } 
                        //#20180821 해피포인트 고객이름 마스킹 end
                    }
                }
                sRet = UserCom.RST_OK;

                // 기타 아이템 추가
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;

            try
            {
                
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region CompletePayment 결제 확정
        /// <summary>
        /// 결제 확정
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CompletePayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
 
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 해피포인트 조회 실행
        /// <summary>
        /// 해피포인트 조회 실행
        /// </summary>
        public string ExecutePointHappyPointIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sInEncData
            , double nNetSaleAmt, double nBasicSaveAmt, string sAddSaveInfo, string sCampaingInfo
            , string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (sInPutData.Length >= 6) sInPutData = sInPutData.Substring(0, 6).PadRight(sInPutData.Length, '*');

                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, nBasicSaveAmt, sApprDate, sApprNo);

                string sAddInfo = "";
                if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)      
                {
                    // 조회
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.StoreNo, 10);    // 점포코드
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // 포스번호
                    sAddInfo += CmUtil.RPadH("", 178);                          // VReserved
                }
                else if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_A || sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_C)
                {
                    // 적립,적립취소
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 8);    // POS 영업일자 - POS 매출일자 8자리
                    sAddInfo += "1001";                                         // 거래사유코드 - 1001:대금결제, 1002:포인트고객적립, 1003:운영사이벤트, 1004:제휴사 이벤트
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 10);   // SAP 코드 - POS 매출일자 10자리
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // POS 번호
                    sAddInfo += "10";                                           // 요청구분 - 10:일반적립, 20:캐시포인트적립
                    sAddInfo += "20";                                           // 적립방식구분코드 - 10:즉시적립, 20:영수증추후적립                    
                    sAddInfo += string.Format("{0:D10}", (long)nBasicSaveAmt);  // 총적립대상금액
                    sAddInfo += "0000000";                                      // 캐시포인트 - 고객이 현금을 캐쉬로 적립 요청한 경우 적립할 캐시포인트
                    sAddInfo += CmUtil.RPadH("", 20);                           // 결제카드번호 - 신용 결제한 카드번호
                    sAddInfo += CmUtil.RPadH("", 125); ;                        // VReserved
                }

                string sVanCD = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                // 포인트 조회
                string[] aIrtRsp = null;
                sRet = ExecutePointIrt(sTradeDiv, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, sApprDate, sApprNo, "", "", sAddSaveInfo, sCampaingInfo, sAddInfo, ref aIrtRsp, "1", m_cEtcItem.OCCUR_ENTRY_10);
                if (sRet != UserCom.RST_OK) return sRet;

                m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;                                         // 할인결제구분 (1:결제, 2:할인)

                m_cEtcItem.ETC_AMT = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]);          // 적립포인트
                m_cEtcItem.AMT_ENTRY_01 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]);     // 적립포인트     
                m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 총포인트(누적포인트)
                m_cEtcItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint]);   // 가용포인트
                m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 누적포인트
                m_cEtcItem.AMT_ENTRY_08 = nBasicSaveAmt;            // 적립대상금액1(기본적립)

                m_cEtcItem.OCCUR_ENTRY_01 = sInPutData;             // 카드번호
                m_cEtcItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;             // 입력 구분
                m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;                // 원승인번호
                m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;              // 원승인일자
                m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                               // 승인구분
                m_cEtcItem.OCCUR_ENTRY_09 = "1";                    // 거래후 적립 구분(0:일반, 1:사후)
                m_cEtcItem.OCCUR_ENTRY_16 = sVanCD;                 // VAN 구분
                m_cEtcItem.OCCUR_ENTRY_18 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResStoreNo];                       // 가맹점번호
                m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부

                m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;      // 빌분리 번호

                m_cEtcItem.CanFiller1 = sInEncData;

                m_cEtcItem.HP_RESERVED = aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim();      // 예약필드
                m_cEtcItem.HP_CAMPAIGN_INFO = aIrtRsp[Column.POS_RES_POINT.SEQ.ResCampaign].Trim(); // 캠페인정보

                if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)      
                    m_cEtcItem.HP_ADD_INFO_SCH = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();     // 추가응답정보
                else
                    m_cEtcItem.HP_ADD_INFO_SAVE = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();     // 추가응답정보

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        public string SetTrainingData(string sTrType, string sPointType, string sInPutType, string sInPutData, string sInEncData
            , double nNetSaleAmt, double nBasicSaveAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정
                string sVanCD = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                double nSavePnt = CmUtil.MathRounds(CmUtil.MathAmtPercent(nBasicSaveAmt, m_cPosStatus.Mst.HpyPntAccumRate), PosConst.MATH_ROUND.CEILING, 0); // 5% 적립

                m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL; // 할인결제구분 (1:결제, 2:할인)

                m_cEtcItem.ETC_AMT = nSavePnt;
                m_cEtcItem.AMT_ENTRY_01 = nSavePnt;         // 적립포인트
                m_cEtcItem.AMT_ENTRY_03 = 99990;            // 총포인트
                m_cEtcItem.AMT_ENTRY_04 = 99990;            // 가용포인트
                m_cEtcItem.AMT_ENTRY_05 = 0;
                m_cEtcItem.AMT_ENTRY_08 = nNetSaleAmt;      // 적립대상금액
                
                m_cEtcItem.OCCUR_ENTRY_01 = sInPutData;     // 카드번호
                m_cEtcItem.OCCUR_ENTRY_02 = "99999999";                         // 승인번호
                m_cEtcItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");    // 승인일자
                m_cEtcItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmm");      // 승인시간
                m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;     // 입력구분
                m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;        // 원승인번호
                m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;      // 원승인일자
                m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.COMPULSION;                                               // 승인구분
                m_cEtcItem.OCCUR_ENTRY_09 = "0";            // 거래후 적립 구분(0:일반, 1:사후)
                m_cEtcItem.OCCUR_ENTRY_16 = sVanCD;         // VAN 구분
                m_cEtcItem.OCCUR_ENTRY_18 = "";
                m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부
                
                m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;              // 빌분리 번호

                m_cEtcItem.CanFiller1 = sInEncData;
 
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region Cat단말기 승인 처리
        /// <summary>
        /// Cat단말기 승인 처리
        /// </summary>
        /// <param name="sAppType"></param>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CatExecuteIrt(string sAppType, string[] aParam)
        {

            string sRet = UserCom.RST_ERR;

            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return SetTrainingData(sAppType, "", "K", "999999*********", "", CmUtil.DoubleParse(aParam[3]), m_cTrnStatus.Head.AftSavePoint, DateTime.Now.ToString("yyyyMMdd"), "99999999");


                string sAddInfo = "";
                if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                {
                    // 조회
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.StoreNo, 10);    // 점포코드
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // 포스번호
                    sAddInfo += CmUtil.RPadH("", 178);                          // VReserved
                }
                else
                {
                    // 적립,적립취소
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 8);    // POS 영업일자 - POS 매출일자 8자리
                    sAddInfo += "1001";                                         // 거래사유코드 - 1001:대금결제, 1002:포인트고객적립, 1003:운영사이벤트, 1004:제휴사 이벤트
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 10);   // SAP 코드 - POS 매출일자 10자리
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // POS 번호
                    sAddInfo += "10";                                           // 요청구분 - 10:일반적립, 20:캐시포인트적립
                    sAddInfo += "10";                                           // 적립방식구분코드 - 10:즉시적립, 20:영수증추후적립                    
                    sAddInfo += string.Format("{0:D10}", CmUtil.LongParse(aParam[3]));  // 총적립대상금액
                    sAddInfo += "0000000";                                      // 캐시포인트 - 고객이 현금을 캐쉬로 적립 요청한 경우 적립할 캐시포인트
                    sAddInfo += CmUtil.RPadH("", 20);                           // 결제카드번호 - 신용 결제한 카드번호
                    sAddInfo += CmUtil.RPadH("", 125);                          // VReserved
                }

                aParam[11] = sAddInfo;

                string sRecvdData = "";
                string sAppLogDiv = "";
                string sInputType = "";

                if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SAVE || sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                {
                    sAppLogDiv = PosConst.CANCEL_DIV.NORMAL;
                }
                else
                {
                    sAppLogDiv = PosConst.CANCEL_DIV.CANCEL;
                }

                string[] aIrtDTLRsp = new string[Column.POS_RES_SPCN_CAT.LEN.Length];

                //전문 송/수신
                if (CatTerminalExecuteIrtCom(sAppType, sAppLogDiv, aParam, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, ref aIrtDTLRsp, ref sRecvdData, ref sInputType) == false)
                {
                    //WinManager.ErrorMessage(sRecvdData);
                    return sRet;
                }

                if (sAppLogDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;                                                             // 할인결제구분 (1:결제, 2:할인)

                    m_cEtcItem.ETC_AMT = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 0, 9));         // 적립포인트
                    m_cEtcItem.AMT_ENTRY_01 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 0, 9));    // 적립포인트     
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 총포인트(누적포인트)

                    if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                        m_cEtcItem.AMT_ENTRY_04 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 9, 9));   // 가용포인트

                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));      // 누적포인트
                    m_cEtcItem.AMT_ENTRY_08 = CmUtil.DoubleParse(aParam[3]);            // 적립대상금액1(기본적립)

                    m_cEtcItem.OCCUR_ENTRY_01 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim().Length == 6 ? aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim() + "*********" : aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim();  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppNo].Trim();                    // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 0, 6);  // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 6, 4);  // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInputType;                     // 입력 구분
                    m_cEtcItem.OCCUR_ENTRY_06 = "";                             // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = "";                             // 원승인일자
                    m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.CAT_TERMINAL;   //승인구분
                    m_cEtcItem.OCCUR_ENTRY_09 = "1";                            // 거래후 적립 구분(0:일반, 1:사후)
                    m_cEtcItem.OCCUR_ENTRY_12 = "N";                            // 앱고객 여부(N:일반, Y:앱고객)
                    m_cEtcItem.OCCUR_ENTRY_16 = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);      // VAN 구분
                    m_cEtcItem.OCCUR_ENTRY_18 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.FranchiseNo];                     // 가맹점번호
                    m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                    m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부

                    m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                    m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;      // 빌분리 번호

                    m_cEtcItem.HP_RESERVED = "";        // 예약필드
                    m_cEtcItem.HP_CAMPAIGN_INFO = "";   // 캠페인정보
                    m_cEtcItem.HP_ADD_INFO_SCH = "";    // 추가응답정보
                    m_cEtcItem.HP_ADD_INFO_SAVE = "";   // 추가응답정보

                }
                else
                {
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 총포인트(누적포인트)
                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 누적포인트

                    m_cEtcItem.OCCUR_ENTRY_01 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim().Length == 6 ? aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim() + "*********" : aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim();  // 카드번호

                    m_cEtcItem.OCCUR_ENTRY_06 = m_cEtcItem.OCCUR_ENTRY_02;                // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = m_cEtcItem.OCCUR_ENTRY_03;              // 원승인일자

                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppNo].Trim();                       // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInputType;             // 입력 구분

                    m_cEtcItem.HP_ADD_INFO_SAVE = "";    // 추가응답정보

                }
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

    }
}
