﻿using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 스마일페이
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class SmilePay : PaymentBase, IPaymentUs
    {

        public SmilePay()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;
            string sPosMenuKey = "", sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                sPosMenuKey = aParam[0];                     // 메뉴키
                sInPutType = aParam[1];                      // 입력구분
                sInPutData = aParam[2];                      // 입력데이터
                sInEncData = aParam[3];                       // 카드데이터
                
                string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A;
                string sPointType = GetMenuKeyToPointType(sPosMenuKey);

                m_cPayItem = new Column.TR_PAYMENT.DATA();      // 결과 저장 변수 생성
                m_cPayItem.PAY_WAY_CD = GetMenuKeyToPayWayCd(sPosMenuKey);
                m_cPayItem.PAY_DTL_CD_01 = GetMenuKeyToPayDtlCd(sPosMenuKey);

                //#17169 스마일페이 변경요청 건 start
                string sSmilepayPromotionCode = ""; // aParam.Length >= 8 ? aParam[7] : ""; // 스마일페이 프로모션코드
                double dSmileCashTargetAmt = 0; //aParam.Length >= 9 ? CmUtil.DoubleParse(aParam[8]) : 0; // 스마일캐시 적립대상금액
                //#17169 스마일페이 변경요청 건 end

                //#17169 스마일페이 변경요청 건 start
                //기존
                //sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, 0, "", "", "");
                //변경
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, 0, "", "", "", sSmilepayPromotionCode, dSmileCashTargetAmt);
                //#17169 스마일페이 변경요청 건 end
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cPayItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록(제휴 포인트 사용)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sPosMenuKey = "", sInPutType = "", sInPutData = "", sInEncData = "", sInOrgData = "";

            try
            {
                sPosMenuKey = aParam[0];                     // 메뉴키
                sInPutType = aParam[1];                      // 입력구분
                sInPutData = aParam[2];                      // 입력데이터(마스킹)
                sInEncData = aParam[3];                      // 카드데이터
                double nPayAmt = CmUtil.DoubleParse(aParam[4]);     // 대상금액
                string sPassWord = "";                              // 비밀번호
                sInOrgData = aParam[6];                      // 입력데이터(원데이터)
                
                string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_USE_A;
                string sPointType = GetMenuKeyToPointType(sPosMenuKey);
                //#17169 스마일페이 변경요청 건 start
                string sSmilepayPromotionCode = aParam.Length >= 8 ? aParam[7] : ""; // 스마일페이 프로모션코드
                double dSmileCashTargetAmt = aParam.Length >= 9 ? CmUtil.DoubleParse(aParam[8]) : 0; // 스마일캐시 적립대상금액
                //#17169 스마일페이 변경요청 건 end

                m_cPayItem = new Column.TR_PAYMENT.DATA();      // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = GetMenuKeyToPayWayCd(sPosMenuKey);
                m_cPayItem.PAY_DTL_CD_01 = GetMenuKeyToPayDtlCd(sPosMenuKey);

                //#17169 스마일페이 변경요청 건 start
                //기존
                //sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, "", "");
                //변경
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, "", "", sSmilepayPromotionCode, dSmileCashTargetAmt);
                //#17169 스마일페이 변경요청 건 end

                if (sRet != UserCom.RST_OK) return sRet;

                // 결제 아이템 추가
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);     // 결제 내역 받아 오기
                m_cPayItem.SEQ = alPayItem.Count + 1;
                m_cPayItem.CanFiller2 = sInOrgData;         // 스마일페이번호(해피포인트 적립용)
                alPayItem.Add(m_cPayItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0067));
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                sInPutType = m_cPayItem.OCCUR_ENTRY_05;          // 입력구분
                sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                sInEncData = m_cPayItem.CanFiller1;               // 카드데이터

                double nPayAmt = m_cPayItem.AMT_ENTRY_01;               // 대상금액
                string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호
                string sPassWord = "";                                  // 비밀번호

                string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_USE_C;
                string sPointType = GetPayDtlCdToPointType(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);
                //#17169 스마일페이 변경요청 건 start
                string sSmilepayPromotionCode = "";// aParam.Length >= 8 ? aParam[7] : ""; // 스마일페이 프로모션코드
                double dSmileCashTargetAmt = 0; // aParam.Length >= 9 ? CmUtil.DoubleParse(aParam[8]) : 0; // 스마일캐시 적립대상금액
                //#17169 스마일페이 변경요청 건 end

                //#17169 스마일페이 변경요청 건 start
                //기존
                //sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, sApprDate, sApprNo);
                //변경
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, sApprDate, sApprNo, sSmilepayPromotionCode, dSmileCashTargetAmt);
                //#17169 스마일페이 변경요청 건 end

                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                //#20171218 스마일페이 캠페인 적용 후 결제취소시 캠페인 취소 안되는 증상 수정 start
                ICampaignUs cCampaingMain = (ICampaignUs)sManager.InitServiceInstance(ServiceLists.ASV_CAMPAIGN.DLL, ServiceLists.ASV_CAMPAIGN.CAMPAIGN_MAIN);
                // 캠페인 취소 처리
                cCampaingMain.CancelCampaignPayment(aParam[0], "");
                //#20171218 스마일페이 캠페인 적용 후 결제취소시 캠페인 취소 안되는 증상 수정 end

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0068));
                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_cPayItem.CanFiller1);
                //////////////////////////////////////////////////////////////////////////////////
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                if (m_cPayItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                {
                    //임의 등록 이면 승인 없이 데이터 처리
                    //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                    m_cPayItem.OCCUR_ENTRY_06 = m_cPayItem.OCCUR_ENTRY_02;
                    m_cPayItem.OCCUR_ENTRY_07 = m_cPayItem.OCCUR_ENTRY_03;

                }
                else
                {
                    sInPutType = m_cPayItem.OCCUR_ENTRY_05;          // 입력구분
                    sInPutData = m_cPayItem.OCCUR_ENTRY_01;          // 입력데이터
                    sInEncData = m_cPayItem.CanFiller1;             // 카드데이터

                    double nPayAmt = m_cPayItem.AMT_ENTRY_01;               // 대상금액
                    string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                    string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호
                    string sPassWord = "";                                  // 비밀번호

                    string sTrType = PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_USE_C;
                    string sPointType = GetPayDtlCdToPointType(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);

                    //#17169 스마일페이 변경요청 건 start
                    string sSmilepayPromotionCode = "";// aParam.Length >= 8 ? aParam[7] : ""; // 스마일페이 프로모션코드
                    double dSmileCashTargetAmt = 0;// aParam.Length >= 9 ? CmUtil.DoubleParse(aParam[8]) : 0; // 스마일캐시 적립대상금액
                    //#17169 스마일페이 변경요청 건 end

                    //#17169 스마일페이 변경요청 건 start
                    //기존
                    //sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, sApprDate, sApprNo);
                    //변경
                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nPayAmt, sPassWord, sApprDate, sApprNo, sSmilepayPromotionCode, dSmileCashTargetAmt);
                    //#17169 스마일페이 변경요청 건 end

                    if (sRet != UserCom.RST_OK) return sRet;
                }
                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_cPayItem.CanFiller1);
                //////////////////////////////////////////////////////////////////////////////////
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 조회
        /// <summary>
        /// 조회
        /// </summary>
        
        //#17169 스마일페이 변경요청 건 start
        //기존
        //public string ExecuteIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sPassWord, string sApprDate, string sApprNo)
        //변경
        public string ExecuteIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sPassWord, string sApprDate, string sApprNo, string sSmilepayPromotionCode, double dSmileCashTargetAmt)
        //#17169 스마일페이 변경요청 건 end
        
        {
            string sRecvData = "";
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sPassWord, sApprDate, sApprNo);

                // 승인업체 코드 조회
                string sVanCD = PosMstManager.GetMstPayDc(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);
                if (sVanCD == "")
                {
                    //WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                // 포인트 조회,사용,사용취소
                string[] aIrtRsp = null;

                //#17169 스마일페이 변경요청 건 start
                //기존
                //sRet = ExecutePointIrt(sTradeDiv, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo, sPassWord, "", "", "", "", ref aIrtRsp, "", "");

                //변경
                string sReserved = "";

                if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_USE_A && sPointType == "SMP")
                {
                    //프로모션코드(10byte) + 적립대상금액(12byte) 
                    //sReserved = CmUtil.LPadH(sSmilepayPromotionCode, 10) + CmUtil.LPadH(dSmileCashTargetAmt.ToString(), 12);
                    //sReserved = CmUtil.RPadH(sSmilepayPromotionCode, 10) + CmUtil.RPadH(dSmileCashTargetAmt.ToString(), 12);
                    sReserved = CmUtil.RPadH(sSmilepayPromotionCode, 10) + dSmileCashTargetAmt.ToString().PadLeft(12, '0').Trim();
                }

                sRet = ExecutePointIrt(sTradeDiv, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sCardData, nPayAmt, sApprDate, sApprNo, sPassWord, "", sReserved, "", "", ref aIrtRsp, "", "");
                //#17169 스마일페이 변경요청 건 end

                
                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                                                             // 카드번호
                m_cPayItem.PAY_AMT = nPayAmt;

                m_cPayItem.PAY_DTL_CD_02 = "";                                                                      // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "";
                m_cPayItem.PAY_DTL_CD_04 = "";
                m_cPayItem.PAY_DTL_CD_05 = "1";                                                                     // 할인적립구분 (1:결제, 2:할인)

                double nAlterPayAmt = 0;
                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                    nAlterPayAmt = CmUtil.DoubleAdd(CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint].Trim()), nPayAmt);
                else
                    nAlterPayAmt = CmUtil.DoubleSubtraction(CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint].Trim()), nPayAmt);
                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                                                                  // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                                                        // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = nAlterPayAmt;                                                             // 거래전 잔액
                m_cPayItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint].Trim());// 거래후 잔액
                m_cPayItem.AMT_ENTRY_05 = 0;
                m_cPayItem.AMT_ENTRY_06 = 0;
                //m_cPayItem.AMT_ENTRY_07 = 0;
                m_cPayItem.AMT_ENTRY_08 = 0;
                m_cPayItem.AMT_ENTRY_09 = 0;
                m_cPayItem.AMT_ENTRY_10 = 0;

                m_cPayItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                     // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);         // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);         // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;                                                             // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                              // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                           // 승인구분

                m_cPayItem.OCCUR_ENTRY_09 = "";
                m_cPayItem.OCCUR_ENTRY_10 = "";                    // 가맹점 정보
                m_cPayItem.OCCUR_ENTRY_12 = "";                   //  결제 정보
                m_cPayItem.OCCUR_ENTRY_13 = "";
                m_cPayItem.OCCUR_ENTRY_16 = sVanCD;              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_19 = aIrtRsp[Column.POS_RES_POINT.SEQ.Resnotice4].Trim();                        // 카드명
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                //m_cPayItem.CanFiller1 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;                                              // 빌분리 번호

                if (CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim(), 0, 3) == "SMP")
                {
                    if (CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim(), 15, 1) == "Y")
                    {
                        m_cPayItem.OCCUR_ENTRY_21 = ItemConst.PAY_CASHBILL_DIV.YES;                                 // 현금영수증 발행 여부
                        m_cPayItem.AMT_ENTRY_07 = CmUtil.DoubleParse( CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim(), 3, 12));
                    }
                    else
                    {
                        m_cPayItem.OCCUR_ENTRY_21 = ItemConst.PAY_CASHBILL_DIV.NO;                                  // 현금영수증 발행 여부
                        m_cPayItem.AMT_ENTRY_07 = 0;
                    }
                }
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        public string SetTrainingData(string sTrType, string sPointType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sPassWord, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정

                // 결제구분 (1:결제, 2:할인)
                DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                m_cPayItem.PAY_AMT = nPayAmt;

                m_cPayItem.PAY_DTL_CD_02 = "";                                  // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "";
                m_cPayItem.PAY_DTL_CD_04 = "";
                m_cPayItem.PAY_DTL_CD_05 = "1";                                 // 할인적립구분 (1:결제, 2:할인)

                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                              // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                    // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = 0;                                    // 총포인트
                m_cPayItem.AMT_ENTRY_04 = 0;                                    // 가용포인트
                m_cPayItem.AMT_ENTRY_05 = 0;                                    // 잔여포인트
                m_cPayItem.AMT_ENTRY_08 = 0;

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                         // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = "99999999";                         // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");    // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");    // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;                         // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                            // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                          // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;       //승인구분

                m_cPayItem.OCCUR_ENTRY_09 = "";
                m_cPayItem.OCCUR_ENTRY_10 = "";                                 // 가맹점 정보
                m_cPayItem.OCCUR_ENTRY_12 = "";                                 // 알리페이 결제 정보
                m_cPayItem.OCCUR_ENTRY_13 = "";
                m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                //m_cPayItem.CanFiller1 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;          // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion
    }
}
