﻿using System;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using System.Data;

using Cosmos.Win;
using Cosmos.BaseFrame;
using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 통신사할인(SKT,KT,LGT) 및 제휴할인(OILBANK,BLUE MEMBER...)
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Win
{
    public partial class frmPntMobileUnity : frm_PayMainBack
    {

        #region 변수 선언

        private SManager sManager = new SManager();                                 // 이 객체를 통해 업무 Service 호출
        private StateServer StateObject = (StateServer)StateServer.GetInstance();   // StateObject : StateServer Object (객체)
        private PosStatus m_cPosStatus = new PosStatus();                           // 기본정보 참조
        private TranStatus m_cTrnStatus = new TranStatus();                         // 거래정보 참조        
        private DeviceStatus m_cDevStatus = new DeviceStatus();                     // 디바이스 관리
        private PosOLEDevice.DelegateOlePos delegatePos;
        private PosOLEDevice.DelegateIcReader delegateReader;                       // IC리더 콜백
        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        private PosOLEDevice.CallbackIc delegateReaderCardInfo;                     // IC리더 콜백(CardInfo)
        private bool m_bCardInPut;                                                  //카드 입력 중복 방지
        private string m_sIcChip;                                                   //IC CHIP DATA(EMV)
        private string m_InputType = ""; //PosConst.POS_VAN_MASTER.VAN_KEYIN;       //입력구분
        private string m_sCardNo;                                                   //입력 카드 번호
        private string m_sFallDiv;                                                  //FallBack구분
        private string m_sServiceCode;                                              //서비스코드
        */
        //#20170918 IC 콜백 함수 변경 end

        private IICReaderUs m_cDeviceICReader = null;
        private ISignPadUs m_cDeviceSignPad = null;
        private IDataProcessUs m_cDataService = null;                               // 거래데이터 합계금액 계산 및 관리
        private IDataCommonUs m_cDataCommon = null;                                 // POS 공통함수 인터페이스
        private IPaymentUs m_cPointMemberUse = null;                                // 제휴할인
        private IPaymentUs m_cMobilePoint = null;                                   // 통신사할인

        //#20180413 웰컴카드 신규기능 추가 start,phj
        private IPaymentExpUs m_cHappyPoint = null;
        private IWelcomeCard m_cWelcomeCard = null;
        private IPaymentUs m_cWelcomeDC = null;
        //#20180413 웰컴카드 신규기능 추가 end,phj

        private bool bNotDoubleClik = false;                                        // 더블 클릭 방지용

        private string m_sPosMenuKey;
        /// <summary>
        /// 통신사할인(SKT,KT,LGT) 및 제휴할인(OILBANK,BLUE MEMBER...)
        /// </summary>
        public string SetPosMenuKey { set { this.m_sPosMenuKey = value; } }

        /// <summary>
        /// 입력구분
        /// </summary>
        private string m_sInPutType = "";
        /// <summary>
        /// 입력데이터
        /// </summary>
        private string m_sInPutData = "";
        /// <summary>
        /// 마스킹데이터
        /// </summary>
        private string m_sInMaskData = "";
        /// <summary>
        /// 카드데이터(암호화)
        /// </summary>
        private string m_sInEncData = "";
        /// <summary>
        /// 대상 금액
        /// </summary>
        private double m_nDestAmt = 0;
        /// <summary>
        /// T페이 입력구분 (PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE)
        /// </summary>
        private string m_sInEntryMode = "";

        //#20170906 T페이 고도화 작업 phj, start
        private string m_sInCardData = "";
        //#20170906 T페이 고도화 작업 phj, end

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        private string m_sWelcomGiftCode = "";
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

        //#20180413 웰컴카드 신규기능 추가 start,phj   
        /// <summary>
        /// HPC - 회원번호
        /// </summary>
        private string m_sInHP_CustNumer = "";
        /// <summary>
        /// HPC - 웰컴카드번호
        /// </summary>
        private string m_sInHP_WelcomeCard = "";
        /// <summary>
        /// 웰컴카드 카드타입(C:실물카드, A:해피앱)
        /// </summary>
        private string m_sInWelcomeCard_Type = "";
        /// <summary>
        /// 등록건에서읽어온HP데이터등록시킬건지, 조회건에서읽어온HP데이터등록시킬건지
        /// </summary>
        private string m_sReadingHPData = "";
        //#20180413 웰컴카드 신규기능 추가 end,phj 

        #endregion 변수 선언

        #region 생성자 & 소멸자 & 폼초기화
        public frmPntMobileUnity()
        {
            InitializeComponent();

            base.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.ResizeRedraw, true);
            //this.UpdateStyles();

            m_cPosStatus = (PosStatus)StateObject.POS;      // POS 기본정보
            m_cTrnStatus = (TranStatus)StateObject.TRAN;    // POS 거래정보 
            m_cDevStatus = (DeviceStatus)StateObject.DEVICE;

            m_cDeviceICReader = (IICReaderUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_ICREADER);
            m_cDeviceSignPad = (ISignPadUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_SIGNPAD);
            m_cDataService = (IDataProcessUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_SERVICE);
            m_cDataCommon = (IDataCommonUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_COMMON);
            m_cPointMemberUse = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTMEMBERUSE);
            m_cMobilePoint = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTMOBILECOM);

            //#20180413 웰컴카드 신규기능 추가 start,phj
            m_cWelcomeCard = (IWelcomeCard)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.WELCOMECARD_ISSUE);
            m_cHappyPoint = (IPaymentExpUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTHAPPYPOINT);
            m_cWelcomeDC = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.WELCOMECARD_ISSUE);
            //#20180413 웰컴카드 신규기능 추가 end,phj

            delegatePos = new PosOLEDevice.DelegateOlePos(OnDeviceEvent);
            delegateReader = new PosOLEDevice.DelegateIcReader(OnIcReaderCallBack);     // IC리더 콜백
            //#20170918 IC 콜백 함수 변경 start
            //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
            //delegateReaderCardInfo = new PosOLEDevice.CallbackIc(OnIcReaderCallBackCardInfo);     // IC리더 콜백(CardInfo)
            //#20170918 IC 콜백 함수 변경 end
        }
        #region public frmPntMobileUnity(string _strDiv)
        public frmPntMobileUnity(string _strDiv)
        {
            //====================================================================
            // (2017.11.01) 해피포인트 제휴할인 선리딩 처리를 위한 생성자 오버로딩
            //====================================================================
            #region 해피포인트 제휴할인 선리딩 처리를 위한 생성자 오버로딩
            if (_strDiv == "Initial")
            {
                #region frmPntMobileUnity과 동일한 내용
                InitializeComponent();

                base.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.ResizeRedraw, true);
                //this.UpdateStyles();

                m_cPosStatus = (PosStatus)StateObject.POS;      // POS 기본정보
                m_cTrnStatus = (TranStatus)StateObject.TRAN;    // POS 거래정보 
                m_cDevStatus = (DeviceStatus)StateObject.DEVICE;

                m_cDeviceICReader = (IICReaderUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_ICREADER);
                m_cDeviceSignPad = (ISignPadUs)sManager.InitServiceInstance(ServiceLists.AGENT_OLEDEVICE.DLL, ServiceLists.AGENT_OLEDEVICE.DEVICE_SIGNPAD);
                m_cDataService = (IDataProcessUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_SERVICE);
                m_cDataCommon = (IDataCommonUs)sManager.InitServiceInstance(ServiceLists.ASV_DATA_PROCESS.DLL, ServiceLists.ASV_DATA_PROCESS.DATA_COMMON);
                m_cPointMemberUse = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTMEMBERUSE);
                m_cMobilePoint = (IPaymentUs)sManager.InitServiceInstance(ServiceLists.BSV_PAYMENT.DLL, ServiceLists.BSV_PAYMENT.POINTMOBILECOM);

                delegatePos = new PosOLEDevice.DelegateOlePos(OnDeviceEvent);
                delegateReader = new PosOLEDevice.DelegateIcReader(OnIcReaderCallBack);     // IC리더 콜백
                //#20170918 IC 콜백 함수 변경 start
                //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                //delegateReaderCardInfo = new PosOLEDevice.CallbackIc(OnIcReaderCallBackCardInfo);     // IC리더 콜백(CardInfo)
                //#20170918 IC 콜백 함수 변경 end
                #endregion

                // 컨트롤 초기화 함수 호출 -----
                InitControl();
            }
            #endregion
        }
        #endregion

        private void frmPntMobileUnity_Load(object sender, EventArgs e)
        {
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "");

            InitControl();

            if (m_sPosMenuKey == PosKey.MENU_KEY.OKCASHBACK && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "0" && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "" && m_cDevStatus.ICReader.UseYn != true)       // OCB 직통신
            {
                tmrIcCard.Enabled = false;   // IC리더 콜백 설정
            }
            else
            {
                tmrIcCard.Tag = "";
                tmrIcCard.Enabled = true;   // IC리더 콜백 설정
            }

            //*************************************************************************
            // (2017.11.01) 해피포인트 제휴할인 선리딩 처리
            //-------------------------------------------------------------------------
            // - 만약 제휴할인 카드 번호가 전역변수에 저장되어 있을 경우
            //   <- 전역변수 : m_cPosStatus.Sale.strMobileUnityCardNo
            //   오버로딩된 제휴할인 조회 함수를 호출한다.
            // - 오버로딩된 제휴할인 조회 함수에서는 제휴할인 카드번호를 표시/조회한다.
            //-------------------------------------------------------------------------
            // - 오버로딩 이벤트 : txtEditBox_EditBoxKeyDownEvent(object sender, string _strMobileUnityCardNo, string _strDiv)
            //*************************************************************************
            #region 해피포인트 제휴할인 선리딩 처리
            if (m_cPosStatus.Sale.strMobileUnityCardNo != "")
            {
                //==============================================================
                // 오버로딩된 제휴할인 이벤트 함수 호출
                //--------------------------------------------------------------
                // - 파라미터 : sender, 제휴할인카드번호, 조회까지 실행할지 여부
                //==============================================================
                #region 오버로딩된 제휴할인 조회 함수 호출
                //txtEditBox_EditBoxKeyDownEvent(null, m_cPosStatus.Sale.strMobileUnityCardNo, "");        // 카드번호만 표시
                txtEditBox_EditBoxKeyDownEvent(null, m_cPosStatus.Sale.strMobileUnityCardNo, btnEnter);    // 승인까지 수행
                #endregion
            }
            #endregion
        }

        private void frmPntMobileUnity_Activated(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(delegatePos);
        }

        private void frmPntMobileUnity_Deactivate(object sender, EventArgs e)
        {
            PosOLEDevice.SetEventHandle(null);
        }

        private void frmPntMobileUnity_FormClosing(object sender, FormClosingEventArgs e)
        {
            tmrIcCard.Tag = "CLOSE";
            // 마우스(이중클릭방지)
            Point nPoint = System.Windows.Forms.Cursor.Position;
            Cursor.Clip = new System.Drawing.Rectangle(1024, 0, 1, 1);

            UnRegIcCallback();          // IC리더 콜백 해지
            InDataToZeroFill();
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", lblTitle.Text);

            // 마우스(이중클릭방지)
            Cursor.Clip = Screen.PrimaryScreen.Bounds;
            Cursor.Position = nPoint;
        }

        /// <summary>
        /// 폼 컨트롤 초기화
        /// </summary>
        private void InitControl()
        {
            try
            {
                this.Location = new Point(0, 50);
                this.Size = new Size(1024, 525);

                // 이미지 로딩 처리
                FormManager.SetFormAllControlFont(this, m_cPosStatus.Base.FONT);
                FormManager.SetTextBoxGlobalInfo(this, m_cPosStatus.Global.m_stCultureMaster.nGroupingDigits, m_cPosStatus.Global.m_stCultureMaster.strGroupingSymbol
                    , m_cPosStatus.Global.m_stCultureMaster.nDecimalDigits, m_cPosStatus.Global.m_stCultureMaster.strDecimalSymbol);

                btnExit.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.BTN_CLOSE);
                if (btnExit.Image != null) btnExit.Text = "";

                btnEnter.BackColor = CmUtil.GetColorToString(m_cPosStatus.ScnMst.ThemeColor);

                lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029);
              
                lblCardNo.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0051);
                lblPayAmt.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0098);
                lblTotSavePoint.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0071);
                lblUsablePoint.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0070);
                lblUsePoint.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0127);

                btnSearch.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0004);
                btnEnter.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0057);
                btnIcCard.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0132);
                btnPinPad.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0097);
                btnMenual.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0364);
                btnCatApp.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0854);

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                btnWelcomGift.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1097);
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#14618 KT 더블할인 개발요청 start,phj
                btnDoubleDC.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1118);
                //#14618 KT 더블할인 개발요청 end,phj

                //#20180413 웰컴카드 신규기능 추가 start,phj
                btnWccIssue.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131);
                //#20180413 웰컴카드 신규기능 추가 end,phj
  
                m_nDestAmt = m_cDataService.GetPluTagetAmount(PosKey.MENU_KEY.SKT);
                if (m_nDestAmt < 0) m_nDestAmt = 0;

                //#20171206 17크리스마스캠페인 start
                //적용시 주석
                //if (m_nDestAmt > m_cTrnStatus.Sale.RemainPayAmt) m_nDestAmt = m_cTrnStatus.Sale.RemainPayAmt;
                //#20171206 17크리스마스캠페인 end

                txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);         // 대상금액                   
                txtUsePoint.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);       // 요청금액                  

                //#15606 제휴서비스 결제 프로세스 개선 start
                //PosConst.MOT_MSG_TYPE.PAY_STEP_2 사용하진 않지만 PAY_STEP_2로 넘기도록 수정
                //기존
                //InitPayMainBack(m_cPosStatus, m_cDataCommon, m_sPosMenuKey, PosConst.MOT_MSG_TYPE.PAY_STEP_3, "");
                //변경
                InitPayMainBack(m_cPosStatus, m_cDataCommon, m_sPosMenuKey, PosConst.MOT_MSG_TYPE.PAY_STEP_2, "");
                //#15606 제휴서비스 결제 프로세스 개선 end

                ClearCardInfo();                // 카드 입력 정보 클리어
                bNotDoubleClik = false;

                // 기능 버튼 설정 체크
                FormManager.SetbtnMenu(txtCardNo, m_cDevStatus.ICReader.UseYn, btnIcCard, btnPinPad, null, null);


                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                btnWelcomGift.Visible = false;
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#14618 KT 더블할인 개발요청 start,phj
                btnDoubleDC.Visible = false;
                //#14618 KT 더블할인 개발요청 end,phj

                btnMenual.Visible = false;
                btnCatApp.Visible = false;
                btnSearch.Visible = true;

                //#20180413 웰컴카드 신규기능 추가 start,phj
                btnWccIssue.Visible = false;
                //#20180413 웰컴카드 신규기능 추가 end,phj

                //#20180413 웰컴카드 신규기능 추가 start,phj
                m_sReadingHPData = "";
                //#20180413 웰컴카드 신규기능 추가 end,phj
                

                // 무결성 실패후 진행시 오류 메시지 표시
                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 Start
                    /*if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true && m_cDevStatus.ICReader.Integrity_SignPad_Status != true && m_cDevStatus.SignPad.UseYn == true) 
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0388);
                    else
                    {
                        if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                    }*/

                    if (m_cDevStatus.ICReader.Integrity_IC_Status != true && m_cDevStatus.ICReader.UseYn == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0384);
                    //#20171208, RF버튼 선택 시에만 서명패드 무결성 체크하도록 수정 End
                }

                InitFuncMobileKind();       // 제휴카드 종류 화면 표시

                txtCardNo.Text = "";
                txtCardNo.ReadOnly = false;
                txtCardNo.Select();
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 제휴카드 종류 화면 표시
        /// </summary>
        private void InitFuncMobileKind()
        {
            try
            {
                fncMobileKind.VisibleUpDown = false;
                fncMobileKind.ClearFuncButtonInfo();                    // 설정된 메뉴정보 초기화
                fncMobileKind.SelectedBackColor = CmUtil.GetColorToString(m_cPosStatus.ScnMst.ThemeColor);
                fncMobileKind.SelectedForeColor = Color.WhiteSmoke;
                fncMobileKind.BackColor = Color.FromArgb(159, 159, 159);
                fncMobileKind.BorderColor = Color.FromArgb(159, 159, 159);
                fncMobileKind.BorderLineSize = 1;

                int iPntCnt = 0;
                
                //#20180413 웰컴카드 신규기능 추가 start,phj
                // 기존
                //for (int i = 0 ; i < 6 ; i++)
                //변경
                for (int i = 0; i < 7; i++)
                //#20180413 웰컴카드 신규기능 추가 end,phj

                {
                    string sPayWayCd = "", sPayDtlCd = "", sPayDtlName = "", sPosMenuKey = "";
                    
                    sPayWayCd =ItemConst.TR_ITEM_ID.MOBILE_COM_POINT;
                    if (i == 0)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.MOBILE_SKT;
                        sPosMenuKey = PosKey.MENU_KEY.SKT;
                    }
                    else if (i == 1)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.MOBILE_KTF;
                        sPosMenuKey = PosKey.MENU_KEY.KT;
                    }
                    else if (i == 2)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.MOBILE_LGT;
                        sPosMenuKey = PosKey.MENU_KEY.LGT;
                    }
                    else if (i == 3)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.OILBANK_POINT;
                        sPosMenuKey = PosKey.MENU_KEY.OLIBANK;
                    }
                    else if (i == 4)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.HBLUE_M_POINT;
                        sPosMenuKey = PosKey.MENU_KEY.BLUE_MEMBERS;
                    }
                    else if (i == 5)
                    {
                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.KRED_M_POINT;
                        sPosMenuKey = PosKey.MENU_KEY.RED_MEMBERS;
                    }
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    else if (i == 6)
                    {
                        if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1") continue;

                        sPayDtlCd = ItemConst.TR_ITEM_ID.MOBILE_COM.WELCOMECARD;
                        sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;
                    }
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    sPayDtlName = PosMstManager.GetMstPayDc(sPayWayCd, sPayDtlCd, PosMst.MST_PAY_DC.DATA.PAY_DC_NM);         // 결제수단명
                    if (sPayDtlName == "") continue;

                    Cosmos.UI.CsmFunc.FuncBtnInfo cFuncInfo = new Cosmos.UI.CsmFunc.FuncBtnInfo();

                    cFuncInfo.sGroupCode = "00";            // 분류코드
                    cFuncInfo.nSeqNo = ++iPntCnt;           // 표시순번
                    cFuncInfo.sFuncCode = sPosMenuKey;      // 기능코드
                    cFuncInfo.sFuncText = sPayDtlName;      // 기능 명

                    cFuncInfo.cBackColor = Color.White;     // 백 컬러
                    cFuncInfo.cForeColor = Color.Black;     // 명 컬러
                    cFuncInfo.fFontSize = 11;               // 명 폰트 사이즈
                    cFuncInfo.nButtonSize = 0;              // 버튼 사이즈(0:일반,1:가로확대,2:세로확대,3:가로세로확대)

                    fncMobileKind.AddFuncButtonInfo(cFuncInfo);    
                }

                fncMobileKind.SetFuncButtonCount(1, iPntCnt);           // 버튼갯수 설정
                fncMobileKind.DisplayFuncButton("00");                  // 기능 버튼 표시

                m_sPosMenuKey = "";
                fncMobileKind.SelectFuncButton("");
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 카드 입력 정보 클리어
        /// </summary>
        private void ClearCardInfo()
        {
            try
            {
                m_sInPutType = "";      // 입력구분
                m_sInPutData = "";      // 입력데이터
                m_sInMaskData = "";     // 마스킹
                m_sInEncData = "";      // 카드데이터

                //#20170906 T페이 고도화 작업 phj, start
                m_sInCardData = "";
                //#20170906 T페이 고도화 작업 phj, end

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                m_sWelcomGiftCode = "";
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                //#20180413 웰컴카드 신규기능 추가 start,phj 
                m_sInHP_CustNumer = ""; // HPC - 회원번호
                m_sInHP_WelcomeCard = ""; // HPC - 웰컴카드번호
                m_sInWelcomeCard_Type = ""; // 웰컴카드 타입 C:실물카드, A:해피App 
                m_sReadingHPData = "";
                //#20180413 웰컴카드 신규기능 추가 end,phj

                txtTotSavePoint.Text = "";
                txtUsablePoint.Text = "";
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion

        #region 버튼 입력 처리
        private void fncMobileKind_FuncClickHandler(object sender, string sFuncCode)
        {
            try
            {
                if (sFuncCode == "") return;

                m_sPosMenuKey = sFuncCode;
                fncMobileKind.SelectFuncButton("");
                fncMobileKind.SelectDispButton(sFuncCode, 0);

                //#15606 제휴서비스 결제 프로세스 개선 start
                SetMotMobileUnity(m_sPosMenuKey, PosConst.MOT_MSG_TYPE.PAY_STEP_2);
                //#15606 제휴서비스 결제 프로세스 개선 end

                DisplayMobileUnityKind();
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 버튼 입력 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnProc_Click(object sender, EventArgs e)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                if (((Cosmos.UI.CsmButton)sender) == btnIcCard)               // 카드입력
                {
                    if (GetIcCardData(e != null ? true : false) == true)
                    {
                        bNotDoubleClik = false;
                        txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                    }
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnPinPad)        // 핀패드
                {
                    UnRegIcCallback(); // IC리더 콜백 해지
                    if (GetPinPadData() == true)
                    {
                        bNotDoubleClik = false;
                        txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                    }
                    if (txtCardNo.Value == "") tmrIcCard.Enabled = true;
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnSearch)        // 조회
                {
                    SearchTxtInPut();
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnEnter)         // 승인
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    //CompleteTxtInPut(0);
                    //변경
                    CompleteTxtInPut(0, btnEnter);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                else if (((Cosmos.UI.CsmButton)sender) == btnWelcomGift)
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    //CompleteTxtInPut(3);
                    //변경
                    CompleteTxtInPut(3, btnWelcomGift);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END
                
                //#14618 KT 더블할인 개발요청 start,phj
                else if (((Cosmos.UI.CsmButton)sender) == btnDoubleDC)
                {
                    

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    //CompleteTxtInPut(3);
                    //변경
                    CompleteTxtInPut(3, btnDoubleDC);
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
                //#14618 KT 더블할인 개발요청 end,phj

                else if (((Cosmos.UI.CsmButton)sender) == btnCatApp)         // Cat 단말기 승인
                {
                    if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                        //#20180413 웰컴카드 신규기능 추가 start,phj
                        m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC || 
                        //#20180413 웰컴카드 신규기능 추가 end,phj
                        m_sPosMenuKey == PosKey.MENU_KEY.LGT) 
                    {
                        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                        //기존
                        //CompleteTxtInPut(1);
                        //변경
                        CompleteTxtInPut(1, btnCatApp);
                        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                    }
                    else
                    {
                        bNotDoubleClik = false;
                        return;
                    }
                }

                //#20180413 웰컴카드 신규기능 추가 start,phj
                else if (((Cosmos.UI.CsmButton)sender) == btnWccIssue)        // 웰컴카드 발급
                {
                    WelcomeCard_Issue();
                }
                //#20180413 웰컴카드 신규기능 추가 end,phj

                else if (((Cosmos.UI.CsmButton)sender) == btnMenual)        // 수기결제
                {
                    MenualTxtInPut();
                }
                else if (((Cosmos.UI.CsmButton)sender) == btnExit)
                {
                    bNotDoubleClik = false;

                    this.DialogResult = DialogResult.Cancel;
                    this.Close();
                    return;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            bNotDoubleClik = false;
        }
        #endregion

        #region 텍스트박스 키 입력 이벤트 처리
        /// <summary>
        /// 텍스트박스 키 입력 이벤트 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="sFuncValue"></param>
        private void txtEditBox_EditBoxKeyDownEvent(object sender, string sFuncValue)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                try
                {
                    if (sFuncValue == PosKey.MENU_KEY.ENTER)
                    {
                        if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                        {
                            if (txtCardNo.Text == "")
                            {
                                // 카드정보 읽기
                                if (GetIcCardData(true) == false)
                                {
                                    bNotDoubleClik = false;
                                    return;
                                }
                            }

                            //#20171108 마스킹 미처리 start
                            //어떤 수단으로 입력한건지 구분이 되지 않기 때문에 입력된 번호 길이가 22자리 이상이면 마스킹 처리
                            if (txtCardNo.Value.Length >= 22)
                            {
                                txtCardNo.InputType = Cosmos.UI.InputType.CardNo; 
                                txtCardNo.Value = txtCardNo.Value;
                                txtCardNo.InputType = Cosmos.UI.InputType.None;
                            }
                            //#20171108 마스킹 미처리 end

                            if (SelectMobileUnityKind() == false)
                            {
                                bNotDoubleClik = false;
                                return;
                            }

                            //#15583 캠페인 기능 개선 요청 start
                            //승인 시도시 체크 하도록 위치 변경
                            /*
                            if (checkCampain().Equals(false))
                            {
                                bNotDoubleClik = false;
                                return;
                            }
                            */
                            //#15583 캠페인 기능 개선 요청 end

                            if (CheckTxtInPut(sender) == false)
                            {
                                bNotDoubleClik = false;
                                return;
                            }

                            if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                                m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                                //#20180413 웰컴카드 신규기능 추가 start,phj
                                m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC || 
                                //#20180413 웰컴카드 신규기능 추가 end,phj
                                m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                            {
                                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                                
                                //#14618 KT 더블할인 개발요청 start,phj
                                //기존
                                //if (btnWelcomGift.Visible == true)
                                //변경
                                if (btnWelcomGift.Visible == true || btnDoubleDC.Visible == true) 
                                //#14618 KT 더블할인 개발요청 end,phj
                                {

                                    //웰컴기프트 버튼 활성화 시 자동승인 기능 막기
                                    bNotDoubleClik = false;
                                    txtCardNo.SelectText();
                                    return;
                                }
                                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                                //기존
                                //if (CompleteTxtInPut(0) == false)      
                                //변경
                                if (CompleteTxtInPut(0, sender) == false)   
                                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                                {
                                    txtCardNo.SelectText();
                                }
                            }
                            else
                            {
                                if (SearchTxtInPut() == false)          // 조회
                                {
                                    bNotDoubleClik = false;
                                    return;
                                }
                                txtUsePoint.Focus();
                            }
                        }

                        if (((Cosmos.UI.CsmPosEditBox)sender) == txtUsePoint)
                        {
                            if (CheckTxtInPut(sender) == false)
                            {
                                bNotDoubleClik = false;
                                return;
                            }

                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                            //기존
                            //CompleteTxtInPut(0);         // 승인 처리
                            //변경
                            CompleteTxtInPut(0, txtUsePoint);
                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                        }
                    }
                    else if (sFuncValue == PosKey.MENU_KEY.CLEAR)
                    {
                        if (((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                        {
                            ClearCardInfo();        // 카드 입력 정보 클리어

                            m_sPosMenuKey = "";     // 카드종류 선택정보 초기화
                            lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029);
                            fncMobileKind.SelectFuncButton("");
                            tmrIcCard.Enabled = true;
                        }

                        if (((Cosmos.UI.CsmPosEditBox)sender).ReadOnly == false) ((Cosmos.UI.CsmPosEditBox)sender).Text = "";
                    }
                }
                catch (Exception ex)
                {
                    WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            bNotDoubleClik = false;
        }

        #region public void txtEditBox_EditBoxKeyDownEvent(object sender, string _strMobileUnityCardNo, string _strDiv)
        public void txtEditBox_EditBoxKeyDownEvent(object sender, string _strMobileUnityCardNo, object _strDiv)
        {
            //====================================================================
            // (2017.11.01) 해피포인트 제휴할인 선리딩 처리를 위한 이벤트 오버로딩
            //====================================================================
            #region 해피포인트 제휴할인 선리딩 처리를 위한 이벤트 오버로딩

            #region 만약 구분(_strDiv) 값이 ''(공백)일 경우 제휴할인 카드 번호만 표시한다.
            if (_strDiv == null)
            {
                // 제휴할인 카드 번호 설정 -----
                txtCardNo.Value = _strMobileUnityCardNo;

                // 텍스트박스 입력 유효성 체크 및 제휴카드 종류 자동 선택 -----
                CheckTxtInPut(null);
                SelectMobileUnityKind();
            }
            #endregion

            #region 만약 구분(_strDiv) 값이 '조회'일 경우 제휴할인 카드 번호 표시후 조회까지 처리한다.
            else if (((Cosmos.UI.CsmButton)_strDiv) == btnSearch)
            {
                // 제휴할인 카드 번호 설정 -----
                txtCardNo.Value = _strMobileUnityCardNo;

                // 제휴할인 카드 조회 이벤트 호출 -----
                txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
            }
            #endregion

            #region 만약 구분(_strDiv) 값이 '승인'일 경우 제휴할인 카드 번호 표시후 승인까지 처리한다.
            else if (((Cosmos.UI.CsmButton)_strDiv) == btnEnter)
            {
                // 제휴할인 카드 번호 설정 -----
                txtCardNo.Value = _strMobileUnityCardNo;

                // 제휴할인 카드 조회 이벤트 호출 -----
                txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);

                // 제휴할인 카드 승인 이벤트 호출 -----
                //txtCardNo.Value = _strMobileUnityCardNo;
                //btnProc_Click(btnEnter, null);
            }
            #endregion

            #endregion
        }

        #endregion

        /// <summary>
        /// 텍스트박스 활성화 처리
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtEditBox_EnterEvent(object sender, EventArgs e)
        {
            try
            {
                padInPut.SetActiveControl = (Control)sender;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion

        #region 텍스트박스 입력 유효성 체크
        /// <summary>
        /// 텍스트박스 입력 유효성 체크
        /// </summary>
        /// <param name="sender"></param>
        /// <returns></returns>
        private bool CheckTxtInPut(object sender)
        {
            return CheckTxtInPut(sender, true);
        }
        private bool CheckTxtInPut(object sender, bool bNotManual)
        {
            try
            {
                // 특정 문자값 제거
                try
                {
                    if (m_cDevStatus.Msr.STX != "" && txtCardNo.Value.StartsWith(m_cDevStatus.Msr.STX)) txtCardNo.Value = txtCardNo.Value.Substring(1);

                    int iLastEtx = txtCardNo.Value.LastIndexOf(m_cDevStatus.Msr.ETX);
                    if (m_cDevStatus.Msr.ETX != "" && iLastEtx > 0) txtCardNo.Value = CmUtil.MidH(txtCardNo.Value, 0, iLastEtx);
                }
                catch { }

                // 카드번호 길이 체크
                if (sender == null || ((Cosmos.UI.CsmPosEditBox)sender) == txtCardNo)
                {
                    if (txtCardNo.Value.Length < 10)
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0037);
                        txtCardNo.SelectText();
                        txtCardNo.Focus();
                        return false;
                    }

                    if (m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                    {
                        if (txtCardNo.Value.StartsWith("4282") == true)     // 해피기프트 카드 안내
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0649);
                            txtCardNo.Focus();
                            return false;
                        }
                    }

                    // 입력된 카드번호 변경 체크
                    if (txtCardNo.Value != m_sInPutData)
                    {
                        ClearCardInfo();        // 카드 입력 정보 클리어   
                    }
 
                    if (m_sInEncData == "")
                    {
                        if (m_sInPutData == "")
                        {
                            m_sInPutData = txtCardNo.Value;
                            if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                            {
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                                m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.KEYIN;
                            }
                            else
                            {
                                m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                                m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.KEYIN;
                            }
                            if (m_sInPutData.Contains("=") == true) m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }

                        m_sInMaskData = m_sInPutData;

                        //#20170906 T페이 고도화 작업 phj, start
                        if (m_sPosMenuKey == PosKey.MENU_KEY.SKT)
                        {
                            if ((m_sInPutData.Substring(0, 3) == "294") || (m_sInPutData.Substring(0, 3) == "292") || (m_sInPutData.Substring(0, 3) == "297"))
                            {
                                m_sInCardData = m_sInPutData;
                            } 
                        }
                        //#20170906 T페이 고도화 작업 phj, end

                        if (bNotManual == true)
                        {
                            if (EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData) == false) return false;
                        }



                        //#20180413 웰컴카드 신규기능 추가 start,phj
                        //if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC && (m_sInWelcomeCard_Type == "" || m_sInHP_WelcomeCard == ""))
                        if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                        {
                            // 카드타입읽어오기.
                            m_sInWelcomeCard_Type = m_cWelcomeCard.WelcomeCard_PrefixCheck(txtCardNo.Value);
                            //SelectMobileUnityKind();

                            // 기능키셋팅.
                            if (m_sInWelcomeCard_Type == "C" || m_sInWelcomeCard_Type == "A")
                            {
                                m_sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;
                            }
                            else
                            {
                                m_sPosMenuKey = "";
                            }

                            if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC && m_sInWelcomeCard_Type == "C")
                            {
                                m_sInHP_WelcomeCard = m_sInPutData;
                                //m_sInHP_WelcomeCard = "";
                            }
                            else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC && (m_sInWelcomeCard_Type == "A" || m_sInWelcomeCard_Type == ""))
                            {
                                // 유효한 해피포인트인지 체크. 
                                if (HP_Availability_Check() == false)
                                {
                                    txtCardNo.SelectText();
                                    txtCardNo.Focus();
                                    ClearCardInfo();
                                    txtCardNo.Text = "";
                                    txtCardNo.Value = "";
                                    return false;
                                }

                                //카드번호 변경해서 재리딩.
                                txtCardNo.Text = m_sInHP_WelcomeCard;
                                txtCardNo.Value = m_sInHP_WelcomeCard;
                                
                                m_sInWelcomeCard_Type = "A";

                                //SelectMobileUnityKind();

                                m_sInPutData = txtCardNo.Value;
                                m_sInMaskData = m_sInPutData;
                                if (EncryptedCardNo(m_sInPutData, ref m_sInMaskData, ref m_sInEncData) == false) return false;
                            }

                            //#20180413 웰컴카드 신규기능 추가 start, 20180621
                            ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);
                            foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                            {
                                if (cEtcItem.CANCEL_DIV == ItemConst.PAY_CANCEL_DIV.CANCEL) continue;
                                if (cEtcItem.ETC_WAY_CD != ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 != ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) continue;


                                //HP웰컴카드
                                if (cEtcItem.OCCUR_ENTRY_19.Trim() == txtCardNo.Value.Trim())
                                {
                                    m_sInWelcomeCard_Type = "A";
                                    break;
                                }
                                //#20180607 해피 조회 응답에 웰컴카드 번호만 내려오면 무조건 제휴할인 적용 end

                            }
                            //#20180413 웰컴카드 신규기능 추가 end, 20180621

                        }
                        //#20180413 웰컴카드 신규기능 추가 end,phj 
                    }
                }

                // 사용포인트 체크
                if (sender == null || ((Cosmos.UI.CsmPosEditBox)sender) == txtUsePoint)
                {
                    if (m_nDestAmt < m_cDataService.DoubleParse(txtUsePoint.Value))
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0071);
                        txtUsePoint.Focus();
                        return false;
                    }

                    if (CmUtil.AmountCut(m_cDataService.DoubleParse(txtUsePoint.Value), CmUtil.IntParse(m_cPosStatus.Mst.PayRudDwLoc)) != m_cDataService.DoubleParse(txtUsePoint.Value))
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0036);    // 입력한 금액은 입력 불가 단위 입니다.
                        txtUsePoint.Focus();
                        return false;
                    }

                    if (txtUsePoint.Value.Length == 0 || m_cDataService.DoubleParse(txtUsePoint.Value) == 0)
                    {
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0071);
                        txtUsePoint.Focus();
                        return false;
                    }

                    if (m_sPosMenuKey == PosKey.MENU_KEY.OLIBANK || m_sPosMenuKey == PosKey.MENU_KEY.BLUE_MEMBERS || m_sPosMenuKey == PosKey.MENU_KEY.RED_MEMBERS)
                    {
                        double nApprAmt = m_cDataService.DoubleParse(txtUsePoint.Value);
                        if (m_sPosMenuKey == PosKey.MENU_KEY.BLUE_MEMBERS || m_sPosMenuKey == PosKey.MENU_KEY.RED_MEMBERS)  
                        {
                            nApprAmt = m_cDataCommon.ExecTermCoopCmpPayDc(m_cDataCommon.GetMenuKeyToPayWayCd(m_sPosMenuKey), m_cDataCommon.GetMenuKeyToPayDtlCd(m_sPosMenuKey), "", m_cDataService.DoubleParse(txtUsePoint.Value));
                            // 블루 레드 멤버스 승인 금액 100원 단위 절삭 처리
                            nApprAmt = CmUtil.MathRounds(nApprAmt, PosConst.MATH_ROUND.TRANCATE, -2);
                        }

                        //*** MoonSeokWoo 2017.09.12 박수환 과장 요청으로 확인 안 함.
                        //if (m_cDataService.DoubleParse(txtUsablePoint.Text) != 0 && m_cDataService.DoubleParse(txtUsablePoint.Text) < nApprAmt)
                        //{
                        //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0072);
                        //    txtUsePoint.Focus();
                        //    return false;
                        //}

                        if (m_cTrnStatus.Sale.RemainPayAmt < nApprAmt)
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0073);
                            txtUsePoint.Focus();
                            return false;
                        }
                    }

                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                    //기존
                    /*
                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                    btnWelcomGiftYN(m_sPosMenuKey);
                    //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END
                    //#14618 KT 더블할인 개발요청 start,phj
                    btnKTDoubleDcYN(m_sPosMenuKey);
                    //#14618 KT 더블할인 개발요청 end,phj
                    */
                    //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                return false;
            }
            return true;
        }
        
        /// <summary>
        /// 입력박스 체크(Cat단말기)
        /// </summary>
        /// <param name="sender"></param>
        /// <returns></returns>
        private bool CheckTxtInPutForCat()
        {
            try
            {
                // 사용포인트 체크
                if (CmUtil.AmountCut(m_cDataService.DoubleParse(txtUsePoint.Value), CmUtil.IntParse(m_cPosStatus.Mst.PayRudDwLoc)) != m_cDataService.DoubleParse(txtUsePoint.Value))
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0036);    // 입력한 금액은 입력 불가 단위 입니다.
                    txtUsePoint.Focus();
                    return false;
                }

                if (txtUsePoint.Value.Length > 10 || m_cDataService.DoubleParse(txtUsePoint.Value) <= 0)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0071);
                    txtUsePoint.Focus();
                    return false;
                }
                if (m_nDestAmt < m_cDataService.DoubleParse(txtUsePoint.Value))
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0071);
                    txtUsePoint.Focus();
                    return false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                return false;
            }
            return true;
        }

        /// <summary>
        /// 제휴카드 종류 자동 선택
        /// </summary>
        /// <returns></returns>
        private bool SelectMobileUnityKind()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_sPosMenuKey != "")
                {
                    return true;
                }
                else
                {

                }

                if (txtCardNo.Value.Length < 6) return false;

                string sCardNo = txtCardNo.Value;
                string sCardKind = "";

                // 제휴카드 프리픽스 체크
                string sQuery = "  SELECT * ";
                sQuery += "   FROM POSMST.dbo.MST_CARD_PREFIX WITH(NOLOCK) ";
                sQuery += "  WHERE CMP_CD = '" + m_cPosStatus.Base.CmpCd + "'";
                sQuery += "    AND '" + sCardNo.Substring(0, 6) + "' LIKE REPLACE(PRFX_CD, 'X', '') + '%'";
                //#20170929 start
                //프리픽스 체크 시 USE_YN 체크.
                sQuery += "    AND USE_YN = '" + PosConst.MST_USE_YN.YES + "'"; 
                //#20170929 end

                IMasterUs cMstService = (IMasterUs)sManager.InitServiceInstance(ServiceLists.ASV_MASTER.DLL, ServiceLists.ASV_MASTER.POS_MASTER);
                DataTable dtCardInfo = cMstService.Select(new string[] { sQuery });
                
                //IMasterUs cMstPayDcService = (IMasterUs)sManager.InitServiceInstance(ServiceLists.ASV_MASTER.DLL, ServiceLists.ASV_MASTER.PAY_DC_MASTER);
                //DataTable dtCardInfo = cMstPayDcService.Select(new string[] { PosMst.MST_CARD_PREFIX.TABLE_NAME, sCardNo.Substring(0, 6) });

                if (dtCardInfo != null && dtCardInfo.Rows.Count > 0)
                {
                    foreach (DataRow dr in dtCardInfo.Rows)
                    {
                        //#20180413 웰컴카드 신규기능 추가 start,phj
                        //기존
                        //if (CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "C" || CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "H") continue;      //C:신용카드, H:HP
                        //변경
                        if (CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "C") continue;      //C:신용카드, H:HP
                        //#20180413 웰컴카드 신규기능 추가 end,phj
                        sCardKind = CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV);
                        break;
                    }
                }
                
                if (sCardKind == "S")       //S:SK
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.SKT;
                }
                else if (sCardKind == "K")  //K:KT
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.KT;
                }
                else if (sCardKind == "L")  //L:LG
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.LGT;
                }
                else if (sCardKind == "B")  //B:현대오일뱅크
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.OLIBANK;
                }
                else if (sCardKind == "Q")  //Q:기아레드
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.RED_MEMBERS;
                }
                else if (sCardKind == "U")  //U:현대블루
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.BLUE_MEMBERS;
                }
                else if (sCardKind == "T")  //T:T페이
                {
                    if (ChangeTPayPayment() == true) return false;

                    m_sPosMenuKey = PosKey.MENU_KEY.SKT;
                }
                //#20180413 웰컴카드 신규기능 추가 start,phj
                else if (sCardKind == "W")  //C: 웰컴카드할인
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;
                    //m_sInWelcomeCard_Type = "C";
                }
                else if (sCardKind == "H")  //H: 해피포인트
                {
                    m_sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;
                    //m_sInWelcomeCard_Type = "A"; //20180521
                }
                //#20180413 웰컴카드 신규기능 추가 end,phj
                else
                {
                    txtUsePoint.Focus();
                    return true;
                }

                fncMobileKind.SelectFuncButton("");
                fncMobileKind.SelectDispButton(m_sPosMenuKey, 0);

                if (DisplayMobileUnityKind().Equals(false))
                {
                    return false;
                }
               

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #region public bool SelectMobileUnityKind(string _strCardNo)
        public string SelectMobileUnityKind(string _strCardNo)
        {
            //==================================================================
            // (2017.11.01) 해피포인트 제휴할인 선리딩 처리를 위한 함수 오버로딩
            //==================================================================
            #region 해피포인트 제휴할인 선리딩 처리를 위한 함수 오버로딩

            // 카드번호 설정 -----
            txtCardNo.Value = _strCardNo;

            // 제휴카드 종류 자동 선택 호출 -----
            string _strCardDiv = "";        // 제휴할인카드 종류(SKT, KT, LGT)

            //-------------------------------------
            // SelectMobileUnityKind 함수 내용 활용
            //-------------------------------------
            #region SelectMobileUnityKind 함수 내용 활용
            string sRet = UserCom.RST_ERR;

            //if (m_sPosMenuKey != "") { return true; }
            if (txtCardNo.Value.Length < 6) return "";

            string sCardNo = txtCardNo.Value;
            string sCardKind = "";

            // 제휴카드 프리픽스 체크
            string sQuery = "  SELECT * ";
            sQuery += "   FROM POSMST.dbo.MST_CARD_PREFIX WITH(NOLOCK) ";
            sQuery += "  WHERE CMP_CD = '" + m_cPosStatus.Base.CmpCd + "'";
            sQuery += "    AND '" + sCardNo.Substring(0, 6) + "' LIKE REPLACE(PRFX_CD, 'X', '') + '%'";
            sQuery += "    AND USE_YN = '" + PosConst.MST_USE_YN.YES + "'";

            IMasterUs cMstService = (IMasterUs)sManager.InitServiceInstance(ServiceLists.ASV_MASTER.DLL, ServiceLists.ASV_MASTER.POS_MASTER);
            DataTable dtCardInfo = cMstService.Select(new string[] { sQuery });

            if (dtCardInfo != null && dtCardInfo.Rows.Count > 0)
            {
                foreach (DataRow dr in dtCardInfo.Rows)
                {
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    //기존
                    //if (CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "C" || CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "H") continue;      //C:신용카드, H:HP
                    //변경
                    if (CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV) == "C") continue;      //C:신용카드, H:HP
                    //#20180413 웰컴카드 신규기능 추가 end,phj

                    sCardKind = CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CARD_DIV);
                    break;
                }
            }

            if (sCardKind == "S")       //S:SK
            {
                m_sPosMenuKey = PosKey.MENU_KEY.SKT;
                _strCardDiv = "SKT";
            }
            else if (sCardKind == "K")  //K:KT
            {
                m_sPosMenuKey = PosKey.MENU_KEY.KT;
                _strCardDiv = "KT";
            }
            else if (sCardKind == "L")  //L:LG
            {
                m_sPosMenuKey = PosKey.MENU_KEY.LGT;
                _strCardDiv = "LGT";
            }
            //#20180413 웰컴카드 신규기능 추가 start,phj
            else if (sCardKind == "W")  //W: 웰컴카드할인
            {
                m_sPosMenuKey = PosKey.MENU_KEY.WELCOMECARD_DC;
                _strCardDiv = "MC";
            }
            //#20180413 웰컴카드 신규기능 추가 end,phj
            else { return ""; }

            fncMobileKind.SelectFuncButton("");
            fncMobileKind.SelectDispButton(m_sPosMenuKey, 0);
            //if (DisplayMobileUnityKind().Equals(false)) { return ""; }

            #endregion

            #endregion

            // 리턴값 설정 -----
            return _strCardDiv;
        }
        #endregion

        /// <summary>
        /// 제휴카드 종류 표시
        /// </summary>
        /// <returns></returns>
        private bool DisplayMobileUnityKind()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_sPosMenuKey == PosKey.MENU_KEY.OLIBANK)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0110);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.BLUE_MEMBERS)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0113);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.RED_MEMBERS)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0114);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.SKT)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0072);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.KT)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0073);
                else if (m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0074);
                //#20180413 웰컴카드 신규기능 추가 start,phj
                else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                    lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1029) + " - " + MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138);
                //#20180413 웰컴카드 신규기능 추가 end,phj

                // 수기결제 여부 설정
                if (m_sPosMenuKey == PosKey.MENU_KEY.OLIBANK)
                {
                    btnMenual.Visible = true;
                }
                else
                {
                    btnMenual.Visible = false;
                }

                // CAT단말기 사용 여부
                if (m_cDevStatus.CatTerminal.UseYn == true
                    && ( m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                         m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                         //#20180413 웰컴카드 신규기능 추가 start,phj
                         m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC ||
                         //#20180413 웰컴카드 신규기능 추가 end,phj

                         m_sPosMenuKey == PosKey.MENU_KEY.LGT))
                {
                    btnCatApp.Visible = true;
                }
                else
                {
                    btnCatApp.Visible = false;
                }

                m_nDestAmt = m_cDataService.GetPluTagetAmount(m_sPosMenuKey);
                if (m_nDestAmt < 0
                    && (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                        //#20180413 웰컴카드 신규기능 추가 start,phj
                        m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC ||
                        //#20180413 웰컴카드 신규기능 추가 end,phj
                        m_sPosMenuKey == PosKey.MENU_KEY.LGT))
                {
                    // 캠페인 중복 불가(캠페인과 통신사 할인 중 선택)
                    ArrayList aSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                    double nCampAmt = 0;
                    foreach (Column.TR_PLU.DATA cPluItem in aSaleItem)
                    {
                        if (cPluItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cPluItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue;      // 지정취소
                        if (cPluItem.BILLSPR_NO != m_cTrnStatus.Sale.BillSplitNo) continue;                                                             // 빌분리번호

                        nCampAmt = CmUtil.DoubleAdd(nCampAmt, cPluItem.CPI_DC_AMT);
                    }
                    string sMessage = string.Format(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0370), m_cPosStatus.Global.NumericTOCurrency(nCampAmt));
                    if (WinManager.QuestionMessage(sMessage) == false) return false;

                    // 캠페인 취소 처리
                    ICampaignUs cCampaingMain = (ICampaignUs)sManager.InitServiceInstance(ServiceLists.ASV_CAMPAIGN.DLL, ServiceLists.ASV_CAMPAIGN.CAMPAIGN_MAIN);
                    cCampaingMain.ClearCampaignAmt();

                    // 상품 합계금액 계산(거래해더)
                    m_cDataService.UpdatePluAmount();

                    IFormSaleMainUs cFormSaleMain = (IFormSaleMainUs)FormManager.GetForm(FormManager.FORM_SAL_MAIN);
                    cFormSaleMain.DisplayItem(1, false);
                    cFormSaleMain.DisplayPayment();           // 결제등록정보 화면표시

                    m_nDestAmt = m_cDataService.GetPluTagetAmount(m_sPosMenuKey);
                }
                
                if (m_nDestAmt <= 0)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0134);
                    return false;
                }

                //#20171206 17크리스마스캠페인 start
                //적용시 주석
                //if (m_nDestAmt > m_cTrnStatus.Sale.RemainPayAmt) m_nDestAmt = m_cTrnStatus.Sale.RemainPayAmt;
                //#20171206 17크리스마스캠페인 end

                txtPayAmt.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);         // 대상금액                   
                txtUsePoint.Text = m_cPosStatus.Global.NumericTOCurrency(m_nDestAmt);       // 요청금액     

                // 요청금액
                if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                    m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC || 
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                {
                    txtUsePoint.ReadOnly = true;
                    btnSearch.Visible = false;

                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    if (PosMstManager.GetPosOption(POS_OPTION.OPT516) == "1")
                    {
                        btnWccIssue.Visible = true;
                    }
                    else
                    {
                        btnWccIssue.Visible = false;
                    }
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                }
                else
                {
                    txtUsePoint.ReadOnly = false;
                    btnSearch.Visible = true;
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    btnWccIssue.Visible = false;
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                }

                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                btnWelcomGiftYN(m_sPosMenuKey);
                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END


                //#14618 KT 더블할인 개발요청 start,phj
                btnKTDoubleDcYN(m_sPosMenuKey);
                //#14618 KT 더블할인 개발요청 end,phj

                //#15583 캠페인 기능 개선 요청 start
                //승인 시도시 체크 하도록 위치 변경
                //기존
                /*
                if (checkCampain().Equals(false))
                {
                    return false;
                }
                else
                {
                    return true;
                }
                */
                //변경
                return true;
                //#15583 캠페인 기능 개선 요청 end

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }

        /// <summary>
        /// T페이 결제 여부 확인
        /// </summary>
        /// <returns></returns>
        private bool ChangeTPayPayment()
        {
            try
            {
                // 할인대상금액 확인 
                if (m_nDestAmt <= 0) return false;

                // T페이 기능키 사용여부 확인 
                //DataTable dt = m_cDataCommon.SeletFuncKeyGroup(PosKey.MENU_KEY.PAY_DC_MENU);
                DataTable dt = m_cDataCommon.SeletFuncKeyGroup("");
                if (dt == null || dt.Rows.Count == 0) return false;
                DataRow[] dr = dt.Select("FUNC_ID = '" + PosKey.MENU_KEY.T_PAY + "'");
                if (dr == null || dr.Length == 0) return false;

                string choice = WinBasic.ShowForm(new string[] { FormManager.FORM_CHOICE_BOX
                    , ""
                    , MessageManager.GetGuideMessage(POS_MESSAGE.GUIDE.MSG_0009)
                    , MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0868)
                    , MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0869)
                    ,"216"
                    ,"173"
                    , "0"
                });

                if (choice != "2") return false;


                // T페이 통합결제 전환 
                frmTPay fTPay = (frmTPay)FormManager.GetForm(FormManager.FORM_PAY_TPAY);
                if (fTPay == null)
                {
                    fTPay = new frmTPay();
                    FormManager.AddForm(FormManager.FORM_PAY_TPAY, fTPay);
                }
                fTPay.PosMenuKey = PosKey.MENU_KEY.T_PAY;
                fTPay.SetTPayData(m_sInPutType, m_sInEntryMode, m_sInPutData, m_sInMaskData, m_sInEncData, m_nDestAmt, PosConst.TPAY_TRADE_TYPE.COMPLEX);
                if (fTPay.ShowDialog() == DialogResult.OK)
                {
                    this.DialogResult = System.Windows.Forms.DialogResult.OK;
                }
                else
                {
                    this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
                }

                this.Close();
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                return false;
            }
        }
        #endregion

        #region 입력 완료 처리
        /// <summary>
        /// 포인트 조회 처리
        /// </summary>
        /// <returns></returns>
        private bool SearchTxtInPut()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_sPosMenuKey == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0701);
                   
                    // Add, 2017.09.05, 카드번호 항목으로 포커스 이동 처리 
                    txtCardNo.SelectText();
                    txtCardNo.Focus();
                    
                    return false;
                }

                if (CheckTxtInPut(txtCardNo) == false) return false;

                if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                    m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC || 
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                {

                }
                else
                {
                    // 조회
                    string[] saRecvdData = null;
                    sRet = m_cPointMemberUse.SearchPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInPutData, m_sInEncData }, ref saRecvdData);
                    if (sRet != UserCom.RST_OK)
                    {
                        InDataToZeroFill();
                        txtCardNo.Focus();
                        return false;
                    }

                    Column.TR_PAYMENT.DATA cPayItem = (Column.TR_PAYMENT.DATA)m_cPointMemberUse.GetPayment(new string[] { });
                    txtUsablePoint.Text = m_cPosStatus.Global.NumericTOCurrency(cPayItem.AMT_ENTRY_04);          // 가용포인트
                    txtTotSavePoint.Text = m_cPosStatus.Global.NumericTOCurrency(cPayItem.AMT_ENTRY_03);         // 누적포인트
                }

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        
        /// <summary>
        /// 포인트 사용 승인 처리
        /// </summary>
        /// <param name="nFlowMode"></param>
        /// <returns></returns>
        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
        //기존
        //private bool CompleteTxtInPut(int nFlowMode)
        //변경
        private bool CompleteTxtInPut(int nFlowMode, object sender)
        //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_nDestAmt == 0)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0134);
                    return false;
                }
                if (m_sPosMenuKey == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0701);
                    return false;
                }

                //#15583 캠페인 기능 개선 요청 start
                if (m_sPosMenuKey == PosKey.MENU_KEY.SKT ||
                    m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                    m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                {
                    if (checkCampain().Equals(false))
                    {
                        return false;
                    }
                }
                //#15583 캠페인 기능 개선 요청 end

                if (nFlowMode == 1)
                {
                    if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.KT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                    {
                        //InParam
                        // 0.전문구분,1.거래유형, 2.할부개월, 3.승인금액 , 4.봉사료, 5.세금, 6.원승인번호, 7.원거래일자, 8.포인트거래구분, 9.상품코드,
                        //10.전표인쇄여부, 11.추가항목, 12.제휴할인코드, 13.제휴할인금액, 14.예비1, 15.예비2

                        //#20170906 T페이 고도화 작업 phj, start
                        //기존
                        //승인처리                                        0,                                 1,  2,    3,                     4,   5,   6,  7,  8,  9,  10, 11, 12,            13, 14, 15 
                        //sRet = m_cMobilePoint.SetPayment(new string[] { PosConst.POS_CAT_MASTER.TRAN_TYPE, "", "00", m_nDestAmt.ToString(), "0", "0", "", "", "", "", "", "", m_sPosMenuKey, "", "", "" });

                        //변경                                          0,                                 1,  2,    3,                     4,   5,   6,  7,  8,  9,  10, 11, 12,            13, 14,            15 
                        sRet = m_cMobilePoint.SetPayment(new string[] { PosConst.POS_CAT_MASTER.TRAN_TYPE, "", "00", m_nDestAmt.ToString(), "0", "0", "", "", "", "", "", "", m_sPosMenuKey, "", m_sInCardData, "" });
                        //#20170906 T페이 고도화 작업 phj, end

                        if (sRet != UserCom.RST_OK)
                        {
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }
                    }
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                    {
                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC Start! (m_sPosMenuKey :" + m_sPosMenuKey);

                        if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }

                        #region 멤버십 할인 승인

                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 start
                        m_sInWelcomeCard_Type = m_sInWelcomeCard_Type == "" ? "C" : m_sInWelcomeCard_Type;
                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 end

                        bool bSuccess = false;
                        string[] saRecvdData = null;
                        sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                             m_sInPutData, 
                                                                             m_sInPutType, 
                                                                             m_sInHP_CustNumer, 
                                                                             m_sInHP_WelcomeCard, 
                                                                             m_sInWelcomeCard_Type, 
                                                                             "",
                                                                             m_nDestAmt.ToString(),
                                                                             DateTime.Now.ToString("yyyyMMdd"), 
                                                                             DateTime.Now.ToString("HHmmss"), 
                                                                             ""}, ref saRecvdData);

                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC End! (Result :" + sRet.ToString());

                        if (sRet == UserCom.RST_OK)
                        {
                            bSuccess = true;

                            //// 웰컴할인 적용했는데, HP회원번호가 없을 경우
                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                            //{
                            //    UserLog.WriteLogFile(UserCom.LOG_IOS,
                            //                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                            //                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                            //                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                            //                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");
                            //
                            //    WelcomeCard_ClientRegister();
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                                {
                                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");

                                    WelcomeCard_ClientRegister();
                                }
                            }
                        }
                        else
                        {
                            bSuccess = false;

                            //#20180605 null 체크 start
                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                            //{
                            //    //if (WinManager.QuestionMessage("발급 처리 되지 않은 카드입니다. 발급 처리 하시겠어요?") == true)
                            //    if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1141), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131)) == true)
                            //    {
                            //        if (WelcomeCard_Issue(m_sInPutData) == true)
                            //        {
                            //            //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                            //            if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                            //            {
                            //                // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                            //                sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                            //                                                                     m_sInPutData, 
                            //                                                                     m_sInPutType, 
                            //                                                                     m_sInHP_CustNumer, 
                            //                                                                     m_sInHP_WelcomeCard, 
                            //                                                                     m_sInWelcomeCard_Type, 
                            //                                                                     "",
                            //                                                                     m_nDestAmt.ToString(),
                            //                                                                     DateTime.Now.ToString("yyyyMMdd"), 
                            //                                                                     DateTime.Now.ToString("HHmmss"), 
                            //                                                                     ""},
                            //                                                                     ref saRecvdData);
                            //
                            //                if (sRet == UserCom.RST_OK)
                            //                {
                            //                    bSuccess = true;
                            //                }
                            //            }
                            //        }
                            //    }
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                                {
                                    if (WelcomeCard_Issue(m_sInPutData) == true)
                                    {
                                        //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                                        if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                                        {
                                            // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                                            sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                                                 m_sInPutData, 
                                                                                                 m_sInPutType, 
                                                                                                 m_sInHP_CustNumer, 
                                                                                                 m_sInHP_WelcomeCard, 
                                                                                                 m_sInWelcomeCard_Type, 
                                                                                                 "",
                                                                                                 m_nDestAmt.ToString(),
                                                                                                 DateTime.Now.ToString("yyyyMMdd"), 
                                                                                                 DateTime.Now.ToString("HHmmss"), 
                                                                                                 ""},
                                                                                                 ref saRecvdData);

                                            if (sRet == UserCom.RST_OK)
                                            {
                                                bSuccess = true;
                                            }
                                        }
                                        else
                                        {
                                            bSuccess = true;
                                        }
                                    }
                                }
                            }
                            //#20180605 null 체크 end
                        }

                        if (bSuccess == false)
                        {
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }

                        #endregion 
                    }
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    else
                    {
                        if (CheckTxtInPutForCat() == false) return false;

                        //InParam
                        //0.전문구분,1.거래유형, 2.할부개월, 3.승인금액 , 4.봉사료, 5.세금, 6.원승인번호, 7.원거래일자, 8.포인트거래구분, 9.상품코드,
                        //10.전표인쇄여부, 11.추가항목, 12.제휴할인코드, 13.제휴할인금액, 14.TPAY OTB번호, 15.예비2

                        string sAppType = PosConst.POS_CAT_MASTER.TRADE_ID.CAT_POINT_USE;

                        //승인처리                                           0,                                 1,        2,    3,                 4,   5,   6,  7,  8,  9,  10, 11, 12,            13, 14, 15 
                        sRet = m_cPointMemberUse.SetPayment(new string[] { PosConst.POS_CAT_MASTER.TRAN_TYPE, sAppType, "00", txtUsePoint.Value, "0", "0", "", "", "", "", "", "", m_sPosMenuKey, "", "", "" });

                        if (sRet != UserCom.RST_OK)
                        {
                            txtUsePoint.Focus();
                            return false;
                        }
                    }
                } 
                else
                {
                    if (CheckTxtInPut(null) == false) return false;

                    if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.KT || 
                        m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                    {

                        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
                        //기존
                        /*
                        //#20170906 T페이 고도화 작업 phj, start
                        //기존
                        //통신사 할인 처리
                        //sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "" });

                        //변경                                          0,             1,             2,            3,            4,                     5,  6,  7,  8,  9,  10, 11, 12, 13, 14,            15 
                        sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, ""});
                        //#20170906 T페이 고도화 작업 phj, end
                        */

                        //변경
                        if (nFlowMode == 3)
                        {
                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                            if (sender == btnWelcomGift)
                            {
                                bool bRet = false;
                                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START                            
                                bRet = btnWelcomGiftYN(m_sPosMenuKey);
                                //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

                                if (bRet == false)
                                {
                                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                                    return false;
                                }
                            }
                            else if (sender == btnDoubleDC)
                            {
                                bool bRet = false;
                                //#14618 KT 더블할인 개발요청 start,phj
                                bRet = btnKTDoubleDcYN(m_sPosMenuKey);
                                //#14618 KT 더블할인 개발요청 end,phj
                                if (bRet == false)
                                {
                                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                                    return false;
                                }
                            }
                            //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                            sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, m_sWelcomGiftCode });
                        }
                        else
                        {
                            sRet = m_cMobilePoint.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_nDestAmt.ToString(), "", "", "", "", "", "", "", "", "", m_sInCardData, "" });
                        }
                        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END


                        if (sRet != UserCom.RST_OK)
                        {
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }
                    }
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    else if (m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC)
                    {
                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC Start! (m_sPosMenuKey :" + m_sPosMenuKey);

                        if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
                        {
                            WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }

                        #region 멤버십 할인 승인


                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 start
                        m_sInWelcomeCard_Type = m_sInWelcomeCard_Type == "" ? "C" : m_sInWelcomeCard_Type;
                        //#20180605 실물카드 구분 비어 있을 경우 C로 픽스 end

                        bool bSuccess = false;
                        string[] saRecvdData = null;
                        sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                             m_sInPutData, 
                                                                             m_sInPutType, 
                                                                             m_sInHP_CustNumer, 
                                                                             m_sInHP_WelcomeCard, 
                                                                             m_sInWelcomeCard_Type, 
                                                                             "",
                                                                             m_nDestAmt.ToString(),
                                                                             DateTime.Now.ToString("yyyyMMdd"), 
                                                                             DateTime.Now.ToString("HHmmss"), 
                                                                             ""}, ref saRecvdData);

                        UserLog.WriteLogFile(UserCom.LOG_IOS,
                                             System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                             System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                             System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                             "[CompleteTxtInPut] WCC End! (Result :" + sRet.ToString());

                        if (sRet == UserCom.RST_OK)
                        {
                            bSuccess = true;

                            // 웰컴할인 적용했는데
                            // 해피포인트 적용이 되어있으면 
                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                            //{
                            //    UserLog.WriteLogFile(UserCom.LOG_IOS,
                            //                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                            //                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                            //                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                            //                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");
                            //
                            //    WelcomeCard_ClientRegister();
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sHPCustNo].Trim() == "")
                                {
                                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                                         "[CompleteTxtInPut] WelcomeCard_ClientRegister!  ");

                                    WelcomeCard_ClientRegister();
                                }
                            }
                        }
                        else
                        {
                            bSuccess = false;

                            //#20180605 null 체크 start

                            //if (saRecvdData != null && m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                            //{
                            //    //if (WinManager.QuestionMessage("발급 처리 되지 않은 카드입니다. 발급 처리 하시겠어요?") == true)
                            //    if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1141), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1131)) == true)
                            //    {
                            //        if (WelcomeCard_Issue(m_sInPutData) == true)
                            //        {
                            //            //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                            //            if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                            //            {
                            //                // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                            //                sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                            //                                                                     m_sInPutData, 
                            //                                                                     m_sInPutType, 
                            //                                                                     m_sInHP_CustNumer, 
                            //                                                                     m_sInHP_WelcomeCard, 
                            //                                                                     m_sInWelcomeCard_Type, 
                            //                                                                     "",
                            //                                                                     m_nDestAmt.ToString(),
                            //                                                                     DateTime.Now.ToString("yyyyMMdd"), 
                            //                                                                     DateTime.Now.ToString("HHmmss"), 
                            //                                                                     ""},
                            //                                                                     ref saRecvdData);
                            //                if (sRet == UserCom.RST_OK)
                            //                {
                            //                    bSuccess = true;
                            //                }
                            //            }
                            //        }
                            //    }
                            //}

                            if (saRecvdData != null)
                            {
                                if (m_sInWelcomeCard_Type == "C" && saRecvdData[Column.WELCOMECARD_DC_RECV.SEQ.sReqCode].Trim() == "00301")
                                {
                                    if (WelcomeCard_Issue(m_sInPutData) == true)
                                    {
                                        //if (WinManager.QuestionMessage("발급 처리 되었습니다. 할인 진행하시겠어요?") == true)
                                        if (WinManager.QuestionMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1142), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1138)) == true)
                                        {
                                            // 발급 성공 시 '발급 처리 되었습니다. 할인 진행하시겠어요?' 할인여부 안내 후 할인을 진행 할 수 있도록 한다.
                                            sRet = m_cWelcomeCard.SetWccDCPayment(new string[] { PosConst.WELCOMECARD_TYPE.DC_AGREE,
                                                                                                 m_sInPutData, 
                                                                                                 m_sInPutType, 
                                                                                                 m_sInHP_CustNumer, 
                                                                                                 m_sInHP_WelcomeCard, 
                                                                                                 m_sInWelcomeCard_Type, 
                                                                                                 "",
                                                                                                 m_nDestAmt.ToString(),
                                                                                                 DateTime.Now.ToString("yyyyMMdd"), 
                                                                                                 DateTime.Now.ToString("HHmmss"), 
                                                                                                 ""},
                                                                                                 ref saRecvdData);

                                            if (sRet == UserCom.RST_OK)
                                            {
                                                bSuccess = true;
                                            }
                                        }
                                    }
                                }
                            }
                            //#20180605 null 체크 end
                        }


                        if (bSuccess == false)
                        {
                            InDataToZeroFill();
                            txtCardNo.Focus();
                            return false;
                        }
                        #endregion  
                    }
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    else
                    {
                        double nUsePoint = m_cDataService.DoubleParse(txtUsePoint.Value);
                        if (m_sPosMenuKey == PosKey.MENU_KEY.BLUE_MEMBERS || m_sPosMenuKey == PosKey.MENU_KEY.RED_MEMBERS)
                        {
                            nUsePoint = CmUtil.MathRounds(m_cDataService.DoubleParse(txtUsePoint.Value), PosConst.MATH_ROUND.TRANCATE, -2);
                        }

                        // 포인트 사용 승인 처리
                        sRet = m_cPointMemberUse.SetPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, nUsePoint.ToString(), "" });
                        if (sRet != UserCom.RST_OK) return false;
                    }
                }
                this.DialogResult = DialogResult.OK;
                this.Close();

                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }


        /// <summary>
        /// 포인트 사용 수기승인 처리
        /// </summary>
        /// <returns></returns>
        private bool MenualTxtInPut()
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (m_sPosMenuKey == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0701);
                    return false;
                }

                if (WinManager.QuestionMessage(POS_MESSAGE.ERROR.MSG_0368) == false) return false;

                if (CheckTxtInPut(null, false) == false) return false;

                if (m_sPosMenuKey == PosKey.MENU_KEY.SKT || 
                    m_sPosMenuKey == PosKey.MENU_KEY.KT ||
                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC ||
                    //#20180413 웰컴카드 신규기능 추가 end,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.LGT)
                {
                }
                else
                {
                    // 포인트 사용 수기승인 처리
                    sRet = m_cPointMemberUse.SetMenualPayment(new string[] { m_sPosMenuKey, m_sInPutType, m_sInMaskData, m_sInEncData, m_cDataService.DoubleParse(txtUsePoint.Value).ToString(), "" });
                    if (sRet != UserCom.RST_OK) return false;

                    this.DialogResult = DialogResult.OK;
                    this.Close();
                }
                return true;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        #region DeviceEvent 관련
        /// <summary>
        /// DeviceEvent 관련
        /// </summary>
        /// <param name="sDevice"></param>
        /// <param name="sData1"></param>
        /// <param name="sData2"></param>
        /// <param name="sData3"></param>
        public void OnDeviceEvent(string sDevice, string sData1, string sData2, string sData3)
        {
            try
            {
                if (bNotDoubleClik) return;
                bNotDoubleClik = true;

                switch (sDevice)
                {
                    case PosConst.OPOS_DEVICE.MSR:
                        this.Invoke(new EventHandler(OnMSREvent));
                        break;
                    case PosConst.OPOS_DEVICE.SCANNER:
                        this.Invoke(new EventHandler(OnScannerEvent));
                        break;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
            bNotDoubleClik = false;
        }

        /// <summary>
        /// MSR Event
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnMSREvent(object source, EventArgs e)
        {
            try
            {
                string sMsrData = m_cDevStatus.Msr.Track2Data;
                if (sMsrData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                    m_sInPutData = sMsrData;

                    txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        /// <summary>
        /// 스캐너 이벤트 처리
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
        private void OnScannerEvent(object source, EventArgs e)
        {
            try
            {
                string sScanData = m_cDevStatus.Scanner.DataLabel;
                if (sScanData.Length > 0)
                {
                    m_sInEncData = "";
                    m_sInPutData = sScanData;
                    if (m_sInPutData.Length > 16 && CmUtil.IsNumber(m_sInPutData.Substring(16, 1)) == false)
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_MOBILE_SWIP;
                        txtCardNo.Value = m_sInPutData.Substring(0, 16);
                    }
                    else
                    {
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_KEYIN;
                        txtCardNo.Value = m_sInPutData;
                    }

                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        /// <summary>
        /// 카드 번호 암호화
        /// </summary>
        /// <param name="sInData"></param>
        /// <param name="sInMaskData"></param>
        /// <param name="sInEncData"></param>
        /// <returns></returns>
        private bool EncryptedCardNo(string sInData, ref string sInMaskData, ref string sInEncData)
        {
            string sEncData = sInData;
            bool bRet = false;
            try
            {
                if (m_sPosMenuKey == PosKey.MENU_KEY.OKCASHBACK && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "0" && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "" && m_cDevStatus.ICReader.UseYn != true)       // OCB 직통신
                {
                    sInEncData = sInData;
                    sInMaskData = sInData;
                    bRet = true;
                }
                else
                {
                    UnRegIcCallback();              // IC리더 콜백 해지

                    sEncData = m_cDeviceICReader.GetEncryptedCardNo(sInData).Trim();
                    if (CmUtil.MidH(sEncData, 0, 2) == "00")
                    {
                        sInEncData = CmUtil.MidH(sEncData, 2, 512).Trim();                          // 암호화 데이터
                        sInMaskData = CmUtil.MidH(sEncData, 514, sEncData.Length - 514).Trim();     // 마스킹 데이터
                        bRet = true;
                    }
                    else
                    {
                        //암호화 처리 실패!
                        UserLog.WriteLogFile(UserCom.LOG_ERROR, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "Fail =>" + sInData);
                        WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0280);
                    }
                    if (txtCardNo.Value == "") tmrIcCard.Enabled = true;    // IC리더 콜백 설정
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }

        /// <summary>
        /// IC 카드 정보 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetIcCardData(bool bCancelCallBack)
        {
            try
            {
                if (m_sPosMenuKey == PosKey.MENU_KEY.OKCASHBACK && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "0" && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "" && m_cDevStatus.ICReader.UseYn != true)       // OCB 직통신
                    return true;
    
                if (bCancelCallBack == true) UnRegIcCallback(); // IC리더 콜백 해지

                txtCardNo.Value = "";
                ClearCardInfo();        // 카드 입력 정보 클리어

                string sRsvStr = "";
                if (m_cDeviceICReader.GetCardInfo_ICReader(PosConst.IC_READER_TRAN_TYPE.POINT, CmUtil.IntParse(txtUsePoint.Value), ref sRsvStr) == true)
                {
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sInEncData = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        m_sInMaskData = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sInPutData = m_sInMaskData;
                        m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        m_sInEntryMode = PosConst.POS_VAN_MASTER.TPAY_ENTRY_MODE.SWIP;

                        txtCardNo.Value = m_sInPutData.Length > 16 ? m_sInPutData.Substring(0, 16) : m_sInPutData;

                        //tmrIcCard.Enabled = true;       // IC리더 콜백 설정
                        return true;
                    }
                }
                if (txtCardNo.Value == "") tmrIcCard.Enabled = true;       // IC리더 콜백 설정
                // WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0321);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }

        /// <summary>
        /// 비밀번호 입력 처리
        /// </summary>
        /// <returns></returns>
        private bool GetPinPadData()
        {
            try
            {
                txtCardNo.Text = "";
                ClearCardInfo();        // 카드 입력 정보 클리어
                string sRsvStr = "";
                //#20171107 통합적립창에서 서명패드 버튼 클릭시 '현금영수증' -> '번호를 입력하세요' start
                //기존
                //if (m_cDeviceSignPad.GetMsg_SignPad(false, MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0065), ref sRsvStr) == true)
                //변경
                if (m_cDeviceSignPad.GetMsg_SignPad(false, MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0065), ref sRsvStr) == true)
                //#20171107 통합적립창에서 서명패드 버튼 클릭시 '현금영수증' -> '번호를 입력하세요' end
                {
                    txtCardNo.Text = sRsvStr;

                    return true;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return false;
        }
        #endregion

        #region 여전법 대응
        /// <summary>
        /// ZeroFill 초기화
        /// </summary>
        private void InDataToZeroFill()
        {
            try
            {

                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_sInPutData);
                CmUtil.ZeroFillClear(ref m_sInEncData);
                CmUtil.ZeroFillClear(ref m_sInMaskData);
                //////////////////////////////////////////////////////////////////////////////////

                //#20180413 웰컴카드 신규기능 추가 start,phj   
                CmUtil.ZeroFillClear(ref m_sInHP_CustNumer); // HPC - 회원번호
                CmUtil.ZeroFillClear(ref m_sInHP_WelcomeCard); // HPC - 웰컴카드번호
                CmUtil.ZeroFillClear(ref m_sInWelcomeCard_Type); // 웰컴카드 카드타입(C:실물카드, A:해피앱)
                CmUtil.ZeroFillClear(ref m_sReadingHPData); // 웰컴카드 카드타입(C:실물카드, A:해피앱)
                //#20180413 웰컴카드 신규기능 추가 end,phj   

                txtCardNo.Value = string.Empty;
            }
            catch (Exception) { }

        }
        #endregion 여전법 대응

        private void lblCardNo_MouseDown(object sender, MouseEventArgs e)
        {
            //if (e.Button == System.Windows.Forms.MouseButtons.Right)
            //{
            //    if (m_sPosMenuKey == PosKey.MENU_KEY.OLIBANK)
            //        m_cDevStatus.Scanner.DataLabel = "7516015102717790";
            //    else if (m_sPosMenuKey == PosKey.MENU_KEY.OKCASHBACK)
            //        m_cDevStatus.Scanner.DataLabel = "2100360697400638";
            //    else
            //        m_cDevStatus.Scanner.DataLabel = "2581104966028022";
            //    OnScannerEvent(null, null);
            //}
        }

        #region IC리더 콜백 관련
        /// <summary>
        /// IC리더 콜백 설정
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tmrIcCard_Tick(object sender, EventArgs e)
        {
            try
            {
                if (m_cDevStatus.ICReader.UseYn != true)             // 여전법 인증여부(0:MSR, 1:IC)
                {
                    tmrIcCard.Enabled = false;
                    return;
                }

                if (tmrIcCard.Tag == null || tmrIcCard.Tag.ToString() == "")
                {
                    // IC리더 콜백 설정
                    if (bNotDoubleClik) return;

                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.RegIcCallback(delegateReader);
                    //변경
                    //string sApprID = PosMstManager.GetMstVan(ItemConst.TR_ITEM_ID.CREDITCARD_ITEM, ItemConst.TR_ITEM_ID.CREDITCARD.CREDIT_CARD, PosMst.MST_VAN.DATA.APPR_ID);
                    //m_cDeviceICReader.RegIcCallbackCardInfo(sApprID, m_cDataService.IntParse(txtUsePoint.Value), delegateReaderCardInfo);
                    //#20170918 IC 콜백 함수 변경 end
                }
                else if (tmrIcCard.Tag.ToString() == "MSR")
                {
                    // MSR 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    bNotDoubleClik = false;
                    txtEditBox_EditBoxKeyDownEvent(txtCardNo, PosKey.MENU_KEY.ENTER);

                    tmrIcCard.Enabled = true;
                }
                else if (tmrIcCard.Tag.ToString() == "IC")
                {
                    // IC리더 카드 읽기
                    tmrIcCard.Enabled = false;
                    tmrIcCard.Tag = "";
                    tmrIcCard.Interval = 500;

                    bNotDoubleClik = false;
                    btnProc_Click(btnIcCard, null);
                }
                else
                    tmrIcCard.Enabled = false;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        delegate void DelegateIcReaderCallBack(int rc, StringBuilder str);
        /// <summary>
        /// IC리더 콜백 함수
        /// </summary>
        /// <param name="num"></param>
        /// <param name="str"></param>
        public void OnIcReaderCallBack(int num, StringBuilder str)
        {
            try
            {
                if (txtCardNo.InvokeRequired)
                {
                    DelegateIcReaderCallBack d = new DelegateIcReaderCallBack(OnIcReaderCallBack);
                    this.Invoke(d, new object[] { num, str });
                }
                else
                {
                    if (bNotDoubleClik) return;
                    bNotDoubleClik = true;

                    if (num == 1)
                    {
                        // IC 카드
                        tmrIcCard.Tag = "IC";
                        tmrIcCard.Interval = 100;
                    }
                    else
                    {
                        // MSR 카드
                        if (str.ToString().StartsWith("EN") == true)
                        {
                            ClearCardInfo();        // 카드 입력 정보 클리어

                            m_sInEncData = CmUtil.MidH(str.ToString(), 0, 512).Trim();
                            m_sInMaskData = CmUtil.MidH(str.ToString(), 512, 40).Trim();
                            m_sInPutData = m_sInMaskData;
                            m_sInPutType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;

                            txtCardNo.Value = m_sInPutData;
                            tmrIcCard.Tag = "MSR";

                            tmrIcCard.Interval = 100;
                        }
                        else
                        {
                            tmrIcCard.Interval = 500;
                        }
                    }
                    tmrIcCard.Enabled = true;

                    bNotDoubleClik = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                        System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                bNotDoubleClik = false;
            }
        }

        /// <summary>
        /// IC리더 콜백 해지
        /// </summary>
        private void UnRegIcCallback()
        {
            try
            {
                if (m_sPosMenuKey == PosKey.MENU_KEY.OKCASHBACK && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "0" && PosMstManager.GetPosOption(POS_OPTION.OPT326) != "" && m_cDevStatus.ICReader.UseYn != true)       // OCB 직통신
                    return;

                if (m_cDevStatus.ICReader.UseYn == true)     // 여신전문금융업법 적용여부 체크
                {
                    tmrIcCard.Enabled = false;

                    //#20170918 IC 콜백 함수 변경 start
                    //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
                    //기존
                    m_cDeviceICReader.UnRegIcCallback();
                    //변경
                    //m_cDeviceICReader.UnRegIcCallbackCardInfo();
                    //#20170918 IC 콜백 함수 변경 end
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        //#20170918 IC 콜백 함수 변경 start
        //포인트창에서 해피제휴 신용카드 리딩시 IC 우선 거래로 인해 '카드를 읽혀 주세요' 팝업 나오는 현상 수정.
        /*
        delegate void DelegateWriteLog(int returnValue, StringBuilder returnData);
        /// <summary>
        /// IC리더 콜백 함수(CardInfo)
        /// </summary>
        /// <param name="returnValue"></param>
        /// <param name="returnData"></param>
        public void OnIcReaderCallBackCardInfo(int returnValue, StringBuilder returnData)
        {
            if (txtCardNo.InvokeRequired)
            {
                DelegateWriteLog d = new DelegateWriteLog(OnIcReaderCallBackCardInfo);
                this.Invoke(d, new object[] { returnValue, returnData });
            }
            else
            {
                if (m_bCardInPut) return;
                m_bCardInPut = true;

                if (returnValue > 0)
                {
                    string sRsvStr = returnData.ToString();
                    if (CmUtil.MidH(sRsvStr, 0, 2) == "00")
                    {
                        m_sCardNo = CmUtil.MidH(sRsvStr, 6, 512).Trim();
                        txtCardNo.Value = CmUtil.MidH(sRsvStr, 1030, 37).Trim();
                        m_sIcChip = CmUtil.MidH(sRsvStr, 518, 512).Trim();
                        if (CmUtil.MidH(sRsvStr, 4, 2).Trim() == "02")
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_SWIP;
                        }
                        else
                        {
                            m_InputType = PosConst.POS_VAN_MASTER.INPUT_TYPE.VAN_IC;
                        }
                        m_sServiceCode = CmUtil.MidH(sRsvStr, 1067, 5).Trim();
                        m_sFallDiv = CmUtil.MidH(sRsvStr, 3, 1); // == "3" ? "0" : "1";

                        // IC 카드(CardInfo)
                        tmrIcCard.Tag = "ICREADER";
                        tmrIcCard.Interval = 100;
                        tmrIcCard.Enabled = true;

                        m_bCardInPut = false;
                    }
                }
            }

        }
        */
        //#20170918 IC 콜백 함수 변경 end

        #endregion

        private void txtCardNo_EditBoxTextChangedEvnet(object sender, EventArgs e)
        {
            try
            {
                //txtPayAmt.Text = "";
                //txtTotSavePoint.Text = m_cPosStatus.Global.NumericTOCurrency(0);
                //txtUsablePoint.Text = m_cPosStatus.Global.NumericTOCurrency(0);
                //txtUsePoint.Text = m_cPosStatus.Global.NumericTOCurrency(0);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }

        private bool  checkCampain()
        {
            try
            {
                //#15583 캠페인 기능 개선 요청 start
                //변경
                // 적립불가 상품의 캠페인 성립여부 체크
                bool bCpnDupPrmtYN = false;

                ArrayList alTrSaleCpi = (ArrayList)StateObject.GetItemObject(Column.TR_SALE_CPI_RSLT.ITEM);         // 캠페인트란 아이템

                if (alTrSaleCpi != null)
                {
                    foreach (Column.TR_SALE_CPI_RSLT.DATA cTrSaleCpi in alTrSaleCpi)
                    {
                        // TELECOM_COOP_DUP_PRMT_YN -> 제휴할인그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                        // MOBILE_CPN_DUP_PRMT_YN -> 모바일쿠폰 그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                        // HPY_CPN_DUP_PRMT_YN -> 해피쿠폰 사용 중복 허용 여부(1:중복적용가능, 0:중복적용불가)
                        // CPI_CUST_BNFT_TYPE -> 캠페인 고객해택 구분(01:할인,02:적립,03:할인+적립,04:사은품,05:복권,06:명판,07:복권+명판,08:응모권,09:응모권+명판,10:스템프,11:할인(실효100%),12:사은품+적립,13:할인(실효))
                        if (cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.LOTTERY ||
                            cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.RECEIPT ||
                            cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.LOTT_REC ||
                            cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.ENTRY ||
                            cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.ENTR_REC)
                        {

                            if (cTrSaleCpi.TELECOM_COOP_DUP_PRMT_YN == "0" && cTrSaleCpi.LTTR_NMPLAT_NO != "")
                            {
                                bCpnDupPrmtYN = true;
                                break;
                            }
                        }
                        else if (cTrSaleCpi.CPI_CUST_BNFT_TYPE == ItemConst.CPI_CUST_BNFT.HP_STAMP)
                        {

                            if (cTrSaleCpi.TELECOM_COOP_DUP_PRMT_YN == "0" && cTrSaleCpi.LTTR_NMPLAT_NO != "")
                            {
                                bCpnDupPrmtYN = true;
                                break;
                            }
                        }
                        else
                        {

                        }
                    }
                }

                if (bCpnDupPrmtYN == true)
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0796);
                    return false;
                }

                //#15583 캠페인 기능 개선 요청 end

                // MoonSeokWoo 2017.10.26 캠페인 통신사 성립여부 체크 Start
                if (m_sPosMenuKey.Equals(PosKey.MENU_KEY.SKT) || 
                    m_sPosMenuKey.Equals(PosKey.MENU_KEY.KT) ||

                    //#20180413 웰컴카드 신규기능 추가 start,phj
                    m_sPosMenuKey == PosKey.MENU_KEY.WELCOMECARD_DC ||
                    //#20180413 웰컴카드 신규기능 추가 end,phj

                    m_sPosMenuKey.Equals(PosKey.MENU_KEY.LGT))
                {
                    // 적립불가 상품의 캠페인 성립여부 체크
                    bool bSaveCpiYN = false;

                    ArrayList alSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                    foreach (Column.TR_PLU.DATA cPluItem in alSaleItem)
                    {
                        if (cPluItem.alTrSaleCpi != null)
                        {
                            foreach (Column.TR_SALE_CPI_RSLT.DATA cTrSaleCpi in cPluItem.alTrSaleCpi)
                            {
                                // TELECOM_COOP_DUP_PRMT_YN -> 제휴할인그룹 중복 여부(1:중복적용가능, 0:중복적용불가)
                                // CPI_CUST_BNFT_TYPE -> 캠페인 고객해택 구분(01:할인,02:적립,03:할인+적립,04:사은품,05:복권,06:명판,07:복권+명판,08:응모권,09:응모권+명판,10:스템프,11:할인(실효100%),12:사은품+적립,13:할인(실효))
                                if (cTrSaleCpi.TELECOM_COOP_DUP_PRMT_YN == "0" && cTrSaleCpi.CPI_CUST_BNFT_TYPE == "02")
                                {
                                    bSaveCpiYN = true;
                                }
                            }
                        }
                    }

                    if (bSaveCpiYN == true)
                    {
                        if (WinManager.QuestionMessage(MessageManager.GetGuideMessage(POS_MESSAGE.GUIDE.MSG_0012)) == false)
                        {
                            txtCardNo.Text = "";
                            txtCardNo.Focus();
                            return false;
                        }
                        else
                        {
                            return true;
                        }
                    }
                    else
                    {
                        return true;
                    }
                }
                return true;
                // MoonSeokWoo 2017.10.26 캠페인 통신사 성립여부 체크 End
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                return true;
            }
        }

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        #region 웰컴 기프트 버튼 선택 
        private void btnWelcomGiftClick(object sender, EventArgs e)
        {
            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "웰컴 기프트 Button Start!!!");


                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                //기존
                //if (btnWelcomGiftYN(m_sPosMenuKey) == false)
                //{
                //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                //    return;
                //}
                //CompleteTxtInPut(3);

                //변경
                CompleteTxtInPut(3, sender);
                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj



                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "웰컴 기프트 Button End!!! ProductCode : " + m_sWelcomGiftCode);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        #endregion
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END

        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ START
        #region 웰컴 기프트 버튼 활성화 유무
        private bool btnWelcomGiftYN(string m_sPosMenuKey)
        {
            bool bRet = true;
            try
            {
                m_sWelcomGiftCode = "";
                btnWelcomGift.Visible = false;

                //#14618 KT 더블할인 개발요청 start,phj
                //기존
                //btnWelcomGift.Visible = m_cDataCommon.WelcomGiftBtnYN(m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //변경
                btnWelcomGift.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_WC_GIFT, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                //#14618 KT 더블할인 개발요청 end,phj

                if (btnWelcomGift.Visible == true && m_sWelcomGiftCode == "")
                {
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }
        #endregion
        //#14231 KT 웰컴기프트 카드 기능 개발, PHJ END


                        
        //#14618 KT 더블할인 개발요청 start,phj
        #region KT 더블할인 
        private bool btnKTDoubleDcYN(string m_sPosMenuKey)
        {
            bool bRet = true;
            try
            {
                m_sWelcomGiftCode = "";
                btnDoubleDC.Visible = false;
                btnDoubleDC.Visible = m_cDataCommon.WelcomGiftBtnYN(ItemConst.DC_APPLY_TRGT.DC_KT_DOUBLE, m_sPosMenuKey, m_nDestAmt, out m_sWelcomGiftCode);
                if (btnDoubleDC.Visible == true && m_sWelcomGiftCode == "")
                {
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return bRet;
        }
        #endregion
        //#14618 KT 더블할인 개발요청 end,phj

        //#14618 KT 더블할인 개발요청 start,phj
        private void btnDoubleDC_Click(object sender, EventArgs e)
        {
            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "KT Double DC Button Start!!!");

                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 start,phj
                //기존
                //if (btnKTDoubleDcYN(m_sPosMenuKey) == false)
                //{
                //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0772);
                //    return;
                //}
                //
                ////승인
                //CompleteTxtInPut(3);

                //변경
                CompleteTxtInPut(3, sender);
                //#20180525 웰컴기프트 승인 시에도 더블할인 적용되는 현상 수정 end,phj

                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "KT Double DC Button End!!! ProductCode : " + m_sWelcomGiftCode);
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
        }
        //#14618 KT 더블할인 개발요청 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 웰컴카드 발급 버튼
        /// <summary>
        /// 웰컴카드 발급 버튼
        /// </summary>
        private bool WelcomeCard_Issue(string sCardNo = "")
        {
            string sRet = UserCom.RST_ERR; 

            if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return false;
            if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return false;

            if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
            {

                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                return false;

            }

            try
            {
                UserLog.WriteLogFile(UserCom.LOG_IOS,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                     "[WelcomeCard_Issue] WELCOMECARD_ISSUE Open!  ");

                //#20180413 웰컴카드 신규기능 추가 start, 20180621
                //기존
                //sRet = WinPay.ShowForm(new string[] { FormManager.FORM_WELCOMECARD_ISSUE, PosKey.MENU_KEY.WELCOMECARD_ISSUE, "2", sCardNo });
                //변경
                sRet = WinPay.ShowForm(new string[] { FormManager.FORM_WELCOMECARD_ISSUE, PosKey.MENU_KEY.WELCOMECARD_ISSUE, "2", sCardNo, "true" });
                //#20180413 웰컴카드 신규기능 추가 end, 20180621

                if (sRet != UserCom.RST_OK)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            ex.Message);

                return false;
            }
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 웰컴카드 전문조립

        /// <summary>
        /// 웰컴카드 전문조립
        /// </summary>
        private bool WelcomeCard_SetData(string sType)
        {
            string sRet = UserCom.RST_ERR;

            if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return false;
            if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return false;
            
            if (PosMstManager.GetPosOption(POS_OPTION.OPT516) != "1")
            {
                WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0790);
                return false;
            }

            try
            {
                // 전문통신!!!
                string[] saRecvdData = null;
                sRet = m_cWelcomeCard.WelcomeCard_SendDataMake(PosConst.CANCEL_DIV.NORMAL,
                                                               new string[] {sType,                                    //웰컴타입                            
                                                                             m_sInPutData,                             //카드번호
                                                                             m_sInPutType,                             //입력구분
                                                                             m_sInHP_CustNumer,                        //HPC - 회원번호
                                                                             m_sInHP_WelcomeCard,                      //HPC - 웰컴카드번호
                                                                             m_sInWelcomeCard_Type,                    //웰컴카드 C:실물카드, A:해피App
                                                                             "",                                       //통신사구분
                                                                             m_nDestAmt.ToString(),                    //할인대상금액
                                                                             DateTime.Now.ToString("yyyyMMdd"),        //거래일자(YYYYMMDD) 
                                                                             DateTime.Now.ToString("HHmmss"),          //거래시간(HHMMSS)
                                                                             "",                                       //승인번호	
                                                                             m_sReadingHPData
                                                                             },
                                                               ref saRecvdData);

                //if (sRet == UserCom.RST_OK &&
                //    sType == PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH &&
                //    (saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "50000" ||
                //     saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "00200" ||
                //     saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode] == "99993"))
                //{
                //    //WinManager.ErrorMessage("해피앱 고객등록 할 수 없습니다. 미발급 된 번호 입니다.");
                //    //WinManager.ErrorMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_1152));
                //    WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1152));
                //
                //    return false;
                //}
                //
                //if (sRet == UserCom.RST_OK)
                //{
                //    return true;
                //}
                //else
                //{
                //    return false;
                //}

                if (sRet == UserCom.RST_OK)
                {
                    if (saRecvdData != null && sType == PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH)
                    {
                        if (saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "50000" || //등록 가능한 카드 (즉 미발급된카드)
                            saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "00200" || //마스터 미등록된 카드
                            saRecvdData[Column.WELCOMECARD_SEARCH_RECV.SEQ.sReqCode].Trim() == "99993")
                        {
                            //WinManager.ErrorMessage("해피앱 고객등록 할 수 없습니다. 미발급 된 번호 입니다.");
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1152));
                            return false;
                        }
                    }

                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);

                return false;
            }
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 리딩한 카드번호가 해피포인트 고객인지 체크
        private bool HP_Availability_Check()
        {
            bool bRet = false;
            bool bHP_YN = false;

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return bRet;
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return bRet;

                m_sInHP_CustNumer = "";
                m_sInHP_WelcomeCard = "";
                m_sInWelcomeCard_Type = "";
                bHP_YN = m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_SEARCH,
                                                            new string[] { m_sInPutType, m_sInMaskData, m_sInEncData, "1", "", m_sInPutData },
                                                            ref m_sInHP_CustNumer,      // HP회원번호
                                                            ref m_sInHP_WelcomeCard);   // HP웰컴카드번호

                if (bHP_YN == true && (m_sInHP_CustNumer != "" && m_sInHP_WelcomeCard != ""))
                {
                    m_sInWelcomeCard_Type = "A";
                    bRet = true;
                }
                else
                {
                    if (bHP_YN == false)
                    {
                        //WinManager.ErrorMessage("해피포인트 회원이 아닙니다. 회원가입 후 진행 해주세요.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1154));
                    }

                    if (m_sInHP_CustNumer == "" || m_sInHP_WelcomeCard == "")
                    {
                        //WinManager.ErrorMessage("웰컴할인 받으실 수 없습니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1155));
                    }
                    bRet = false;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            ex.Message);

                return false;
            }
            return bRet;
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj

        //#20180413 웰컴카드 신규기능 추가 start,phj
        #region 해피앱 고객등록 시도
        private string WelcomeCard_ClientRegister()
        {
            string sRet = UserCom.RST_ERR;

            string sMsg = string.Empty;
            bool bClientRegister = false; // 고객의 '해피앱 고객등록' 동의여부 (true: 고객동의 false: 고객미동의)
            bool bAvailability = true; // 현재 해피고객의 '해피앱 고객등록' 가능여부 (true: 가능 false: 불가능) 

            try
            {
                //발급조회
                if (WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.ISSUE_SEARCH) == false) return sRet;

                // 메세지 
                sMsg = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1143); 
               
                // 해피앱 고객등록 동의여부 체크 
                if (WinManager.QuestionMessage(sMsg) == true)
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱등록 동의여부] 동의");

                    bClientRegister = true;

                    #region 해피포인트 데이터 검색 및 해피앱 고객등록 대상자인지 체크

                    m_sReadingHPData = "";

                    if (m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_REGISTER_DATA, new string[] { }, ref m_sInHP_CustNumer, ref m_sInHP_WelcomeCard) == true)
                    {
                        if (m_sInHP_WelcomeCard != "") { bAvailability = false; }
                        if (m_sInHP_CustNumer == "") { bAvailability = false; }
                        if (bAvailability != false)
                        {
                            m_sReadingHPData = PosConst.WELCOMECARD_MSG.HP_REGISTER_DATA;
                        }
                    }
                    else
                    {
                        //#20180413 웰컴카드 신규기능 추가 start, 20180621, 20180622
                        //기존
                        //WinPay.ShowForm(new string[] { FormManager.FORM_PAY_POINT_HAPPY_POINT, PosKey.MENU_KEY.HAPPY_POINT_SCH, "0", "2" });
                        //변경
                        string sRetShow = WinPay.ShowForm(new string[] { FormManager.FORM_PAY_POINT_HAPPY_POINT, PosKey.MENU_KEY.HAPPY_POINT_SCH, "0", "2" });
                        if (sRetShow != UserCom.RST_OK) return sRet;
                        //#20180413 웰컴카드 신규기능 추가 end, 20180621, 20180622

                        if (m_cWelcomeCard.ClientRegisterCheck(PosConst.WELCOMECARD_MSG.HP_SEARCH_DATA, new string[] { }, ref m_sInHP_CustNumer, ref m_sInHP_WelcomeCard) == true)
                        {
                            if (m_sInHP_WelcomeCard != "") { bAvailability = false; }
                            if (m_sInHP_CustNumer == "") { bAvailability = false; }
                            if (bAvailability != false)
                            {
                                m_sReadingHPData = PosConst.WELCOMECARD_MSG.HP_SEARCH_DATA;
                            }
                        }
                        else
                        {
                            //#20180413 웰컴카드 신규기능 추가 start, 20180621, 20180622
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1154));
                            //#20180413 웰컴카드 신규기능 추가 end, 20180621, 20180622
                            return sRet;
                        }
                    }

                    #endregion

                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱 고객등록 가능여부] HP웰컴카드번호 :" + m_sInHP_WelcomeCard + ", HP회원번호 :" + m_sInHP_CustNumer + ", INPUT카드번호 :" + m_sInPutData);

                    #region 해피에 등록된 웰컴카드 번호가 있으면 해피앱 고객등록 할 수 없다. 만약 등록하려던 웰컴카드 번호가 이미 해피에 연동된 번호일 때 발급취소를 진행하지 않는다.

                    // 해피포인트 조회 시 응답 전문에 웰컴카드번호가 있으면 해피앱 고객등록 안된다.
                    if (m_sInHP_WelcomeCard != "" && m_sInHP_WelcomeCard != m_sInPutData)
                    {
                        //WinManager.ErrorMessage("이미 고객등록 된 해피포인트 입니다. 해피앱 고객등록 할 수 없습니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1147));
                        return sRet;
                    }
                    else if (m_sInHP_WelcomeCard != "" && m_sInHP_WelcomeCard == m_sInPutData)
                    {
                        //WinManager.ErrorMessage("같은 번호로 이미 고객등록 된 해피포인트 입니다. ");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1148));
                        return sRet;
                    }

                    // 고객등록 기본 조건은 해피앱이고 회원번호가 존재해야 하며 웰컴카드 번호가 없어야 한다.
                    if (bAvailability == false)
                    {
                        //WinManager.ErrorMessage("해피앱 고객등록 대상자가 아닙니다.");
                        WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1149));
                        return sRet;
                    }

                    #endregion

                    #region 고객동의 받았고 해피앱 고객등록 가능자일 때

                    if (bClientRegister == true && bAvailability == true)
                    {
                        // HPC 고객등록 시도
                        if (WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.HPC_CLIENT_REGISTER) == true)
                        {
                            // POS SERVER 고객등록 시도
                            WelcomeCard_SetData(PosConst.WELCOMECARD_TYPE.POS_CLIENT_REGISTER);

                            //WinManager.ErrorMessage("HPC 고객등록 성공!");
                            //WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1150), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1133));
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1150));
                            sRet = UserCom.RST_OK;
                        }
                        else
                        {
                            //WinManager.ErrorMessage("HPC 고객등록 실패!");
                            //WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1151), MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1133));
                            WinManager.ErrorMessage(MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_1151));
                            sRet = UserCom.RST_ERR;
                        }
                    }

                    #endregion
                }
                else
                {
                    UserLog.WriteLogFile(UserCom.LOG_IOS,
                                         System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                         System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                         System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                         "[해피앱등록 동의여부] 미동의");

                    bClientRegister = false;
                    bAvailability = false;

                    sRet = UserCom.RST_ERR;
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +
                                            System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                            "WelcomeCardIssueClick Exception : " + ex.Message);
                return UserCom.RST_ERR;
            }
            return sRet;
        }
        #endregion
        //#20180413 웰컴카드 신규기능 추가 end,phj
    }
}
